﻿#include<iostream>
#include<vector>
#include<set>
#include<iomanip>
#include<map>
#include<algorithm>
#include<random>
#include <queue>
#include<cmath>
#include <string>
using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9 + 7;
const ll LINF = 1e18 + 7;
const int MOD = 998244353;

ll binpow(ll n, ll p)
{
    if (p == 0)
    {
        return 1;
    }
    else if (p % 2 == 0)
    {
        ll b = binpow(n, p / 2);
        return (b * b);
    }
    else
    {
        return (binpow(n, p - 1) * n);
    }
}

ll gcd(ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a % b);
}

int main()
{
    cout.precision(20);
    cin.tie(0)->sync_with_stdio(0);
    vector<pair<int, int>>kw = { {0,0},{2,2},{-1,2},{2,-1},{2,3} };
    int dx = -1, dy = 0;
    int n; cin >> n;
    for (int len = 4; len <= n; ++len) {
        auto c = kw.back();
        c.first += dx * (len - 1);
        c.second += dy * (len - 1);
        kw.push_back(c);
        int z = 0 - dy;
        dy = dx; dx = z;
        c.first += dx * (len);
        c.second += dy * (len);
        kw.push_back(c);
        z = 0 - dy;
        dy = dx; dx = z;
    }
    pair<int, int>d = { (n - 2) / 2,(n - 3) / 2 };
    for (auto& c : kw)c.first += d.first, c.second += d.second;
    for (auto c : kw)cout << c.first << " " << c.second << "\n";
}