#include <iostream>

using namespace std;

long long gcd(long long a, long long b) {
    if (a > b) swap(a, b);
    if (a == 0) return b;
    return gcd(b % a, a);
}

long long binpow(long long a, long long b) {
    if (b == 0) return 1;
    if (b % 2 == 1) return binpow(a, b - 1) * a;
    long long x = binpow(a, b / 2);
    return x * x;
}

int main()
{
    long long a = 0, b, x, y;
    int n;
    cin >> n;
    char c;
    b = binpow(10, n);
    for (int i = 0; i < n; ++i) {
        cin >> c;
        a *= 10;
        a += c - '0';
    }
    x = a / gcd(a, b);
    y = b / gcd(a, b);
    if (y < 1e6) {
        cout << "YES\n" << x << " " << y;
    }
    return 0;
}
