#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define int ll
const  double eps = 1e-6;

int sqr(int x) {
    int s = sqrt(x);
    while (s * s < x)
        s++;
    while (s * s > x)
        s--;
    return s;
}

void solve(){
    int c, h;
    cin >> c >> h;
    double ax = 1, bx = -c, cx = h * h;
    double D = bx * bx - 4 * ax * cx;
    if (D < 0) {
        cout << -1;
        return;
    }
    double a1 = (-bx + sqrt(D)) / 2 * ax;
    double b1 = (double)c - a1;
    if(a1 <= 0 || b1 <= 0){
        cout << -1;
        return;
    }
    double a = sqrt(a1 * a1 + h * h), b = sqrt(b1 * b1 + h * h);
    if(abs(a * a + b * b - c * c) > 1e-9){
        cout << -1;
        return;
    }
    cout << (double) h * c / 2 << endl;
}
     

void solve1() {
    int n;
    int coef;
    cin >> n >> coef;
    if (n > 6) {
        cout << "NO";
        return;
    }
    int mx = 1e6;
    int mn = 1;
    for (int i = 0; i < n; i++)
        mn *= 10;
    for (int a = 1; a < mx; a++) {
        if (a * mn % coef == 0) {
            int b = a * mn / coef;
            if (b >= 1 && b < mx) {
            cout << "YES\n" << a << " " << b;
            return;
            }
        }
    }
    cout << "NO";
}

signed main(){

    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);


    int t = 1;
    // cin >> t;

    while(t--)
        solve1();
}