#include<bits/stdc++.h>
using namespace std;
#define pb push_back
#define ll long long
#define ld long double
#define pii pair<int, int>
#define ff first
#define ss second
#define int ll

const int N = 1e5 + 1;

const ld EPS = 1e-7;

struct point{
    ld x, y;
};
int n;
point ans[N];

ld getlen(point a, point b){
    return sqrtl((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

vector<point> getinter(ld r, ld a, ld b, ld c){
    ld x0 = -a * c/(a * a + b * b), y0 = -b * c / (a * a + b * b);
    if (c*c > r*r*(a*a+b*b)+EPS)
        return {};
    else if (abs (c*c - r*r*(a*a+b*b)) < EPS) {
        return {{x0, y0}};
    }
    else {
        ld d = r*r - c*c/(a*a+b*b);
        ld mult = sqrt (d / (a*a+b*b));
        ld ax, ay, bx, by;
        ax = x0 + b * mult;
        bx = x0 - b * mult;
        ay = y0 - a * mult;
        by = y0 + a * mult;
        return {{ax, ay}, {bx, by}};
    }
}

vector<point> getinter(point c2, ld r1, ld r2){
    ld A = -2 * c2.x;
    ld B = -2 * c2.y;
    ld C = c2.x * c2.x + c2.y * c2.y + r1 * r1 - r2 * r2;
    return getinter(r1, A, B, C);
}

vector<point> getinter(point c1, ld r1, point c2, ld r2){
    c2.x -= c1.x;
    c2.y -= c1.y;
    vector<point> ret = getinter(c2, r1, r2);
    for(auto &e : ret)
        e.x += c1.x, e.y += c1.y;
    return ret;
}

void getans(point A, point B, vector<pair<int, int>> cur){
    if(cur.size() == 1){
        ans[cur[0].second] = {A.x - B.x, A.y - B.y};
        assert(abs(getlen(A, B) - cur[0].first) < EPS);
        return;
    }
    ld len = getlen(A, B);
    ld l = abs(len - (ld)cur[0].first), r = len + (ld)cur[0].first;
    ll sm = 0;
    ll mx = 0;
    for(int i = 1; i < cur.size(); i++)
        sm += cur[i].first, mx = max(mx, cur[i].first);
    //x <= mx
    vector<pair<int, int>> ncur = {};
    for(int i = 1; i < cur.size(); i++)
        ncur.push_back(cur[i]);
    ld nlen;
    if(mx >= l && mx <= r){
        nlen = mx;
    }else if(mx < l){
        nlen = l;
    }else{
        nlen = r;
    }
    vector<point> v = getinter(A, nlen, B, cur[0].first);
    ans[cur[0].second] = {v[0].x - B.x, v[0].y - B.y};
    getans(A, v[0], ncur);
}

void solve(){
    point A, B;
    cin >> A.x >> A.y;
    cin >> B.x >> B.y;
    cin >> n;
    ld sm = getlen(A, B);
    vector<pair<int, int>> len;
    for(int i = 1; i <= n; i++){
        int a;
        cin >> a;
        sm += a;
        len.push_back({a, i});
    }
    for(int i = 1; i <= n; i++){
        if(sm - len[i - 1].first < len[i - 1].first){
            cout << "IMPOSSIBLE\n";
            return;
        }
    }
    if(sm < 2 * getlen(A, B)){
        cout << "IMPOSSIBLE\n";
        return;
    }
    cout << "POSSIBLE\n";
    getans(B, A, len);
    for(int i = 1; i <= n; i++){
        cout << fixed << setprecision(15) << ans[i].x << ' ' << ans[i].y << '\n';
    }
}

signed main(){
    int t = 1;
    //cin>>t;
    while(t--) solve();
}