#include <iostream>
#include <algorithm>
using namespace std;

int main() {
    long long n, m, s;
    cin >> n >> m >> s;

  
    if (s == n * m) {
        cout << 0 << endl;
        return 0;
    }

    int min_cuts = INT_MAX;

  
    for (long long x = 0; x <= n - 1; x++) {
        
        long long vertical_parts = x + 1;


        if (s % vertical_parts == 0) {
            long long height_needed = s / vertical_parts;

            
            if (height_needed <= m) {
                
                long long y = height_needed - 1;
                min_cuts = min(min_cuts, (int)(x + y));
            }
        }

        
        long long height_needed = (s + vertical_parts - 1) / vertical_parts; 
        if (height_needed <= m) {
            long long y = height_needed - 1;
            min_cuts = min(min_cuts, (int)(x + y));
        }
    }

    cout << min_cuts << endl;
    return 0;
}

