def is_non_periodic(b):
    """Проверяем, содержит ли число b простые множители, отличные от 2 и 5."""
    while b % 2 == 0:
        b //= 2
    while b % 5 == 0:
        b //= 5
    return b > 1  

def solve(n, digits):
    
    value = int(digits) / (10 ** n)
    for b in range(1, 10**6):  
        if is_non_periodic(b):  
            a = round(value * b)  
            if 0 < a < b and abs(a / b - value) < 1e-9:
                return "YES", a, b
    return "NO"

n = int(input())
digits = input()
result = solve(n, digits)
if result == "NO":
    print(result)
else:
    print(result[0])
    print(result[1], result[2])
