from collections import defaultdict
def solve():
    n,q = map(int,input().split())
    edges_by_color = defaultdict(set)  
    vertex_degree = defaultdict(lambda: defaultdict(int))  
    total_beauty =0  
    for _ in range(q):
        query = input().split()
        operation = query[0]
        v = int(query[1])
        u = int(query[2])
        c = int(query[3])
        if operation == '+':
            if (v,u) not in edges_by_color[c] and (u, v) not in edges_by_color[c]:
                edges_by_color[c].add((v, u))
                vertex_degree[c][v] += 1
                vertex_degree[c][u] += 1
                if vertex_degree[c][v] == 1 and vertex_degree[c][u] == 1:
                    total_beauty += 1
        elif operation == '-':
            if (v,u) in edges_by_color[c]:
                edges_by_color[c].remove((v, u))
                vertex_degree[c][v] -= 1
                vertex_degree[c][u] -= 1
                if vertex_degree[c][v] == 1 and vertex_degree[c][u] == 1:
                    total_beauty +=1
                if vertex_degree[c][v] > 1 or vertex_degree[c][u] > 1:
                    total_beauty -= 1
                    print(total_beauty)

