#include <iostream>
#include <string>
#include <cmath>

using namespace std;

bool check_fraction(int a, int b, const string& expected) {
    string result = "";
    int remainder = a % b;

    for (int i = 0; i < expected.size(); ++i) {
        remainder *= 10;
        int digit = remainder / b;
        remainder %= b;

        result += to_string(digit);
    }

    return result == expected;
}

int main() {
    int n;
    string decimal_part;

    cin >> n;
    cin >> decimal_part;
    for (int b = 1; b < 1000000; ++b) {
        for (int a = 1; a < b; ++a) {
            if (check_fraction(a, b, decimal_part)) {
                cout << "YES" << endl;
                cout << a << " " << b << endl;
                return 0;
            }
        }
    }

    cout << "NO" << endl;
    return 0;
}
