import math

def lined(x1, y1, x2, y2, x3, y3):
    A = y2 - y1
    B = x1 - x2
    C = x2 * y1 - x1 * y2
    return abs(A * x3 + B * y3 + C) / math.sqrt(A**2 + B**2)

def dist(x1, y1, x2, y2):
    return math.sqrt((x2 - x1)**2 + (y2 - y1)**2)

x1, y1, x2, y2, x3, y3 = map(int, input().split())


dist3 = lined(x1, y1, x2, y2, x3, y3) #x3 y3
dist2 = lined(x1, y1, x3, y3, x2, y2) #x2 y2
dist1 = lined(x2, y2, x3, y3, x1, y1) #x1 y1

minn = min(dist1, dist2, dist3)
if dist1 == minn:
    print(x2, y2, x3, y3)
elif dist2 == minn: 
    print(x1, y1, x3, y3)
else:               
    print(x1, y1, x2, y2)
#print(dist1, dist2, dist3)
