#include <iostream>
#include <vector>
#include <algorithm> 


using namespace std;



int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);


    for (int i = 0; i < n; ++i) cin >> a[i];
    
    for (int i = 0; i < n; ++i) cin >> b[i];


    vector<int> top(a), bottom(b);
    vector<bool> flipped(n, false); 

    for (int i = 0; i < n; ++i) {
        if (i > 0) {
         
            if (top[i] < top[i - 1]) {
                if (bottom[i] >= top[i - 1]) {
                    flipped[i] = true;
                    swap(top[i], bottom[i]); 
                } else {
                    cout << -1 << endl;
                    return 0;
                }
            }

            if (bottom[i] < bottom[i - 1]) {
                if (top[i] >= bottom[i - 1] && !flipped[i]) {
                    flipped[i] = true;
                    swap(top[i], bottom[i]); 
                } else if (bottom[i] < bottom[i - 1]) {
                    cout << -1 << endl;
                    return 0;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << top[i] << " ";
    }
    cout << endl;
    for (int i = 0; i < n; ++i) {
        cout << bottom[i] << " ";
    }
    cout << endl;

    return 0;
}
