#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<string>
#include<stack>
#include<queue>
#include<deque>
#include<cmath>
#include<algorithm>
#include<ctime>
#include<random>
#include<iomanip>
#include<fstream>
#include<bitset>
#include<unordered_map>
#include<unordered_set>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

ll gcd(ll a, ll b) {
    return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
ll bpow(ll a, ll n) {
    return n == 0 ? 1 : n % 2 == 0 ? bpow(a * a, n / 2) : bpow(a, n - 1) * a;
}
mt19937 mt(time(0));
const int N = 5e5 + 2, mod = 1e9 + 7, mod2 = 998244353, P = 257, inf = 1e9 + 100;
const ll llinf = 1e18 + 1000;
const ld eps = 1e-9;

void solve() {
    ll n, m, s;
    cin >> n >> m >> s;
    if (s == n * m) {
        cout << 0;
        return;
    }
    if (s % n == 0 || s % m == 0) {
        cout << 1;
        return;
    }
    for (ll d = 1; d * d <= s; ++d) {
        if (s % d == 0) {
            if ((d < n && s / d < m) || (s / d < n && d < m)) {
                cout << 2;
                return;
            }
        }
    }
    s = n * m - s;
    for (ll d = 1; d * d <= s; ++d) {
        if (s % d == 0) {
            if ((d < n && s / d < m) || (s / d < n && d < m)) {
                cout << 2;
                return;
            }
        }
    }
    cout << 3;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}