//order_of_key(k): Number of items strictly smaller than k .
//find_by_order(k): K-th element in a set (counting from zero).

//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define file(s) if(fopen(s".in","r")) freopen(s".in","r",stdin);freopen(s".out","w",stdout)
#define all(x) (x).begin(), (x).end()
#define len(x) (int)x.size()
#define tm (tl + tr >> 1)
#define ls v << 1, tl, tm
#define rs v << 1 | 1, tm + 1, tr
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define elif else if
#define F first
#define S second
#define int long long

using namespace std;
using namespace __gnu_pbds;

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;
typedef unsigned long long ull;
typedef long long ll;
typedef double db;
typedef long double ld;

const int MOD = 1e9 + 7;
const int N = 2e5 + 7;
const int P = 911;
const ll INF = 1e18;

struct custom_hash {
    static uint64_t splitmix64(uint64_t x) {
        // http://xorshift.di.unimi.it/splitmix64.c
        x += 0x9e3779b97f4a7c15;
        x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
        x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
        return x ^ (x >> 31);
    }

    size_t operator()(uint64_t x) const {
        static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
        return splitmix64(x + FIXED_RANDOM);
    }
};

int rnd() {
	int x = rand() << 15;
	return x ^ rand();
}

bool is[10][10];

void solve() {
	int gk, gmask, gal = 0;
	for (int k = 0; k <= 7; k++) {
		for (int mask = 0; mask < 4; mask++) {
			int x = k, y = k;
			if (mask & 1) x = -k;
			if (mask >> 1 & 1) y = -k;
			int tr = 0, fl = 0;
			for (int i = 1; i <= 8; i++) {
				for (int j = 1; j <= 8; j++) {
					if (!is[i][j]) continue;
					if (1 <= i + x <= 8 && 1 <= j + y <= 8) tr++;
					else fl++;
				}
			}
			tr = min(tr, fl);
			if (tr > gal) {
				gk = k;
				gmask = mask;
			}
		}
	}
	int k = gk, mask = gmask;
	int x = k, y = k;
	if (mask & 1) x = -k;
	if (mask >> 1 & 1) y = -k;
	cout << "? " << x << ' ' << y << endl;
	char ans;
	cin >> ans;
	bool ok = (ans == '+');
	for (int i = 1; i <= 8; i++) {
		for (int j = 1; j <= 8; j++) {
			if (!is[i][j]) continue;
			if (1 <= i + x <= 8 && 1 <= j + y <= 8) {
				if (!ok) is[i][j] = 0;
			} else {
				if (ok) is[i][j] = 0;
			}
		}
	}
}

void GazizMadi() {
	for (int i = 1; i <= 8; i++) {
		for (int j = 1; j <= 8; j++) {
			is[i][j] = 1;
		}
	}
	int q = 7;
	while (q--) solve();
	for (int i = 1; i <= 8; i++) {
		for (int j = 1; j <= 8; j++) {
			if (is[i][j]) {
				string a = "*abcdefgh", b = "*87654321"; 
				cout << "! " << a[i] << ' ' << b[j] << endl;
				return;
			}
		}
	}
}

const bool Cases = 0;

signed main() {
//	ios_base::sync_with_stdio(false);
//	cin.tie(nullptr);
	srand(time(0));
	int TT = 1;
	if (Cases) cin >> TT;
	for (int i = 1; i <= TT; i++) {
		//cout << "Case " << i << ": ";
		GazizMadi();
	}
}
