Python 3.7.4 (tags/v3.7.4:e09359112e, Jul  8 2019, 20:34:20) [MSC v.1916 64 bit (AMD64)] on win32
Type "help", "copyright", "credits" or "license()" for more information.
>>> def solve():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    idx = 0
    t = int(data[idx])
    idx += 1
    results = []
    
    for _ in range(t):
        n, m, k = map(int, data[idx:idx + 3])
        idx += 3
        p = list(map(int, data[idx:idx + n]))
        idx += n
        a = list(map(int, data[idx:idx + m]))
        idx += m
        
        intervals = []
        for _ in range(k):
            l, r = map(int, data[idx:idx + 2])
            idx += 2
            intervals.append((l - 1, r - 1))
        
        # Проверка, можно ли собрать p из подотрезков
        def can_form_permutation(selected):
            combined = []
            for i in selected:
                combined.extend(a[intervals[i][0]:intervals[i][1] + 1])
            
            # Два указателя для проверки наличия подотрезка
            j = 0
            for rune in combined:
                if j < n and rune == p[j]:
                    j += 1
                if j == n:
                    return True
            return False
        
        # Минимизируем количество учеников
        from itertools import combinations
        
        answer = -1
        order = []
        
        for c in range(1, k + 1):
            for comb in combinations(range(k), c):
                if can_form_permutation(comb):
                    answer = c
                    order = comb
                    break
            if answer != -1:
                break
        
        if answer == -1:
            results.append("-1")
        else:
            results.append(f"{answer}")
            results.append(" ".join(str(x + 1) for x in order))
    
    sys.stdout.write("\n".join(results) + "\n")

