def solve(x1, y1, x2, y2, x3, y3):
    # Параметры прямой, проходящей через точки (x1, y1) и (x2, y2)
    # Уравнение прямой: (y - y1) = m * (x - x1)
    # m = (y2 - y1) / (x2 - x1)

    # Если x1 == x2, то это вертикальная прямая
    if x1 == x2:
        print(f"{x1} {y1} {x2} {y2}")
    else:
        # Угловой коэффициент m для прямой, проходящей через (x1, y1) и (x2, y2)
        m = (y2 - y1) / (x2 - x1)
        # Уравнение прямой y = mx + b, находим b
        b = y1 - m * x1

        # Для получения двух точек на прямой, просто подставим разные значения x
        # Например, x = 0 и x = 1
        x1_new = 0
        y1_new = m * x1_new + b

        x2_new = 1
        y2_new = m * x2_new + b

        print(f"{x1_new} {y1_new} {x2_new} {y2_new}")

# Чтение данных
x1, y1, x2, y2, x3, y3 = map(int, input().split())

# Вызываем функцию для решения задачи
solve(x1, y1, x2, y2, x3, y3)
