from collections import defaultdict

n, q = map(int, input().split())

verticies = [defaultdict(int) for _ in range(n)]
edges = defaultdict(set)
colors = set()
answers = []

for _ in range(q):
    operation, a, b, c = input().split()
    a, b = int(a) - 1, int(b) - 1
    color = int(c)
    edge = tuple(sorted((a, b)))
    colors.add(color)

    if operation == '+':
        verticies[a][color] += 1
        verticies[b][color] += 1
        edges[edge].add(color)
    else:
        verticies[a][color] -= 1
        verticies[b][color] -= 1
        edges[edge].remove(color)
        if verticies[a][color] == 0:
            del verticies[a][color]
        if verticies[b][color] == 0:
            del verticies[b][color]

    beauty = 0
    for color in colors:
        perfect = True
        for vertex in verticies:
            if vertex[color] > 1:
                perfect = False
                break

        if perfect:
            for edge_colors in edges.values():
                if color in edge_colors:
                    beauty += 1

    answers.append(beauty)

for ans in answers:
    print(ans)
