#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<long long>(x.size())

using ll = long long;

bool ask(int dx, int dy) {
    cout << "! " << dx << ' ' << dy << endl;
    char c; cin >> c;
    return (c == '+');
}

bool okay(int x, int y) {
    return (0 <= x && x < 8 && 0 <= y && y < 8);
}

void solve() {
    vector<bool> ans;
    for (int d : {4, 2, 1}) {
        ans.push_back(ask(-d, -d));
    }
    for (int d : {4, 2, 1}) {
        ans.push_back(ask(d, d));
    }
    ans.push_back(ask(1, -1));
    for (int sx = 0; sx < 8; sx++) {
        for (int sy = 0; sy < 8; sy++) {
            int cur_x = sx, cur_y = sy;
            int i = 0;
            bool flag = true;
            for (int d : {4, 2, 1}) {
                if (okay(cur_x - d, cur_y - d) != ans[i++]) {
                    flag = false;
                    break;
                }
                else if (okay(cur_x - d, cur_y - d)) {
                    cur_x -= d;
                    cur_y -= d;
                }
            }
            for (int d : {4, 2, 1}) {
                if (okay(cur_x + d, cur_y + d) != ans[i++]) {
                    flag = false;
                    break;
                }
                else if (okay(cur_x + d, cur_y + d)) {
                    cur_x += d;
                    cur_y += d;
                }
            }
            if (okay(cur_x + 1, cur_y - 1) != ans[i++]) {
                flag = false;
            }
            if (flag) {
                cout << "! " << static_cast<char>('a' + sx) << sy + 1 << endl;
                return;
            }
        }
    }
}

int main() {
    //cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
