#include <iostream>
#include <cmath>
using namespace std;

double triangle_area(int c, int h) {
    if (h >= c) return -1;
    double discriminant = c * c - 4.0 * h * h;
    if (discriminant < 0) return -1;
    double p = (c + sqrt(discriminant)) / 2.0;
    double q = c - p;
    if (p > 0 && q > 0 && abs(p + q - c) < 1e-9) return c * h / 2.0;
    return -1;
}

int main() {
    int c, h;
    cin >> c >> h;
    cout << triangle_area(c, h);
    return 0;
}