def solve_timeline(n, a, b):
    dp = [(a[0], b[0]), (b[0], a[0])]

    for i in range(1, n):
        new_dp = []
        for x, y in dp:
            if a[i] >= x:
                new_dp.append((a[i], b[i]))
            if b[i] >= x:
                new_dp.append((b[i], a[i]))
        if not new_dp:
            return -1
        dp = new_dp

    return dp[0]

n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))
result = solve_timeline(n, a, b)

if result == -1:
    print(-1)
else:
    top, bottom = zip(*[result])
    print(" ".join(map(str, top)))
    print(" ".join(map(str, bottom)))