def solve():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    n = int(data[0])  # Количество знаков после запятой
    digits = data[1]  # Десятичная часть
    
    # Преобразуем десятичную часть в дробное число
    fractional_part = int(digits)  # Число без точки
    denominator = 10 ** n  # Основание (10^n)
    
    # Перебираем возможные значения b (1 <= b < 10^6)
    for b in range(1, 10**6):
        a = fractional_part * b // denominator
        if fractional_part * b % denominator == 0 and 0 < a < b:
            print("YES")
            print(a, b)
            return
    
    # Если подходящих a и b не найдено
    print("NO")

