def bp(l, r, val, n, m):
    while r - l > 1:
        mid = (l + r) // 2
        if n * mid <= val:
            l = mid
        else:
            r = mid
    return l

def rec(n, m, s, memo):
    if s <= 0:
        return 0
    if (n, m, s) in memo:
        return memo[(n, m, s)]
    if n > m:
        n, m = m, n
    right = bp(0, int(1e6), s, n, m)
    result = rec(n, m - right, s - n * right, memo) + 1
    memo[(n, m, s)] = result
    return result

def main():
    n, m, s = map(int, input().split())
    if n * m == s:
        print(0)
        return
    if s % n == 0 or s % m == 0:
        print(1)
        return
    memo = {}
    print(rec(n, m, s, memo))

main()
