def bp(l, r, val, n, m):
    while r - l > 1:
        mid = (l + r) // 2
        if n * mid <= val:
            l = mid
        else:
            r = mid
    return l

def solve(n, m, s):
    if n * m == s:
        return 0
    if s % n == 0 or s % m == 0:
        return 1
    result = float('inf')
    for i in range(1, int(1e6)):
        if n * i > s:
            break
        remaining_s = s - n * i
        cuts = i - 1
        cuts += bp(0, int(1e6), remaining_s, m, m) - 1
        result = min(result, cuts)
    return result

def main():
    n, m, s = map(int, input().split())
    print(solve(n, m, s))

main()

