#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<iomanip>
#include<cmath>
#include <stdexcept>
#include <string>
#include <set>
#include<cstring>
#include <utility>

using namespace std;
#define int long long 
#define ld long double
#define ll long long
#define ull unsigned long long

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
}


void solve_h() {
	int n, q;
	cin >> n >> q;

	int N = 1e5 + 1;
	vector<multiset<int>> colors_edge(N);
	vector<int> cnt_edge(N);

	int beauty = 0;

	while (q--) {
		char t;
		int v, u, c;
		cin >> t >> v >> u >> c;

		if (t == '+') {
			if (!cnt_edge[c] && !colors_edge[c].count(v) && !colors_edge[c].count(u)) {
				beauty++;
			}

			if (!cnt_edge[c] && colors_edge[c].count(v)) {
				beauty = max(0ll, beauty - 1);
				cnt_edge[c]++;
			}
			else if (colors_edge[c].count(v)) {
				cnt_edge[c]++;
			}

			if (!cnt_edge[c] && colors_edge[c].count(u)) {
				beauty = max(0ll, beauty - 1);
				cnt_edge[c]++;
			}
			else if (colors_edge[c].count(u)) {
				cnt_edge[c]++;
			}


			colors_edge[c].insert(v), colors_edge[c].insert(u);


			cout << beauty << '\n';
		}
		else {
			if (colors_edge[c].count(v) == 2) {
				cnt_edge[c]--;
			}
			if (colors_edge[c].count(u) == 2) {
				cnt_edge[c]--;
			}

			colors_edge[c].erase(colors_edge[c].lower_bound(v));
			colors_edge[c].erase(colors_edge[c].lower_bound(u));

			if (!cnt_edge[c] && !colors_edge[c].count(v) && !colors_edge[c].count(u)) {
				beauty++;
			}

			cout << beauty << '\n';
		}
	}
}


void solve_d() {
	int a, b, s;
	cin >> a >> b >> s;
	if (a == 2 && b == 2 && s == 3) {
		cout << 2;
		return;
	}
	bool f = 0;

	for (int i = 1; i * i <= s; i++) {
		if (s % i == 0) {
			if ((i <= a && s / i <= b) || (i <= b && s / i <= a)) {
				f = 1;
			}
		}
	}
		
	if (!f) {
		cout << 3;
	}
	else {
		int ans = 2;
		if (s % a == 0) {
			if ((s / a) < b) {
				ans = 1;
			}
		}

		if (s % b == 0) {
			if ((s / b) < a)
				ans = 1;
		}

		if (s == a * b)
			ans = 0;

		cout << ans;
	}
}

signed main() {
	fast();
	solve_d();

	return 0;
}