#include <iostream>
#include <iomanip>
#include <cmath>
#include <numeric>

using namespace std;

double d(double x0, double y0, double A, double B, double C)
{
    return abs(A * x0 + B * y0 + C) / sqrt(A * A + B * B);
}

int main()
{
    long long x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    if ( (x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2)) == 0)
    {
        cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
        return 0;
    }

    long long A1 = y2 - y1, B1 = x1 - x2, C1 = x2 * y1 - x1 * y2;
    long long d1 = d(x3, y3, A1, B1, C1);

    long long A2 = y3 - y2, B2 = x2 - x3, C2 = x3 * y2 - x2 * y3;
    long long d2 = d(x1, y1, A2, B2, C2);

    long long A3 = y3 - y1, B3 = x1 - x3, C3 = x3 * y1 - x1 * y3;
    long long d3 = d(x2, y2, A3, B3, C3);

    if (d1 <= d2 && d1 <= d3)
        cout  << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
    else if (d2 <= d1 && d2 <= d3)
        cout  << x2 << " " << y2 << " " << x3 << " " << y3 << endl;
    else
        cout  << x1 << " " << y1 << " " << x3 << " " << y3 << endl;

    return 0;
}
