#include <iostream>
#include <cstddef>
#include <iomanip>
#include <vector>

int main() {
    std::size_t n;
    int m, c;
    std::cin >> n >> m >> c;
    
    std::vector<double> x(n + 2);
    std::vector<int> t(n + 2);

    for (std::size_t i = 1; i < n + 1; ++i) {
        std::cin >> x[i] >> t[i];
    } x[n + 1] = m;

    std::vector<double> answer(n + 2, std::numeric_limits<double>::max());
    answer[0] = 0;
    for (std::size_t i = 0; i < n + 2; ++i) {
        for (std::size_t j = i + 1; j < n + 2; ++j) {
            answer[j] = std::min(answer[j], answer[i] + (x[j] - x[i]) * (x[j] - x[i]) / c + t[j]);
        }
    }

    std::cout << std::fixed << std::setprecision(6) << answer[n + 1];

    return 0;
}
