#include <unordered_map>
#include <iostream>
#include <cstddef>
#include <cstdint>
#include <vector>

int main() {
    std::size_t n;
    std::int32_t q;
    std::cin >> n >> q;

    std::vector<std::unordered_map<std::int32_t, std::uint32_t>> colorCount(n);
    std::unordered_map<std::int32_t, std::uint32_t> unperfectCount;
    std::unordered_map<std::int32_t, std::uint32_t> colorUsedCount;
    std::uint32_t answer = 0;
    while (q--) {
        char op;
        std::int32_t v, u, c;
        std::cin >> op >> v >> u >> c;
        --v;
        --u;

        if (op == '-') {
            --colorCount[v][c];
            --colorCount[u][c];
            --colorUsedCount[c];
            if (colorCount[v][c] == 1 || colorCount[u][c] == 1) {
                unperfectCount[c] -= 1 + (colorCount[v][c] == colorCount[u][c]);
                if (unperfectCount[c] == 0) {
                    answer += colorUsedCount[c];
                }
            } else if (unperfectCount[c] == 0) {
                --answer;
            }
        } else {
            ++colorCount[v][c];
            ++colorCount[u][c];
            ++colorUsedCount[c];
            if (colorCount[v][c] != 1 || colorCount[u][c] != 1) {
                bool flag = false;
                if (unperfectCount[c] == 0) {
                    flag = true;
                }
                unperfectCount[c] += 1 + (colorCount[v][c] != 1 && colorCount[u][c] != 1);
                if (unperfectCount[c] != 0 && flag) {
                    answer -= colorUsedCount[c] - 1;
                }
            } else if (unperfectCount[c] == 0) {
                ++answer;
            }
        }

        std::cout << answer << std::endl;
    }

    return 0;
}
