def min_cuts(n, m, s):
    if s > n * m:
        return -1

    min_cuts = float('inf')

    # Перебираем количество вертикальных разрезов
    for x in range(n + 1):
       
        for y in range(m + 1):
            
            rows = [n // (x + 1)] * (x + 1)
            for i in range(n % (x + 1)):
                rows[i] += 1

            cols = [m // (y + 1)] * (y + 1)
            for i in range(m % (y + 1)):
                cols[i] += 1

            
            areas = []
            for row in rows:
                for col in cols:
                    areas.append(row * col)

            
            areas.sort(reverse=True)
            total = 0
            cuts = 0
            for area in areas:
                if total + area <= s:
                    total += area
                    cuts += 1
                if total == s:
                    break

            if total == s:
                min_cuts = min(min_cuts, x + y)

    return min_cuts if min_cuts != float('inf') else -1



n, m, s = map(int, input().split())
result = min_cuts(n, m, s)
print(result)
