import sys
import math

sys.setrecursionlimit(1 << 25)
input = sys.stdin.readline
n, m, s = map(int, sys.stdin.readline().split())
if s == n * m:
    print(0)
else:

    min_cuts = n + m - 2
    max_side = int(math.isqrt(s)) + 1

    for a in range(1, min(n, max_side) + 1):
        if s % a == 0:
            b = s // a
            if b <= m:
                cuts_needed = (a < n) + (b < m)
                if cuts_needed < min_cuts:
                    min_cuts = cuts_needed
    for b in range(1, min(m, max_side) + 1):
        if s % b == 0:
            a = s // b
            if a <= n:
                cuts_needed = (a < n) + (b < m)
                if cuts_needed < min_cuts:
                    min_cuts = cuts_needed
    print(min_cuts)