#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp> 
#include <ext/pb_ds/tree_policy.hpp> 
 
using namespace std;
using namespace __gnu_pbds; 
 
#define int long long
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ff first
#define ss second
#define pb push_back
#define ordered_set tree<int, null_type,less<int>, rb_tree_tag,tree_order_statistics_node_update> 
#define ordered_multiset tree<int, null_type,less_equal<int>, rb_tree_tag,tree_order_statistics_node_update>
 
template<class T, class U> inline bool chmin(T& a, const U& b) { if (a > b) { a = b; return true; } return false; }
template<class T, class U> inline bool chmax(T& a, const U& b) { if (a < b) { a = b; return true; } return false; }
 
int N = 2e5 + 5;
const int INF = 1e18;
const int mod = 1e9 + 7;

void add(int &a, int b) {
    if (a + b >= mod) a = (a + b) - mod;
    else a += b;
}
 
void sub(int &a, int b) {
    if (a - b < 0) a = (a - b) + mod;
    else a -= b;;
}

void solve(){
	int n, q;
	cin >> n >> q;
	vector<multiset<int>> g(n + 1);
	int ans = 0;
	vector<set<int>> st(n + 1);
	vector<int> sz(n + 1);
	for(int i = 0;i < q;i++) {
		char type;
		cin >> type;
		if(type == '-') {
			int u, v, c;
			cin >> u >> v >> c;
			sz[c]--;
			sz[c]--;
			g[u].erase(g[u].find(c));
			g[v].erase(g[v].find(c));
			if(g[u].count(c) < 2 && st[c].find(u) != st[c].end()) {
				st[c].erase(u);
				if(st[c].empty()) {
					ans += sz[c];
				}
			}
			if(g[v].count(c) < 2 && st[c].find(v) != st[c].end()) {
				st[c].erase(v);
				if(st[c].empty()) {
					ans += sz[c];
				}
			}
		} else {
			int u, v, c;
			cin >> u >> v >> c;
			g[u].insert(c);
			g[v].insert(c);
			sz[c]++;
			sz[c]++;
			if(st[c].empty()) ans += 2;
			if(g[u].count(c) >= 2 && st[c].find(u) == st[c].end()) {
				if(st[c].empty()) {
					ans -= sz[c];
				}
				st[c].insert(u);
			}
			if(g[v].count(c) >= 2 && st[c].find(v) == st[c].end()) {
				if(st[c].empty()) {
					ans -= sz[c];
				}
				st[c].insert(v);
			}
		}
		cout << ans / 2 << "\n";
	}
	
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);cout.tie(nullptr);
	
	int t = 1;
	//cin >> t;
	while(t--){
		solve();
	}
}

