#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp> 
#include <ext/pb_ds/tree_policy.hpp> 
   
using namespace std;
using namespace __gnu_pbds; 
   
#define int long long
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ff first
#define ss second
#define pb push_back
#define ordered_set tree<int, null_type,less<int>, rb_tree_tag,tree_order_statistics_node_update> 
#define ordered_multiset tree<int, null_type,less_equal<int>, rb_tree_tag,tree_order_statistics_node_update>
   
template<class T, class U> inline bool chmin(T& a, const U& b) { if (a > b) { a = b; return true; } return false; }
template<class T, class U> inline bool chmax(T& a, const U& b) { if (a < b) { a = b; return true; } return false; }
   
int N = 2e5 + 5;
const int INF = 1e18;
const int mod = 1e9 + 7;
  
void add(int &a, int b) {
    if (a + b >= mod) a = (a + b) - mod;
    else a += b;
}
   
void sub(int &a, int b) {
    if (a - b < 0) a = (a - b) + mod;
    else a -= b;;
}
  
void solve(){
    
    auto ask = [&](int a, int b) {
		cout << "? " << a << " " << b << endl;
		char c;
		cin >> c;
		return c;
	};
	int l = 1, r = 7, ans = 0;
	int sum = 0;
	while(l <= r) {
		int mid = (l + r) >> 1;
		int tar = mid - sum;
		char c = ask(-tar, tar);
		if(c == '+') {
			l = mid + 1;
			sum += tar;
			ans = mid;
		} else {
			r = mid - 1;
		}
	}
	int fst = ans;
	l = 1, r = 7, ans = 0;
	sum = 0;
	while(l <= r) {
		int mid = (l + r) >> 1;
		int tar = mid - sum;
		char c = ask(tar, -tar);
		if(c == '+') {
			l = mid + 1;
			sum += tar;
			ans = mid;
		} else {
			r = mid - 1;
		}
	}
	int scn = ans;
	char c = ask(1, 1);
	if(c == '-') {
		cout << "! " << (char)('a' + 7 - (scn - fst)) << 8 - fst << endl;
	} else {
		cout << "! " << (char)(fst + 'a') << 7 - (scn - fst) << endl;
	}
	
	
    
}
  
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);cout.tie(nullptr);
      
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}
