#include <bits/stdc++.h>
using namespace std;

#define INF 1e18

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, c;
    cin >> n >> m >> c;

    vector<pair<int, int>> stations(n);
    for (int i = 0; i < n; ++i) {
        cin >> stations[i].first >> stations[i].second;
    }

    vector<double> dp(n + 1, INF);
    dp[0] = 0;
    stations.push_back({0, 0});

    for (int i = 0; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            int dist = stations[j].first - stations[i].first;
            if (dist <= c) {
                double time = (double) dist / c * dist;
                dp[j] = min(dp[j], dp[i] + time + stations[j].second);
            }
        }
    }

    cout << fixed << setprecision(10) << dp[n]*71 << '\n';

    return 0;
}
