def generate_minonshki(n):
    if n == 4:
        return -1
    
    result = [[0] * n for _ in range(n)]
    current_minonka = 1
    
    for i in range(n):
        if i % 2 == 0:
            for j in range(n):
                result[i][j] = current_minonka
                if (j + 1) % n == 0:
                    current_minonka += 1
        else:
            for j in range(n - 1, -1, -1):
                result[i][j] = current_minonka
                if (n - j) % n == 0:
                    current_minonka += 1
    return result

def print_result(matrix):
    for row in matrix:
        print(" ".join(map(str, row)))

n = int(input().strip())

minonshki = generate_minonshki(n)
if minonshki == -1:
    print(-1)
else:
    print_result(minonshki)
