#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;

    unordered_map<int, int> ec;
    unordered_map<int, vector<int>> vd;

    long long beauty = 0;

    for (int i = 0; i < q; ++i) {
        char op;
        int v, u, c;
        cin >> op >> v >> u >> c;

        if (op == '+') {
            ec[c]++;
            vd[c].resize(n + 1, 0);
            vd[c][v]++;
            vd[c][u]++;
        } else if (op == '-') {
            ec[c]--;
            vd[c][v]--;
            vd[c][u]--;
        }

        beauty = 0;
        for (auto& e : ec) {
            int col = e.first;
            int cnt = e.second;
            bool excellent = true;
            for (int j = 1; j <= n; ++j) {
                if (vd[col][j] > 1) {
                    excellent = false;
                    break;
                }
            }
            if (excellent) {
                beauty += cnt;
            }
        }

        cout << beauty << endl;
    }

    return 0;
}

