#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;

    unordered_map<int, int> ec;
    unordered_map<int, unordered_map<int, int>> cnt;
    unordered_map<int, bool> ex;

    long long beauty = 0;

    for (int i = 0; i < q; ++i) {
        char op;
        int v, u, c;
        cin >> op >> v >> u >> c;

        if (op == '+') {
            ec[c]++;
            cnt[c][v]++;
            cnt[c][u]++;

            if (cnt[c][v] == 2 or cnt[c][u] == 2) {
                ex[c] = false;
            } else {
                ex[c] = true;
                for (auto& [p, colCnt] : cnt[c]) {
                    if (colCnt > 1) {
                        ex[c] = false;
                        break;
                    }
                }
            }
        } else if (op == '-') {
            ec[c]--;
            cnt[c][v]--;
            cnt[c][u]--;

            if (cnt[c][v] == 1 or cnt[c][u] == 1) {
                ex[c] = true;
                for (auto& [p, colCnt] : cnt[c]) {
                    if (colCnt > 1) {
                        ex[c] = false;
                        break;
                    }
                }
            }
        }

        beauty = 0;
        for (const auto& e : ec) {
            int col = e.first;
            if (ex[col]) {
                beauty += e.second;
            }
        }

        cout << beauty << endl;
    }

    return 0;
}
