class Bishop:
    def __init__(self, position):
        self.position = position

    def move(self, direction):
        x, y = self.position
        x += direction[0]
        y += direction[1]

        if 1 <= x <= 8 and 1 <= y <= 8:
            self.position = (x, y)
            return '+'
        else:
            return '-'

bishop = Bishop((5, 7))
results = []

for _ in range(5):
    user_input = input("Введите направление (например, 1 1 для вправо-вверх): ")
    direction = tuple(map(int, user_input.split()))
    result = bishop.move(direction)
    results.append(result)

print(f"Результаты ходов: {results}")
print(f"Текущая позиция слона: {bishop.position}")