#include <bits/stdc++.h>

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define file(s) if (fopen(s".in", "r")) freopen(s".in", "r", stdin), freopen(s".out", "w", stdout)
#define all(a) a.begin() , a.end()
#define F first
#define S second

using namespace std;
using ll = long long;
using ld = long double;

const ll N = 250000+5 , inf = 2e9 + 7;
const ll INF = 1e18 ,   mod = 1e9+7;


ld dp[N] , c , x[N];
int n , m;

struct line {
  ld k = 0 , m = 1e17;
  line() {}
  line(ld k, ld m): k(k), m(m) {}
  ld get(ld x) {
    return k * x + m;
  }
};

line t[8000001];

void upd(ll v, ll tl, ll tr, line L) {
  // cout << tl <<" " << tr <<" " << L.k <<" "<< L.m << "\n";
  if(t[v].m == 1e17) {
    t[v] = L;
    return;
  }
  if (tl > tr) return;
  ll tm = (tl + tr) / 2;
  bool l = L.get(x[tl]) > t[v].get(x[tl]);
  bool mid = L.get(x[tm]) < t[v].get(x[tm]);
  if (mid) swap(L, t[v]);
  if (l == mid) upd(2 * v, tl, tm - 1, L);
  else upd(2 * v + 1, tm + 1, tr, L);
}

long double get(int v, int tl, int tr, int p) {
  if (t[v].m == 1e17) return t[v].m;
  if (tl > tr) return 1e17;
  ll tm = (tl + tr) / 2;
    if (p == tm) return t[v].get(x[p]);
    if (p < tm) return min(t[v].get(x[p]), get(2 * v, tl, tm - 1, p));
  else return min(t[v].get(x[p]), get(2 * v + 1, tm + 1, tr, p));
}

void solve(){
  cin >> n >> m >> c;
  for(int i = 1; i <= n+1; i++){
    ld time;
    if(i <= n) cin >> x[i] >> time;
    else x[i] = m , time = 0;
    dp[i] = min(time+(x[i]*x[i])/c , time+(x[i]*x[i])/c+get(1,0,n+1,i));
    // cout << dp[i] <<"\n";
    line nw; 
    nw.k = -2*x[i]/c; nw.m = dp[i]+(x[i]*x[i])/c;
    upd(1,0,n+1,nw);
  }
  for(int i = 1; i <= n; i++){
    dp[n+1] = min(dp[n+1] , (x[n+1]-x[i])*(x[n+1]-x[i])/c+dp[i]);
  }
  cout << fixed << setprecision(7) << dp[n+1];
}
/*

*/
signed main(){
  ios;
  solve();
}