import math

def dist(x0, y0, x1, y1, x2, y2):
    A = y2 - y1
    B = x1 - x2
    C = -(A * x1 + B * y1)
    d = abs(A * x0 + B * y0 + C) / math.sqrt(A * A + B * B)
    return d

x1, y1, x2, y2, x3, y3 = map(int, input().split())

d1 = dist(x1, y1, x2, y2, x3, y3)
d2 = dist(x2, y2, x1, y1, x3, y3)
d3 = dist(x3, y3, x1, y1, x2, y2)

if d1 < d2 and d1 < d3:
    print(x2, y2, x3, y3)
elif d2 < d3 and d2 < d1:
    print(x1, y1, x3, y3)
else:
    print(x1, y1, x2, y2)