#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
using ll = long long;
const long long INF = ll(1e16);

bool comp(pair<ll, ll> & a, pair<ll, ll> & b) {
    if (a.first < b.first) {
        return true;
    }
    return a.second < b.second;
}

int main() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].second;
    }
    for (int i = 0; i < n; i++) {
        a[i] = {min(a[i].first, a[i].second), max(a[i].first, a[i].second)};
    }
    sort(a.begin(), a.end(), comp);
    ll T = 1;
    for (int i = 1; i < n; i++) {
        if (a[i - 1].first > a[i].first) {
            T = 0;
            break;
        }
        if (a[i - 1].second > a[i].second) {
            T = 0;
            break;
        }
    }
    if (T == 0) {
        cout << "-1";
        return 0;
    }
    for (int i = 0; i < n; i++) {
        cout << a[i].first << " ";
    } cout << endl;
    for (int i = 0; i < n; i++) {
        cout << a[i].second << " ";
    }

    return 0;
}
