#include <bits/stdc++.h>
#define fi first
#define se second

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const long long inf = 2e9;
const int N = 250001;

long double dp[N];

int root = 1;
int last = 2;
long long x[N], t[N];

struct line {
    long double k, c, b, d;

    long double get(long double x) {
        return (x * x - k * x + b) / c + d;
    }
};

struct {
    line t[16 * N];
    int l[16 * N], r[16 * N];

    void update(int v, long long tl, long long tr, line a) {
        long long tm = (tl + tr) >> 1;

        long long vv = t[v].get(tm);
        long long dd = a.get(tm);
        if (t[v].get(tm) > a.get(tm)) {
            swap(t[v], a);
        }

        if (t[v].get(tl) > a.get(tl)) {
            if (l[v] == 0) l[v] = last++, t[l[v]].c = 1, t[l[v]].b = 1e18;
            update(l[v], tl, tm, a);
        } else if (t[v].get(tr) > a.get(tr)) {
            if (r[v] == 0) r[v] = last++, t[r[v]].c = 1, t[r[v]].b = 1e18;
            update(r[v], tm + 1, tr, a);
        }
    }
    long double get(int v, long long tl, long long tr, long long x) {
        long double cur = t[v].get(x);

        long long tm = (tl + tr) >> 1;

        if (x <= tm) {
            if (l[v] == 0) return cur;
            return min(cur, get(l[v], tl, tm, x));
        } else {
            if (r[v] == 0) return cur;
            return min(cur, get(r[v], tm + 1, tr, x));
        }
    }
} T;

int main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    long long n, m;
    long double c;

    cin >> n >> m >> c;

    T.t[1].k = 0;
    T.t[1].b = 0;
    T.t[1].c = c;

    x[n + 1] = m;
    vector<long long> st;
    for (int i = 1; i <= n + 1; ++i) {
        cin >> x[i] >> t[i];

        dp[i] = T.get(1, 0, inf, x[i]);
        if (i == n + 1) break;

        T.update(root, 1, inf, (line){2 * x[i], c, x[i] * x[i], dp[i] + t[i]});
//        long double mn = 1e18;
//        for (int j = 0; j < i; ++j) {
//            mn = min(mn, dp[j] + t[j] + (x[j] - x[i]) * (x[j] - x[i]) / c);
//        }
//        dp[i] = mn;
//
//        cout << dp[i] << " \n"[i == n];
    }

    cout << fixed << setprecision(8);

    cout << dp[n + 1] << endl;

    return 0;
}
