#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 20;

int good[N], cnt[N], cnt_bad[N];
vector <map <int, int> > g;

int main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    int n, q;
    cin >> n >> q;

    g.assign(n + 1, map<int, int>());

    for (int i = 1; i < N; ++i) good[i] = 1;

    long long ans = 0;
    for(int i = 1; i <= q; ++i) {
        char c;
        cin >> c;
        if(c == '+') {
            int u, v, t;
            cin >> u >> v >> t;

            g[u][t]++;
            g[v][t]++;

            bool prev = good[t];

            if (g[u][t] == 2) {
                cnt_bad[t]++;
            }

            if (g[v][t] == 2) {
                cnt_bad[t]++;
            }

            good[t] = (cnt_bad[t] == 0);

            if (prev != good[t]) {
                ans -= cnt[t];
            } else {
                if (prev == 1)
                    ans++;
            }

            cnt[t]++;
        } else {
            int u, v, t;
            cin >> u >> v >> t;
            g[u][t]--;
            g[v][t]--;

            bool prev = good[t];

            if (g[u][t] == 1) {
                cnt_bad[t]--;
            }

            if (g[v][t] == 1) {
                cnt_bad[t]--;
            }

            good[t] = (cnt_bad[t] == 0);

            cnt[t]--;
            if (prev != good[t]) {
                ans += cnt[t];
            } else {
                if (prev == 1) {
                    ans--;
                }
            }
        }

        cout << ans << "\n";
    }

    return 0;
}
