def min_cuts(n, m, s):
    if n * m == s:
        return 0

    if s > n * m:
        return -1

    min_cuts_result = float('inf')

    for i in range(1, n):
        upper_part = i * m
        if upper_part >= s:
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(i, m, s))
        else:
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(n - i, m, s - upper_part))

    for j in range(1, m):
        left_part = j * n
        if left_part >= s:
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(n, j, s))
        else:
            min_cuts_result = min(min_cuts_result, 1 + min_cuts(n, m - j, s - left_part))

    return min_cuts_result if min_cuts_result != float('inf') else -1


n, m, s = map(int,input().split())
result = min_cuts(n, m, s)
print(result)


