def solve():
    # Функция для отправки запроса
    def query(x, y):
        print(f"? {x} {y}")
        return input().strip()
    
    # Список направлений, чтобы исследовать диагонали
    directions = [(7, 7), (-7, -7), (7, -7), (-7, 7)]
    
    # Начальные значения
    current_x, current_y = 0, 0  # относительно начала координат
    
    # Пробуем двигаться в каждом направлении
    for dx, dy in directions:
        response = query(dx, dy)
        if response == '+':
            current_x += dx
            current_y += dy
    
    # Определяем начальную позицию в шахматной нотации
    initial_row = current_y + 1  # Преобразуем к 1-8
    initial_col = chr(ord('a') + current_x)  # Преобразуем к 'a'-'h'
    
    print(f"! {initial_col}{initial_row}")

solve()