def find_trench_coordinates(x1, y1, x2, y2, x3, y3):
    # Сортируем точки по их координатам x и y отдельно
    x_coords = sorted([x1, x2, x3])
    y_coords = sorted([y1, y2, y3])
    
    # Выбираем минимальные и максимальные координаты
    min_x, max_x = x_coords[0], x_coords[2]
    min_y, max_y = y_coords[0], y_coords[2]
    
    # Возвращаем координаты двух точек, через которые будет проходить траншея
    point1 = (min_x, min_y)
    point2 = (max_x, max_y)
    
    return point1, point2

# Чтение входных данных
x1, y1, x2, y2, x3, y3 = map(int, input().split())

# Нахождение координат для прокладки траншеи
point1, point2 = find_trench_coordinates(x1, y1, x2, y2, x3, y3)

# Вывод результата
print(point1[0], point1[1], point2[0], point2[1])
