#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;

template<class T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& e : a)
        in >> e;
    return in;
}

template<class T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& e : a)
        out << e << ' ';
    out << '\n';
    return out;
}

ll gcd(ll a, ll b) {
    if (a == 0 || b == 0) {
        return a + b;
    }
    if (a < b) {
        return gcd(a, b % a);
    }
    return gcd(b, a % b);
}

void solve() {
    ll n, a;
    cin >> n >> a;
    ll b = 1;
    for (ll i = 0; i < n; i++) {
        b *= 10;
    }
    ll g = gcd(a, b);
    a /= g;
    b /= g;
    if (a < 1e6 && b < 1e6) {
        cout << "YES" << '\n';
        cout << a << " " << b;
    }
    else {
        cout << "NO";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}