#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <cmath>
#include <queue>
#include <iomanip>
using namespace std;
#define int long long
#define pb push_back
#define db double
#define make make_pair
#define speed cin.tie(0);cout.tie(0);ios_base::sync_with_stdio(NULL);

int getA(int xa, int ya, int xb, int yb) {
    return yb - ya;
}

int getB(int xa, int ya, int xb, int yb) {
    return xa - xb;
}

int getC(int xa, int ya, int xb, int yb) {
    int a = getA(xa, ya, xb, yb);
    int b = getB(xa, ya, xb, yb);
    return -a * xa - b * ya;
}

double getD(int xa, int ya, int xb, int yb, int xc, int yc) {
    int a = getA(xa, ya, xb, yb);
    int b = getB(xa, ya, xb, yb);
    int c = getC(xa, ya, xb, yb);
    return abs(a * xc + b * yc + c + 0.0) / sqrt(a * a + b * b);
}

signed main() {
    speed;
    int x1, x2, x3, y1, y2, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    double d12 = getD(x1, y1, x2, y2, x3, y3);
    double d13 = getD(x1, y1, x3, y3, x2, y2);
    double d23 = getD(x2, y2, x3, y3, x1, y1);

    if (d12 <= d13 && d12 <= d23) {
        cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2;
    }
    else if (d13 <= d12 && d13 <= d23) {
        cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3;
    }
    else {
        cout << x2 << ' ' << y2 << ' ' << x3 << ' ' << y3;
    }

    return 0;
}
