/*
     888b     d888        d8888 8888888b.  8888888888     888888b.   Y88b   d88P
     8888b   d8888       d88888 888  "Y88b 888            888  "88b   Y88b d88P
     88888b.d88888      d88P888 888    888 888            888  .88P    Y88o88P
     888Y88888P888     d88P 888 888    888 8888888        8888888K.     Y888P
     888 Y888P 888    d88P  888 888    888 888            888  "Y88b     888
     888  Y8P  888   d88P   888 888    888 888            888    888     888
     888   "   888  d8888888888 888  .d88P 888            888   d88P     888
     888       888 d88P     888 8888888P"  8888888888     8888888P"      888


8888888888  .d8888b.   .d88888b.  8888888b.   .d8888b.  888    888 8888888 888    d8P
888        d88P  Y88b d88P" "Y88b 888   Y88b d88P  Y88b 888    888   888   888   d8P
888        888    888 888     888 888    888 888    888 888    888   888   888  d8P
8888888    888        888     888 888   d88P 888        8888888888   888   888d88K
888        888  88888 888     888 8888888P"  888        888    888   888   8888888b
888        888    888 888     888 888 T88b   888    888 888    888   888   888  Y88b
888        Y88b  d88P Y88b. .d88P 888  T88b  Y88b  d88P 888    888   888   888   Y88b
8888888888  "Y8888P88  "Y88888P"  888   T88b  "Y8888P"  888    888 8888888 888    Y88b

                                    Date 17.11.24
                                Thanks for reading!!!

                               ▄▄▄▄▄▄▄ ▄ ▄▄▄ ▄▄▄▄▄▄▄
                               █ ▄▄▄ █ ▄▄▀█  █ ▄▄▄ █
                               █ ███ █ █▀ ▄▀ █ ███ █
                               █▄▄▄▄▄█ ▄▀█▀█ █▄▄▄▄▄█
                               ▄▄▄▄  ▄ ▄▄▄██▄  ▄▄▄ ▄
                               ▄ ▄█ ▀▄████▄▀█▄▄ ▄▀ █
                               ▀ ██▄ ▄ ▄▄ ▀▄▀▄▄▀▀  ▄
                               ▄▄▄▄▄▄▄ ▀█▄█ ▄▀ █ ▀ ▀
                               █ ▄▄▄ █  █ ██▀▄▄ █▀█
                               █ ███ █ █▀██▄█▀ ▀█▀▀
                               █▄▄▄▄▄█ ██▀█▄█▀▄█▄  ▀

*/

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define print(a) for (auto i: a){cout << i << " ";}cout << endl;
#define dprint(a) for (ll i = 0; i < a.size(); i++){ cout << i << ": ";for(auto j: a[i]){cout << j << "\t";}cout << endl;}cout << endl;
#define open(name_input, name_output) freopen(name_input, "r", stdin); freopen(name_output, "w", stdout);
#define input(a, n) for(ll i = 0; i < n; i++){cin>>a[i];}
#define tests ll number_of_tests; cin>>number_of_tests; while(number_of_tests--)
#define slprint(sl) for(auto i: sl){ cout << i.first << " " << i.second << endl;}
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define M_PI 3.14159265358979323846
#define INF  10e11
#define INF_INT 10e8
#define MOD 1000000093
#define pifagor(a, b) sqrt(pow(a, 2) + pow(b, 2))
#define X first
#define Y second

// ---------MAIN CODE--------- //

bool comp(pll a, pll b) {
    return (a.X < b.X) || (a.X == b.X && a.Y < b.Y);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<ll> a(n), b(n);
    vector<pll> c(n);
    input(a, n);
    input(b, n);
    for (int i = 0; i < n; ++i) {
        c[i] = {a[i], b[i]};
        if (a[i] > b[i]){
            c[i] = {b[i], a[i]};
        }
    }
    sort(all(c));
    //slprint(c)
    for (int i = 1; i < n; ++i) {
        if (c[i].X < c[i - 1].X || c[i].Y < c[i - 1].Y){
            cout << -1;
            return 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << c[i].X << " ";
    }
    cout << endl;
    for (int i = 0; i < n; ++i) {
        cout << c[i].Y << " ";
    }
}