#include <bits/stdc++.h>
using namespace std;
#define int long long
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()

template<class A, class B>
bool chmin(A &a, const B &b) {
	return a > b ? (a = b) == b : false;
} template<class A, class B>
bool chmax(A &a, const B &b) {
	return a < b ? (a = b) == b : false;
}

int get(int n, int s) {
	if (s % n == 0) return 1;
	if (n > s) return 2;
	return 3;
}

signed main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int n, m, s;
	cin >> n >> m >> s;
	if (n * m == s) {
		cout << 0;
		return 0;
	}
	int res = n + m - 2;
	chmin(res, get(n, s));
	chmin(res, get(n, n * m - s));
	chmin(res, get(m, s));
	chmin(res, get(m, n * m - s));
	for (int i = 1; i <= max(n, m); ++i) {
		if (s % i) continue;
		if ((i <= n && s / i <= m) || (i <= m && s / i <= n)) {
			chmin(res, 2);
			break;
		}
	}
	s = n * m - s;
	for (int i = 1; i <= max(n, m); ++i) {
		if (s % i) continue;
		if ((i <= n && s / i <= m) || (i <= m && s / i <= n)) {
			chmin(res, 2);
			break;
		}
	}
	for (int i = 0; i <= n; ++i) {
		int lo = 0, hi = m;
		while (lo + 1 < hi) {
			int mid = (lo + hi) / 2;
			int cur = i * mid + (n - i) * (m - mid);
			if (cur < s) lo = mid;
			else hi = mid;
		}
		int cnt = i * hi + (n - i) * (m - hi);
		if (cnt == s || cnt == n * m - s)
			chmin(res, 2);
	}
	swap(n, m);
	for (int i = 0; i <= n; ++i) {
		int lo = 0, hi = m;
		while (lo + 1 < hi) {
			int mid = (lo + hi) / 2;
			int cur = i * mid + (n - i) * (m - mid);
			if (cur < s) lo = mid;
			else hi = mid;
		}
		int cnt = i * hi + (n - i) * (m - hi);
		if (cnt == s || cnt == n * m - s)
			chmin(res, 2);
	}
	cout << res;
}
