#include <bits/stdc++.h>
using namespace std;
#define int long long
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()

template<class A, class B>
bool chmin(A &a, const B &b) {
	return a > b ? (a = b) == b : false;
} template<class A, class B>
bool chmax(A &a, const B &b) {
	return a < b ? (a = b) == b : false;
}

double p_dist(int x1, int y1, int x2, int y2) {
	return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

double get(int x1, int y1, int x2, int y2, int x3, int y3) {
	double a = p_dist(x1, y1, x2, y2);
	double b = p_dist(x1, y1, x3, y3);
	double c = p_dist(x2, y2, x3, y3);
	double p = (a + b + c) / 2;
	double S = sqrt(p) * sqrt(p - a) * sqrt(p - b) * sqrt(p - c);
	return S / a;
}

signed main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	int x1, x2, x3, y1, y2, y3;
	cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
	int X1 = x1, Y1 = y1;
	int X2 = x2, Y2 = y2;
	double dist = get(x1, y1, x2, y2, x3, y3);
	if (chmin(dist, get(x3, y3, x1, y1, x2, y2)))
		X1 = x1, Y1 = y1, X2 = x3, Y2 = y3;
	if (chmin(dist, get(x3, y3, x2, y2, x1, y1)))
		X1 = x2, Y1 = y2, X2 = x3, Y2 = y3;
	cout << X1 << ' ' << Y1 << ' ' << X2 << ' ' << Y2;
}
