def generate_tetrominoes(n):
    if n < 3:
        return -1

    grid = [[0] * n for _ in range(n)]
    label = 1

    for i in range(n):
        for j in range(n):
            if grid[i][j] == 0:
                count = 0
                for di in range(n):
                    for dj in range(n):
                        if count < n and grid[(i + di) % n][(j + dj) % n] == 0:
                            grid[(i + di) % n][(j + dj) % n] = label
                            count += 1
                label += 1
                if label > n:
                    break
        if label > n:
            break

    if label <= n:
        return -1

    return grid


n = int(input())
result = generate_tetrominoes(n)
if result == -1:
    print(-1)
else:
    for row in result:
        print(" ".join(map(str, row)))