#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4,popcnt,abm,mmx,avx,avx2")
#pragma GCC optimize("unroll-loops")
using namespace std;
long double xs, ys, xf, yf;
long double dist(long double x, long double y, long double a, long double b) {
    return sqrtl((a - x) * (a - x) + (b - y) * (b - y));
}
long double kol(long double x) {
    return max(-x, x);
}
long double f(long double a, long double b, long double x, long double y) {
    return kol(dist(xs, ys, x, y) - a) + kol(dist(xf, yf, x, y) - b);
}
bool ch(long double a, long double b, long double &ansx, long double &ansy) {
    long double xl = -2e8, xr = 2e8;
    int cnt1 = 0;
    while (xr - xl > 0.00001) {
        long double xmid = (xl + xr) / 2.0;
        int cnt2 = 0;
        long double yl = -2e8, yr = 2e8;
        while (yr - yl > 0.00001) {
            long double ymid = (yl + yr) / 2.0;
            if (f(a, b, xmid, ymid) > f(a, b, xmid, ymid + 0.00001)) {
                yl = ymid;
            } else {
                yr = ymid;
            }
            cnt2++;
        }
        if (f(a, b, xmid, yl) > f(a, b, xmid + 0.00001, yl)) {
            xl = xmid;
        } else {
            xr = xmid;
        }
        cnt1++;
    }
    int cnt2 = 0;
    long double yl = -2e8, yr = 2e8;
    while (yr - yl > 0.00001) {
        long double ymid = (yl + yr) / 2.0;
        if (f(a, b, xl, ymid) > f(a, b, xl, ymid + 0.00001)) {
            yl = ymid;
        } else {
            yr = ymid;
        }
        cnt2++;
    }
    ansx = xl;
    ansy = yl;
    // cout << fixed << setprecision(10) << f(a, b, xl, yl) << endl;
    if (kol(f(a, b, xl, yl)) <= 0.00001) {
        return 1;
    } else {
        return 0;
    }
}
 
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> xs >> ys >> xf >> yf;
    int n;
    cin >> n;
    long double l[n + 1];
    int pref[n + 1] = {};
    for (int i = 1; i <= n; i++) {
        cin >> l[i];
    }
    vector <pair <int,int> > v;
    for(int i = 1;i <= n;i++) {
        v.push_back({l[i],i});
    }
    sort(v.begin(),v.end());
    reverse(v.begin(),v.end());
    bool verh[n + 1] = {};
    long double cnt1 = 0,cnt2 = 0;
    for(auto x:v) {
        if(cnt1 > cnt2) {
            cnt2+=x.first;
            verh[x.second] = false;
        }
        else {
            cnt1+=x.first;
            verh[x.second] = true;
        }
    }
    //cnt1,cnt2,dist(xs,ys,xf,yf);
    long double q = cnt1,w = cnt2,e = dist(xs,ys,xf,yf);
     
    if(q + w < e || q + e < w || e + w < q) {
        cout << "Impossible" << endl;
    }
    else {
        long double x,y;
        ch(cnt1,cnt2,x,y);
        cout << "Possible" << endl;
        long double deltaxf = x - xs;
        long double deltayf = y - ys;
         
        long double deltax2 = xf - x;
        long double deltay2 = yf - y;
        long double curx = xs,cury = ys;
        for(int i = 1;i <= n;i++) {
            if(verh[i]) {
                curx+=l[i]/cnt1*(deltaxf);
                cury+=l[i]/cnt1*(deltayf);
            }a
            else {
                curx+=l[i]/cnt2*(deltax2);
                cury+=l[i]/cnt2*(deltay2);
            }
            cout << fixed << setprecision(4) << curx << " " << cury << endl;
        }
         
    }
}