#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4,popcnt,abm,mmx,avx,avx2")
#pragma GCC optimize("unroll-loops")
using namespace std;
long double xs, ys, xf, yf;
__float128 dist(__float128 x, __float128 y, __float128 a, __float128 b) {
    return sqrtl((a - x) * (a - x) + (b - y) * (b - y));
}
__float128 kol(__float128 x) {
    return max(-x, x);
}
__float128 f(__float128 a, __float128 b, __float128 x, __float128 y) {
    return kol(dist(xs, ys, x, y) - a) + kol(dist(xf, yf, x, y) - b);
}
bool ch(__float128 a, __float128 b, __float128 &ansx, __float128 &ansy) {
    __float128 xl = -2e8, xr = 2e8;
    int cnt1 = 0;
    while (xr - xl > 0.000000001) {
        __float128 xmid = (xl + xr) / 2.0;
        int cnt2 = 0;
        __float128 yl = -2e8, yr = 2e8;
        while (yr - yl > 0.00000000001) {
            __float128 ymid = (yl + yr) / 2.0;
            if (f(a, b, xmid, ymid) > f(a, b, xmid, ymid + 0.00000000001)) {
                yl = ymid;
            } else {
                yr = ymid;
            }
            cnt2++;
        }
        if (f(a, b, xmid, yl) > f(a, b, xmid + 0.00000000001, yl)) {
            xl = xmid;
        } else {
            xr = xmid;
        }
        cnt1++;
    }
    int cnt2 = 0;
    __float128 yl = -2e8, yr = 2e8;
    while (yr - yl > 0.00000000001) {
        __float128 ymid = (yl + yr) / 2.0;
        if (f(a, b, xl, ymid) > f(a, b, xl, ymid + 0.00000000001)) {
            yl = ymid;
        } else {
            yr = ymid;
        }
        cnt2++;
    }
    ansx = xl;
    ansy = yl;
    // cout << fixed << setprecision(10) << f(a, b, xl, yl) << endl;
    if (kol(f(a, b, xl, yl)) <= 0.00000000001) {
        return 1;
    } else {
        return 0;
    }
}
  
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> xs >> ys >> xf >> yf;
    int n;
    cin >> n;
    __float128 l[n + 1];
    int pref[n + 1] = {};
    for (int i = 1; i <= n; i++) {
        long double x;
        cin >> x;
        l[i] = x;
    }
    if(n == 1) {
        if(dist(xs,ys,xf,yf) == l[1]) {
            cout << "Possible" << endl;
            cout << xf << " " << yf << endl;
            exit(0);
        } else {
            cout << "Impossible";
            exit(0);
        }
            exit(0);
    }
    vector <pair <int,int> > v;
    for(int i = 1;i <= n;i++) {
        v.push_back({l[i],i});
    }
    sort(v.begin(),v.end());
    reverse(v.begin(),v.end());
    bool verh[n + 1] = {};
    __float128 cnt1 = 0,cnt2 = 0;
    for(auto x:v) {
        if(cnt1 > cnt2) {
            cnt2+=x.first;
            verh[x.second] = false;
        }
        else {
            cnt1+=x.first;
            verh[x.second] = true;
        }
    }
    // cout<<(long double)cnt1<<" "<<(long double)cnt2<<endl;
    //cnt1,cnt2,dist(xs,ys,xf,yf);
    __float128 q = cnt1,w = cnt2,e = dist(xs,ys,xf,yf);
      
    if(q + w < e || q + e < w || e + w < q) {
        cout << "Impossible" << endl;
    }
    else {
        __float128 x,y;
        assert(min(cnt1,cnt2) > 0);
        ch(cnt1,cnt2,x,y);
        cout << "Possible" << endl;
        __float128 deltaxf = x - xs;
        __float128 deltayf = y - ys;
          
        __float128 deltax2 = xf - x;
        __float128 deltay2 = yf - y;
        __float128 curx = xs,cury = ys;
        for(int i = 1;i <= n;i++) {
            if(verh[i]) {
                curx+=l[i]/cnt1*(deltaxf);
                cury+=l[i]/cnt1*(deltayf);
            }
            else {
                curx+=l[i]/cnt2*(deltax2);
                cury+=l[i]/cnt2*(deltay2);
            }
            cout << fixed << setprecision(10) << (long double)curx << " " << (long double)cury << endl;
        }
          
    }
}