import math
def is_power_of_2_or_5_only(num):
   while num % 2 == 0:
       num //= 2
   while num % 5 == 0:
       num //= 5
   return num == 1
def find_fraction(n, digits):
   fractional_part = int(digits)
   denominator = 10 ** n
   numerator = fractional_part
   gcd = math.gcd(numerator, denominator)
   numerator //= gcd
   denominator //= gcd
   if is_power_of_2_or_5_only(denominator):
       return numerator, denominator
   else:
       return None
n = int(input())
digits = input().strip()
result = find_fraction(n, digits)
if result:
   numerator, denominator = result
   print("YES")
   print(numerator, denominator)
else:
   print("NO")