#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double

const int MAXN = 1e5 + 5;

vector<int> color(MAXN, 0);

void solve() {
    int n, q;
    cin >> n >> q;
    int ans = 0;
    map<int, unordered_map<int, int>> mp;
    vector<int> us(n + 1, 0);
    for (int i = 0; i < q; ++i) {
        char m;
        cin >> m;
        int u, v, c;
        cin >> u >> v >> c;
        if (m == '+') {
            mp[u][c]++;
            mp[v][c]++;
            if(mp[v][c] > 1 || mp[u][c] > 1) {
                if(us[c] == 1) {
                    ans -= color[c];
                }
                color[c]++;
                us[c] = 0;
            } else {
                if(us[c] == 1) ans -= color[c];
                color[c]++;
                ans += color[c];
                us[c] = 1;
            }
            cout << ans << endl;
        } else {
            mp[u][c]--;
            mp[v][c]--;
            if(mp[v][c] > 1 || mp[u][c] > 1) {
                if(us[c] == 1) {
                    ans -= color[c];
                }
                color[c]--;
                us[c] = 0;
            } else {
                if(us[c] == 1) ans -= color[c];
                color[c]--;
                ans += color[c];
                us[c] = 1;
            }
            cout << ans << endl;
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
