#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double

struct Point {
    double x, y;
};

struct Line {
    double a, b, c;
    Point p1, p2;
    Line(Point a1, Point b1) {
        a = b1.y - a1.y;
        b = a1.x - b1.x;
        c = -(a1.x * b1.y - a1.y * b1.x);
        p1 = a1;
        p2 = b1;
    }
};




double len(Point a, Line line) {
    return abs((line.a * a.x + line.b * a.y + line.c) / sqrtl(line.a * line.a + line.b * line.b));
}

void solve() {
    Point a, b, c;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    Line ab(a, b), bc(b, c), ca(c, a);
    double dist1, dist2, dist3;
    dist1 = len(c, ab);
    dist2 = len(a, bc);
    dist3 = len(b, ca);
    Point ans1, ans2;
    ans1 = ab.p1;
    ans2 = ab.p2;
    int ans_dist = dist1;
    if(dist2 < ans_dist) {
        ans1 = bc.p1;
        ans2 = bc.p2;
    }
    if(dist3 < ans_dist) {
         ans1 = ca.p1;
         ans2 = ca.p2;
    }
    cout << fixed << setprecision(10) << ans1.x << ' ' << ans1.y << ' ' << ans2.x << ' ' << ans2.y;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
