#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

void solve()
{
    int n, m, s;
    cin >> n >> m >> s;
    if (s == n * m)
    {
        cout << "0";
        return;
    }
    if (s % m == 0 || s % n == 0)
    {
        cout << "1";
        return;
    }
    /*for (int i = 1; i <= m - 1; i++)
    {
        if (s - i * n > 0 && (s - i * n) % m == 0)
        {
            cout << "2";
            return;
        }
    }
    cout << "3";*/
    vector<int> a;
    int z = s;
    for (int i = 2; i * i <= z; i++)
    {
        while (z % i == 0)
        {
            a.push_back(i);
            z /= i;
        }
    }
    if (z != 1)
    {
        a.push_back(z);
    }
    int q = pow(2, a.size());
    for (int i = 0; i < q; i++)
    {
        string w = "";
        int x = i;
        while (x)
        {
            w += '0' + x % 2;
            x %= 2;
        }
        while (w.size() <= a.size())
        {
            w += '0';
        }
        int p1 = 1, p2 = 1;
        for (int j = 0; j < a.size(); j++)
        {
            if (w[i] == '1')
            {
                p1 *= (w[i] - '0');
            }
            if (w[i] == '0')
            {
                p2 *= (w[i] - '0');
            }
        }
        if (max(p1, p2) <= max(n, m) && min(p1, p2) <= min(n, m))
        {
            cout << "2";
            return;
        }
    }
    int c = 0;
    int y = min(n, m);
    while (c < s)
    {
        c += max(n, m);
        y--;
    }
    c -= max(n, m);
    y++;
    if (y == 1)
    {
        cout << "2";
    }
    else
    {
        cout << "3";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
