def check_possible_fraction(n, digits):
    # Преобразуем строку цифр в целое число
    numerator = int(digits)
    denominator = 10 ** n

    # Проверим, если дробь не имеет периодичности
    # Если знаменатель делится на 2 или 5, дробь может быть конечной
    # Преобразуем знаменатель, делим его на 2 и 5, пока можно
    while denominator % 2 == 0:
        denominator //= 2
    while denominator % 5 == 0:
        denominator //= 5

    # Если после деления знаменатель стал равен 1, дробь конечная
    # и значит она не может быть результатом деления с непериодичной дробью
    if denominator != 1:
        # Найдем a и b
        a = numerator
        b = 10 ** n
        if a < b:
            return f"YES\n{a} {b}"
    
    return "NO"

# Ввод
n = int(input())
digits = input()

# Вывод результата
print(check_possible_fraction(n, digits))
