import random
import time

# Список возможных заклинаний
spells = {
    "Фламмора": "Вы вызываете мощный огненный поток, который поджигает всё на своём пути!",
    "Левитация": "Вы поднимаете предмет в воздух, он парит перед вами.",
    "Огненный шар": "Вы создаете огненный шар и метаете его в цель.",
    "Исцеление": "Раны начинают заживать, и боль уходит.",
    "Таймлапс": "Время замедляется, и вы успеваете выполнить все свои действия.",
    "Молния": "Вы вызываете молнию, которая поражает вашего врага."
}

# Функция для выполнения заклинания
def cast_spell(spell):
    print(f"Произнесение заклинания: {spell}...")
    time.sleep(2)  # Пауза для создания эффекта магии
    print(f"{spells[spell]}")
    print("Заклинание успешно исполнено!\n")

# Функция для выбора случайного заклинания
def random_spell():
    spell = random.choice(list(spells.keys()))
    return spell

# Основная программа
def main():
    print("Добро пожаловать в мир магии!")
    while True:
        action = input("Введите название заклинания или 'random' для случайного заклинания ('exit' для выхода): ").strip()
        if action.lower() == 'exit':
            print("До свидания!")
            break
        elif action.lower() == 'random':
            spell = random_spell()
            cast_spell(spell)
        elif action in spells:
            cast_spell(action)
        else:
            print("Такого заклинания нет. Попробуйте снова.")

# Запуск программы
if __name__ == "__main__":
    main()
