def solve():
    n = int(input().strip())

    # Для n = 2 или n = 3 невозможно разбиение
    if n == 2 or n == 3:
        print(-1)
        return

    # Создадим пустое поле для разбиения
    field = [[0] * n for _ in range(n)]
    
    # Метод разбиения: заполняем поле спирально
    current_number = 1
    for i in range(0, n, 2):
        for j in range(0, n, 2):
            field[i][j] = current_number
            field[i][j + 1] = current_number
            field[i + 1][j] = current_number
            field[i + 1][j + 1] = current_number
            current_number += 1

    # Выводим результат
    for row in field:
        print(" ".join(map(str, row)))

