from math import gcd
def full_factorization(n):
    p = []
    d = 2
    while d * d <= n:
        while n % d == 0:
            p.append(d)
            n //= d
        d += 1
    if n > 1:
        p.append(n)
    return p
def dividers(n):
    p = full_factorization(n)
    divs = []
    for i in range(1, n + 1):
        if n%i == 0:
            divs.append(i)
    return divs
def main(n):
    used = []
    number = 0
    div = dividers(n)
    for a in div:
        for b in div:
            if a < b and (a,b) not in used and gcd(a,b) == 1 and a*b <= n:
                number += 1
            used += [(a, b), (b, a)]
    return number
n = int(input())
print(main(int(input())))
