def can_form_timeline(n, front, back):
    years = list(zip(front, back))
    years.sort(key=lambda x: min(x))  # Сортируем по минимальному году на карточках

    # Проверяем возможность формирования правильного порядка
    last_front, last_back = 0, 0
    for f, b in years:
        if min(f, b) >= last_front:
            last_front = max(f, b)
        elif max(f, b) >= last_back:
            last_back = max(f, b)
        else:
            return -1

    return " ".join(map(str, front)) + "\n" + " ".join(map(str, back))

# Пример использования:
n = int(input("Введите количество карточек: "))
front = list(map(int, input("Введите годы на лицевой стороне карточек: ").split()))
back = list(map(int, input("Введите годы на оборотной стороне карточек: ").split()))

result = can_form_timeline(n, front, back)
print(result)
