def query(dx, dy):
    print(f"? {dx} {dy}")
    response = input().strip()
    return response == '+'

def find_bishop_position():
    possible_positions = [(x, y) for x in range(1, 9) for y in range(1, 9) if (x + y) % 2 == 1]
    
    for _ in range(7):
        if len(possible_positions) == 1:
            break
        
        mid_index = len(possible_positions) // 2
        test_x, test_y = possible_positions[mid_index]
        if query(test_x - 1, test_y - 1):
            possible_positions = [pos for pos in possible_positions if abs(pos[0] - test_x) == abs(pos[1] - test_y)]
        else:
            possible_positions = [pos for pos in possible_positions if abs(pos[0] - test_x) != abs(pos[1] - test_y)]
    
    if len(possible_positions) == 1:
        x, y = possible_positions[0]
        print(f"! {chr(ord('a') + x - 1)}{y}")
    else:
        print("Невозможно определить позицию слона")


find_bishop_position()
