def min_cuts(n, m, s):
    if s == n * m:
        return 0
    min_cuts = float('inf')
    for x in range(n + 1): 
        area1 = x * m
        area2 = (n - x) * m
        if s <= area1 or s <= area2:
            min_cuts = min(min_cuts, 1)


    for y in range(m + 1):  
        area1 = n * y
        area2 = n * (m - y)
        if s <= area1 or s <= area2:
            min_cuts = min(min_cuts, 1)

    for x in range(n + 1):  
        for y in range(m + 1):  
            part1 = x * y
            part2 = (n - x) * y
            part3 = x * (m - y)
            part4 = (n - x) * (m - y)
            areas = [part1, part2, part3, part4]
            if any(sum(areas[:i] + areas[i + 1:]) == s for i in range(4)):
                min_cuts = min(min_cuts, x + y)
    return min_cuts if min_cuts != float('inf') else -1

n, m, s = map(int, input().split())

print(min_cuts(n, m, s))
