def min_cuts(n, m, s):
    if s == n * m:
        return 0
    
    min_cuts = float('inf')  
    for i in range(1, n + 1):  
        if s % i == 0:  
            j = s // i 
            if j <= m:  
                
                vertical_cuts = i - 1
                horizontal_cuts = j - 1
                min_cuts = min(min_cuts, vertical_cuts + horizontal_cuts)

    
    for j in range(1, m + 1):  
        if s % j == 0:  
            i = s // j  
            if i <= n:  
                
                vertical_cuts = i - 1
                horizontal_cuts = j - 1
                min_cuts = min(min_cuts, vertical_cuts + horizontal_cuts)

    return min_cuts if min_cuts != float('inf') else -1

n, m, s = map(int, input().split())
print(min_cuts(n, m, s))
