#pragma GCC optimize("O3")

#include <bits\stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int N = 1e6;

void solve() {
    cout << setprecision(7) << fixed;
    ll n, m;
    ld c;
    cin >> n >> m >> c;
    vector<ld>x(n + 1);
    vector<ld>t(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> t[i];
    }
    x[n] = m;
    t[n] = 0;
    vector<ld>dp(n + 1);
    dp[0] = (x[0] * x[0]) /c + t[0];
    set<pair<ld, ld>> st = {{dp[0], x[0]}};
    for (int i = 1; i < n + 1; ++i) {
        dp[i] = (x[i] * x[i]) / c + t[i];
        for (auto [dpj, xj] : st) {
            dp[i] = min(dp[i], dpj + (x[i] - xj) * (x[i] - xj) / c + t[i]);
        }
        vector<pair<ld, ld>> dl;

        for (auto [dpj, xj] : st) {
            if (dp[i] < dpj + (x[i] - xj) * (x[i] - xj) / c) {
                dl.emplace_back(dpj, xj);
            }
        }
        for (auto pr : dl) {
            st.erase(pr);
        }
        st.emplace(dp[i], x[i]);
    }
    cout << dp[n];
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}