#include <bits\stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int N = 1e6;

struct Point {
    ld x, y;
    Point(ld x, ld y): x(x), y(y) {

    }
    Point(Point &a, Point &b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
};

ld pr(Point a, Point b, Point c) {
    Point b1(b, a);
    Point c1(c, a);
    return abs(b1.x * c1.y - c1.x * b1.y) / 2;
}

long double f(Point a, Point b, Point c) {
    ld sq = pr(a, b, c);
    ld r = sqrt((b.x - c.x) * (b.x - c.x) + (b.y - c.y) * (b.y - c.y));
    return sq / r;
}

void solve() {
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    Point a(x1, y1), b(x2, y2), c(x3, y3);
    pair<int, int> mn = min(pair(f(a, b, c), pair(2, 3)), min(pair(f(b, a, c), pair(1, 3)), pair(f(c, b, a), pair(1, 2)))).second;
    if (mn == pair(2, 3)) {
        cout << x2 << ' ' << y2 << ' ' << x3 << ' ' << y3;
    }
    if (mn == pair(1, 3)) {
        cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3;
    }
    if (mn == pair(1, 2)) {
        cout << x2 << ' ' << y2 << ' ' << x1 << ' ' << y1;
    }
}

signed main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}
