#include <bits/stdc++.h>

#ifdef LOCAL
#include "algo/debug.h"
#else
#define print(...)
#endif

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define str string

#define all(v)  v.begin(), v.end()
#define fi      first
#define se      second
#define pb      push_back
#define ent     cout << "\n";
#define sz(v)   ll(v.size())

using namespace std;

const long long MOD = 1e9+7, inf = 1e18;

ll rec(ll n, ll m, ll s) {
    // print(n, m, s);
    if (n * m == s) {
        return 0;
    }
    if (s % m == 0 || s % n == 0) {
        return 1;
    }
    ll ok = 0, p = s;
    for (ll i=1; i*i<=p; i++) {
        if (p % i == 0) {
            ll x = i;
            ll y = p / i;

            if ((x <= n && y <= m) || (x <= m && y <= n)) {
                ok = 1;
            }
        }
    }
    p = n * m - s;
    for (ll i=1; i*i<=p; i++) {
        if (p % i == 0) {
            ll x = i;
            ll y = p / i;

            if ((x <= n && y <= m) || (x <= m && y <= n)) {
                ok = 1;
            }
        }
    }

    
    ll ans1 = inf;
    if (s / n > 0) {
        ans1 = rec(n, m - s / n, s - ll(s / n) * n);
    }
    ll ans2 = inf;
    if (s / m > 0) {
        ans2 = rec(n - s / m, m, s - ll(s / m) * m);
    }
    ll ans = 1 + min(ans1, ans2);

    if (ok) ans = min(ans, 2LL);

    return ans;
}

void solve() {
    ll n, m, s;
    cin >> n >> m >> s;
    cout << rec(n, m, s);
}

int32_t main() {
    #ifdef ONLINE_JUDGE
        // freopen("input.txt","r",stdin);
        // freopen("output.txt","w",stdout);
    #endif
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    ll ttest=1;
    // cin >> ttest;

    for (ll test_number=1; test_number<=ttest; test_number++) {
        solve();
    }

    return 0;
}