def generate_route(n):
    route = []
    
    # Начало маршрута в точке (2, 2) для n=3
    route.append((n-1, n-1))  # То есть (2, 2) для n=3
    
    # Двигаемся по маршруту через все точки
    route.append((0, 0))  # Нижний левый угол
    route.append((n, 0))  # Двигаемся вправо
    route.append((0, n))  # Перемещаемся вверх
    
    # Завершаем маршрут в точке (0, 1)
    route.append((0, 1))
    
    return route

# Ввод
n = int(input())

# Генерация маршрута
route = generate_route(n)

# Вывод маршрута
for point in route:
    print(*point)
