def generate_route(n):
    route = []
    
    # Начинаем с точки (n-1, n-1), то есть (2, 2) для n=3
    route.append((n-1, n-1))  # Это будет (2, 2) для n=3
    
    # Двигаемся по сетке в правильном порядке
    route.append((0, 0))  # Нижний левый угол
    route.append((n, 0))  # Двигаемся вправо по оси X
    route.append((0, n))  # Двигаемся вверх по оси Y
    
    # Завершаем маршрут в точке (0, 1)
    route.append((0, n-2))
    
    return route

# Ввод
n = int(input())

# Генерация маршрута
route = generate_route(n)

# Вывод маршрута
for point in route:
    print(*point)
