﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <set>
#include <cmath>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define print(a) for (auto i : a) {cout << i << " ";} cout << "\n";
#define scan(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define its(a) a.begin(), a.end()
ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}
void solve() {
    ll n; cin >> n;
    string s; cin >> s;
    ll i = 0; 
    while (s[i] == '0')
        i++;
    vector <ll> a;
    while (i < n) {
        a.push_back(s[i] - '0');
        i++;
    }
    ll x = 0, y = pow(10, n);
    for (int i = 0; i < a.size(); i++)
        x += (ll)a[i] * (ll)pow(10, a.size() - 1 - i);
    ll g = gcd(x, y);
    x /= g;
    y /= g;
    if (x > 0 && x < 1e6 && y > 0 && y < 1e6 && x < y) {
        cout << "YES\n";
        cout << x << " " << y;
        return;
    }
    cout << "NO";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    //freopen("network.in", "r", stdin);
    //freopen("network.out", "w", stdout);
    solve();
}