﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <set>
#include <cmath>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define print(a) for (auto i : a) {cout << i << " ";} cout << "\n";
#define scan(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define its(a) a.begin(), a.end()
//ll gcd(ll a, ll b) {
//    if (b == 0) return a;
//    return gcd(b, a % b);
//}

bool check(ld a, ld b, ld c) {
    return a + b > c && a + c > b && b + c > a;
}

void solve() {
    ll c, h; cin >> c >> h;
    ld d = sqrt(c * c + 2 * h * c);
    ld D = d * d - 4 * h * c;
    if (D < 0) {
        cout << -1;
        return;
    }
    ld a1 = (d + sqrt(D)) / 2;
    ld a2 = (d - sqrt(D)) / 2;
    if (a1 < 0 && a2 < 0) {
        cout << -1;
        return;
    }
    if (a1 == 0 && a2 == 0) {
        cout << -1;
        return;
    }
    if (a1 > 0 && a1 < c) {
        ld b1 = d - a1;
        if (check(a1, b1, c)) {
            //cout << a1 << " " << b1 << "\n";
            cout << 0.5 * c * h;
            return;
        }
    }
    if (a2 > 0 && a2 < c) {
        ld b2 = d - a2;
        if (check(a2, b2, c)) {
            //cout << a2 << " " << b2 << "\n";
            cout << 0.5 * c * h;
            return;
        }
    }
    cout << -1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    //freopen("network.in", "r", stdin);
    //freopen("network.out", "w", stdout);
    solve();
}