﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <set>
#include <cmath>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define print(a) for (auto i : a) {cout << i << " ";} cout << "\n";
#define scan(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define its(a) a.begin(), a.end()
//ll gcd(ll a, ll b) {
//    if (b == 0) return a;
//    return gcd(b, a % b);
//}
ll get(ll n, ll m, ll s) {
    for (int i = 1; i <= n; i++) {
        if (i * m == s)
            return 1;
        if (i * m < s)
            continue;
        if (i == n)
            return 2;
        else {
            return min(3ll, 1ll + get(n - i - 1, m, s - i * m));
        }
    }
}
void solve() {
    ll n, m, s; cin >> n >> m >> s;
    if (n * m == s) {
        cout << 0;
        return;
    }
    ll ans = min(min(get(n, m, s), get(m, n, s)), min(get(n, m, n * m - s), get(m, n, n * m - s)));
    if (n > m)
        swap(n, m);
    for (ll d = 1; d * d <= s; d++) {
        if (s % d == 0) {
            if (min(d, s / d) <= n && max(d, s / d) <= m) {
                if (min(d, s / d) == n || max(d, s / d) == m)
                    ans = min(ans, 1ll);
                else
                    ans = min(ans, 2ll);
            }
        }
    }
    s = n * m - s;
    for (ll d = 1; d * d <= s; d++) {
        if (s % d == 0) {
            if (min(d, s / d) <= n && max(d, s / d) <= m) {
                if (min(d, s / d) == n || max(d, s / d) == m)
                    ans = min(ans, 1ll);
                else
                    ans = min(ans, 2ll);
            }
        }
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    //freopen("network.in", "r", stdin);
    //freopen("network.out", "w", stdout);
    solve();
}