﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <set>
#include <cmath>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define print(a) for (auto i : a) {cout << i << " ";} cout << "\n";
#define scan(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define its(a) a.begin(), a.end()
void solve() {
    int n, q; cin >> n >> q;
    int ans = 0;
    vector <int> cnt(n);
    vector <set <int>> c1(n);
    vector <multiset <int>> c2(n);
    while (q--) {
        char type;
        int a, b;
        int c;
        cin >> type >> a >> b >> c;
        a--; b--; c--;
        if (type == '+') {
            int sz1 = c1[c].size(), sz2 = c2[c].size();
            c1[c].insert(a);
            c1[c].insert(b);
            c2[c].insert(a);
            c2[c].insert(b);
            if (c1[c].size() == c2[c].size()) {
                cnt[c]++;
                ans++;
                cout << ans << "\n";
                continue;
            }
            if (sz1 != sz2) {
                cnt[c]++;
            }
            else {
                ans -= cnt[c];
                cnt[c]++;
            }
        }
        else {
            int sz1 = c1[c].size(), sz2 = c2[c].size();
            c2[c].erase(c2[c].find(a));
            c2[c].erase(c2[c].find(b));
            cnt[c]--;
            if (c2[c].count(a) == 0) c1[c].erase(a);
            if (c2[c].count(b) == 0) c1[c].erase(b);
            if (sz1 == sz2) {
                ans--;
                cout << ans << "\n";
                continue;
            }
            if (c1[c].size() == c2[c].size()) {
                ans += cnt[c];
                cout << ans << "\n";
                continue;
            }
        }
        cout << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    //freopen("network.in", "r", stdin);
    //freopen("network.out", "w", stdout);
    solve();
}