﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <set>
#include <cmath>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define print(a) for (auto i : a) {cout << i << " ";} cout << "\n";
#define scan(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define its(a) a.begin(), a.end()

map <int, char> mp = { {0, 'a'}, {1, 'b'}, {2, 'c'}, {3, 'd'}, {4, 'e'}, {5, 'f'}, {6, 'g'}, {7, 'h'}};

void solve() {
    int l1 = 0, r1 = 8;
    while (r1 - l1 > 1) {
        int mid = (l1 + r1) >> 1;
        cout << "? " << -mid << " " << -mid << endl;
        char ans; cin >> ans;
        if (ans == '+') {
            l1 = mid;
        }
        else {
            r1 = mid;
        }
    }
    int l2 = 0, r2 = 8;
    while (r2 - l2 > 1) {
        int mid = (l2 + r2) >> 1;
        cout << "? " << mid << " " << mid << endl;
        char ans; cin >> ans;
        if (ans == '+') {
            l2 = mid;
        }
        else {
            r2 = mid;
        }
    }
    if (l1 + l2 + 1 == 8) {
        cout << "! " << mp[l1] << 8 - l2 << endl;
        return;
    }
    if (l1 + l2 + 1 == 6) {
        char ans;
        if (l1 == 0 || l1 == 5) {
            cout << "? " << -1 << " " << 1 << endl;
        }
        else if (l1 == 1 || l1 == 4) {
            cout << "? " << -2 << " " << 2 << endl;
        }
        else if (l1 == 2 || l1 == 3) {
            cout << "? " << -3 << " " << 3 << endl;
        }
        cin >> ans;
        if (ans == '+') {
            cout << "! " << mp[2 + l1] << 6 - l2 << endl;
            return;
        }
        else {
            cout << "! " << mp[l1] << 8 - l2 << endl;
            return;
        }
    }
    else if (l1 + l2 + 1 == 4) {
        char ans;
        if (l1 == 0 || l1 == 3) {
            cout << "? " << -1 << " " << 1 << endl;
        }
        else if (l1 == 2 || l1 == 1) {
            cout << "? " << -2 << " " << 2 << endl;
        }
        cin >> ans;
        if (ans == '+') {
            cout << "! " << mp[4 + l1] << 4 - l2 << endl;
            return;
        }
        else {
            cout << "! " << mp[l1] << 8 - l2 << endl;
            return;
        }
    }
    else {
        char ans;
        cout << "? " << -1 << " " << 1 << endl;
        cin >> ans;
        if (ans == '+') {
            cout << "! " << mp[6 + l1] << 2 - l2 << endl;
        }
        else {
            cout << "! " << mp[l1] << 8 - l2 << endl;
        }
    }
}

int main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(nullptr);
    //freopen("network.in", "r", stdin);
    //freopen("network.out", "w", stdout);
    solve();
}