def solve_galactic_timeline(n, a, b):
    # Формируем список карточек
    cards = list(zip(a, b))
    
    # Проверяем возможность сортировки
    def can_sort(cards):
        # Пробуем сортировать с переворотом
        cards.sort(key=lambda x: (min(x), max(x)))
        face_sorted = [min(card) for card in cards]
        back_sorted = [max(card) for card in cards]
        return face_sorted == sorted(face_sorted) and back_sorted == sorted(back_sorted)

    # Если возможно, возвращаем результат
    if can_sort(cards):
        cards.sort(key=lambda x: (min(x), max(x)))
        face_sorted = [min(card) for card in cards]
        back_sorted = [max(card) for card in cards]
        return face_sorted, back_sorted
    
    return -1


# Чтение данных
n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

# Решение задачи
result = solve_galactic_timeline(n, a, b)

if result == -1:
    print(-1)
else:
    print(*result[0])
    print(*result[1])

