from math import ceil, floor

def find_tranch(x1, y1, x2, y2, x3, y3):
    if (x2 - x1) * (y3 - y1) - (x3 - x1) * (y2 - y1) == 0:
        return "No solution"

    a, b = (x1, y1), (x2, y2)

    x_intersect = b[0] - (b[1] - a[1]) * a[0] / (b[1] - a[1])
    y_intersect = a[1] - (b[0] - a[0]) * a[1] / (b[0] - a[0])
 
    return (int(ceil(min(x_intersect, 0))), 0), (0, int(floor(max(y_intersect, 0))))

x1, y1, x2, y2, x3, y3 = map(int, input().split())
result = find_tranch(x1, y1, x2, y2, x3, y3)
print(result)