import math

def solve(x1, y1, x2, y2, x3, y3):
    A = y2 - y1
    B = x1 - x2
    C = x2 * y1 - x1 * y2
    distance = abs(A * x3 + B * y3 + C) / math.sqrt(A * A + B * B)
    return distance

def main():
    # Ввод всех координат в одной строке
    x1, y1, x2, y2, x3, y3 = map(float, input().split())

    distance = solve(x1, y1, x2, y2, x3, y3)
    distance1 = solve(x1, y1, x3, y3, x2, y2)
    distance2 = solve(x2, y2, x3, y3, x1, y1)

    if distance < distance1 and distance < distance2:
        print(int(x1), int(y1), int(x2), int(y2))
    elif distance1 < distance and distance1 < distance2:
        print(int(x1), int(y1), int(x3), int(y3))
    else:
        print(int(x2), int(y2), int(x3), int(y3))

if __name__ == "__main__":
    main()
