#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(0);
#endif

      ll n, m, s;
      cin >> n >> m >> s;

      if (n > m) swap(n, m);


      auto solve = [](ll n, ll m, ll s) -> ll {
            if (s < 0) return 3;
            if (n * m == s) {
                  return 0;
            }

            if (s % n == 0 || s % m == 0) {
                  return 1;
            }
            for (int y = 1; y <= n - 1; ++y) {
                  for (;;) {
                        if ((s - y * m) % (n - y) != 0) break;
                        ll x = (s - y * m) / (n - y);
                        if (x <= 0 || x >= m) break;
                        return 2;
                  }
                  for (;;) {
                        if (2ll * y == n) break;
                        if ((s - n * m + m * y) % (2ll * y - n) != 0) break;
                        ll x = (s - n * m + m * y) / (2ll * y - n);
                        if (x <= 0 || x >= m) break;
                        return 2;
                  }
            }

            for (ll i = 1; i * i <= s; ++i) {
                  if (s % i != 0) continue;
                  ll j = s / i;

                  if (i <= n && j <= m) {
                        return 2;
                  }
            }
            s = n * m - s;
            for (ll i = 1; i * i <= s; ++i) {
                  if (s % i != 0) continue;
                  ll j = s / i;

                  if (i <= n && j <= m) {
                        return 2;
                  }
            }
            return 3;
      };

      cout << solve(n, m, s) << "\n";
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (int i = 0; i < a.size(); i++)
            os << a[i] << " \n"[i == a.size() - 1];
      return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
      for (auto &i: a)
            is >> i;
      return is;
}
// endregion