from collections import defaultdict

aa = defaultdict(lambda: defaultdict(set))
aa1 = defaultdict(int)


superior_colors = set()


def pop(v, u, c, op):
    if op == '+':
        aa[c][v].add(u)
        aa[c][u].add(v)
        aa1[c] += 1
    elif op == '-':
        aa[c][v].discard(u)
        aa[c][u].discard(v)
        aa1[c] -= 1
    
    if check_superior(c):
        superior_colors.add(c)
    else:
        superior_colors.discard(c)

def check_superior(c):
    for vertex, adjacent in aa[c].items():
        if len(adjacent) > 1:
            return False
    return True

def colcul():
    return sum(aa1[color] for color in superior_colors)

n, q = map(int, input().split())

for _ in range(q):
    op, v, u, c = input().split()
    v, u, c = int(v), int(u), int(c)
    pop(v, u, c, op)
    print(colcul())
