#include <iostream>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;

bool is_sorted(const vector<int>& arr) {
    return is_sorted(arr.begin(), arr.end());
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    vector<pair<int, int>> ggg(n);
    for (int i = 0; i < n; ++i) {
        ggg[i] = make_pair(a[i], b[i]);
    }

    vector<pair<int, int>> be;

    random_device rd;
    mt19937 g(rd());

    for (int i = 0; i < 1000; ++i) {
        shuffle(ggg.begin(), ggg.end(), g);
        vector<pair<int, int>> agg;

        for (int j = 0; j < n; ++j) {
            if (static_cast<double>(rand()) / RAND_MAX < 0.5) {
                agg.push_back({ ggg[j].second, ggg[j].first });
            }
            else {
                agg.push_back(ggg[j]);
            }
        }

        vector<int> t(n), tv(n);
        for (int j = 0; j < n; ++j) {
            t[j] = agg[j].first;
            tv[j] = agg[j].second;
        }

        if (is_sorted(t) && is_sorted(tv)) {
            be = agg;
            break;
        }
    }

    if (!be.empty()) {
        for (const auto& x : be) {
            cout << x.first << " ";
        }
        cout << endl;
        for (const auto& x : be) {
            cout << x.second << " ";
        }
        cout << endl;
    }
    else {
        cout << "-1" << endl;
    }
}

int main() {
    solve();
    return 0;
}