def is_valid_move(x, y):
    print(f"? {x} {y}")
    response = input().strip()
    return response == "+"

def get_cell_notation(x, y):
    col = chr(ord('a') + x - 1)
    row = str(y)
    return col + row

def detect_bishop_position():

    first_move = is_valid_move(7, 7)

    second_move = is_valid_move(-7, -7)

    if first_move != second_move:
        third_move = is_valid_move(7, -7)

        if third_move:
            left, right = 1, 7
            while left < right:
                mid = (left + right) // 2
                if is_valid_move(mid, -mid):
                    right = mid
                else:
                    left = mid + 1
            x = 8 - left
            y = left
        else:
            left, right = 1, 7
            while left < right:
                mid = (left + right) // 2
                if is_valid_move(-mid, mid):
                    right = mid
                else:
                    left = mid + 1
            x = left
            y = 8 - left
    else:
        left, right = 1, 7
        while left < right:
            mid = (left + right) // 2
            if is_valid_move(mid, mid):
                right = mid
            else:
                left = mid + 1
        x = y = left

    print(f"! {get_cell_notation(x, y)}")

detect_bishop_position()
