#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

struct O {
    long long f, b;
    int i;
    bool fl;
};

int main() {
    int n;
    cin >> n;
    vector<long long> a(n), b(n);
    for (int j = 0; j < n; ++j) {
        cin >> a[j];
    }
    for (int j = 0; j < n; ++j) {
        cin >> b[j];
    }

    vector<O> opts;
    for (int j = 0; j < n; ++j) {
        opts.push_back({a[j], b[j], j, false});
        if (a[j] != b[j]) {
            opts.push_back({b[j], a[j], j, true});
        }
    }

    sort(opts.begin(), opts.end(), [](const O& x, const O& y) {
        if (x.f != y.f)
            return x.f < y.f;
        return x.b < y.b;
    });

    vector<bool> u(n, false);
    vector<long long> fs, bs;
    vector<bool> fl(n, false);

    long long pb = -1;
    int c = 0;

    for (const auto& o : opts) {
        if (!u[o.i] && o.b >= pb) {
            u[o.i] = true;
            fs.push_back(o.f);
            bs.push_back(o.b);
            fl[o.i] = o.fl;
            pb = o.b;
            ++c;
            if (c == n)
                break;
        }
    }

    if (c < n) {
        cout << -1 << endl;
        return 0;
    }

    vector<long long> rf(n), rb(n);
    for (int j = 0; j < n; ++j) {
        int idx = opts[j].i;
        if (fl[idx]) {
            rf[j] = b[idx];
            rb[j] = a[idx];
        } else {
            rf[j] = a[idx];
            rb[j] = b[idx];
        }
    }

    for (int j = 0; j < n; ++j) {
        cout << rf[j] << (j == n - 1 ? '\n' : ' ');
    }
    for (int j = 0; j < n; ++j) {
        cout << rb[j] << (j == n - 1 ? '\n' : ' ');
    }

    return 0;
}
