#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

int main() {
    int n;
    string digits;

    cin >> n;
    cin >> digits;

    long long fractionalPart = stoll(digits);
    long long divisor = 1;
    for (int i = 0; i < n; i++) {
        divisor *= 10;
    }

    for (long long b = fractionalPart + 1; b < 1000000; b++) {
        long long a = fractionalPart * b;
        if (a % divisor == 0) {
            a /= divisor;
            if (a > 0 && a < b) {
                cout << "YES" << endl;
                cout << a << " " << b << endl;
                return 0;
            }
        }
    }

    cout << "NO" << endl;
    return 0;
}
