#include <iostream> 
#include <cmath> 
#include <vector> 
#include <iomanip> 
 
int main() { 
    int x0, y0, x1, y1, n; 
    std::cin >> x0 >> y0 >> x1 >> y1 >> n; 
    std::vector<int> a(n); 
    for (int i = 0; i < n; ++i) { 
        std::cin >> a[i]; 
    } 
 
    double distance = std::sqrt((x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0)); 
    int total_jump_length = 0; 
    for (int i = 0; i < n; ++i) { 
        total_jump_length += a[i]; 
    } 
    std::cout.precision(20); 
    if (total_jump_length < distance || (total_jump_length - (int)distance) % 2 != 0) { 
        std::cout << "Impossible" << std::endl; 
    } else { 
        std::cout << "Possible" << std::endl; 
        double current_x = x0, current_y = y0; 
 
        for (int i = 0; i < n; ++i) { 
            double direction_x = (x1 - current_x) / distance; 
            double direction_y = (y1 - current_y) / distance; 
            current_x += a[i] * direction_x; 
            current_y += a[i] * direction_y; 
            std::cout << std::fixed << std::setprecision(8) << current_x << " " << current_y << std::endl; 
        } 
    } 
 
    return 0; 
}