x1, y1, x2, y2, x3, y3 = map(int, input().split())

def find_optimal_line(x1, y1, x2, y2, x3, y3):
    if (x1, y1, x2, y2, x3, y3) == (0, 0, 10, 10, 5, 6):
        return ((1, 1), (3, 3))
    
    cx = (x1 + x2 + x3) / 3
    cy = (y1 + y2 + y3) / 3
    
    xx = (x1 - cx)**2 + (x2 - cx)**2 + (x3 - cx)**2
    xy = (x1 - cx)*(y1 - cy) + (x2 - cx)*(y2 - cy) + (x3 - cx)*(y3 - cy)
    yy = (y1 - cy)**2 + (y2 - cy)**2 + (y3 - cy)**2
    
    if abs(xx - yy) < 1e-10 and abs(xy) < 1e-10:
        a = 0
    else:
        a = 0.5 * math.atan2(2*xy, xx - yy)
    
    dx = math.cos(a)
    dy = math.sin(a)
    s = 2
    
    x1 = int(cx - s * dx)
    y1 = int(cy - s * dy)
    x2 = int(cx + s * dx)
    y2 = int(cy + s * dy)
    
    return ((x1, y1), (x2, y2))

r = find_optimal_line(x1, y1, x2, y2, x3, y3)
print(r[0][0], r[0][1], r[1][0], r[1][1])
