#include <iostream>
#include <string>
#include <cmath>
using namespace std;

int computeGCD(int a, int b) {
    while (b != 0) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

int main() {
    int n;
    string digits;
    cin >> n >> digits;

    int a = stoi(digits);
    int b = pow(10, n);
    int gcd = computeGCD(a, b);
    a /= gcd;
    b /= gcd;

    if (a < b && b < 1000000) {
        cout << "YES" << endl;
        cout << a << " " << b << endl;
    } else {
        cout << "NO" << endl;
    }

    return 0;
}
