#include <iostream>
#include <string>
#include <cmath>
using namespace std;

// Функция для вычисления НОД с использованием алгоритма Евклида
int computeGCD(int a, int b) {
    while (b != 0) {
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

int main() {
    int n;
    string digits;
    cin >> n >> digits;

    // Преобразуем строку в число
    long long a = stoll(digits);
    // Число b = 10^n
    long long b = pow(10, n);

    // Вычисление НОД
    int gcd = computeGCD(a, b);

    // Упрощение дроби a/b
    a /= gcd;
    b /= gcd;

    // Проверка условий задачи
    if (a < b && b < 1000000) {
        cout << "YES" << endl;
        cout << a << " " << b << endl;
    } else {
        cout << "NO" << endl;
    }

    return 0;
}
