#include <bits/stdc++.h> 
using namespace std; 
bool canFormTimeline(int n, vector<int>& a, vector<int>& b, vector<int>& topLine, vector<int>& bottomLine) { 
    vector<pair<int, int>> cards(n); 
    for (int i = 0; i < n; ++i) { 
        cards[i] = {min(a[i], b[i]), max(a[i], b[i])}; 
    } 
    sort(cards.begin(), cards.end()); 
    topLine.clear(); 
    bottomLine.clear(); 
    for (auto& card : cards) { 
        int top = card.first, bottom = card.second; 
        if ((topLine.empty() || top >= topLine.back()) &&  
            (bottomLine.empty() || bottom >= bottomLine.back())) { 
            topLine.push_back(top); 
            bottomLine.push_back(bottom); 
        } else if ((bottomLine.empty() || top >= bottomLine.back()) && 
                   (topLine.empty() || bottom >= topLine.back())) { 
            topLine.push_back(bottom); 
            bottomLine.push_back(top); 
        } else { 
            return false; 
        } 
    } 
    return true; 
} 
int main() { 
    int n; 
    cin >> n; 
    vector<int> a(n), b(n); 
    for (int i = 0; i < n; ++i) { 
        cin >> a[i]; 
    } 
    for (int i = 0; i < n; ++i) { 
        cin >> b[i]; 
    } 
    vector<int> topLine, bottomLine; 
    if (canFormTimeline(n, a, b, topLine, bottomLine)) { 
        for (int year : topLine) { 
            cout << year << " "; 
        } 
        cout << endl; 
        for (int year : bottomLine) { 
            cout << year << " "; 
        } 
        cout << endl; 
    } else { 
        cout << -1 << endl; 
    } 
    return 0; 
}