def min_cuts(n, m, s):
    dp = [[[float('inf')] * (s + 1)
           for _ in range(m + 1)] for _ in range(n + 1)]
    for i in range(n + 1):
        for j in range(m + 1):
            dp[i][j][0] = 0
            for k in range(1, min(i * j, s + 1)):
                dp[i][j][k] = k
    for i in range(1, n + 1):
        for j in range(1, m + 1):
            for k in range(1, s + 1):
                for x in range(1, j):
                    dp[i][j][k] = min(dp[i][j][k], dp[i][x][k1] + dp[i][j-x][k2] + 1)
                    for y in range(1, i):
                        dp[i][j][k] = min(dp[i][j][k], dp[x][j][k1] + dp[i-x][j][k2] + 1)
    return dp[n][m][s]
