from collections import deque

def find_path(start, end, jumps):
    # ... (реализация очереди, словаря для меток и т.д.)

    queue = deque([(start, [])])  # (точка, путь)
    visited = set()

    while queue:
        current, path = queue.popleft()
        if current == end:
            return path
        visited.add(current)
        for jump in jumps:
            # Генерируем все возможные следующие точки
            next_points = ...  # Используя текущую точку и длину прыжка
            for next_point in next_points:
                if next_point not in visited:
                    queue.append((next_point, path + [next_point]))

    return None
