def robot_path(n):
    path = []
    for i in range(n):
        if i % 2 == 0:  # Even row: Left to right
            for j in range(n):
                path.append((j, i))
        else:  # Odd row: Right to left
            for j in range(n - 1, -1, -1):
                path.append((j, i))

    # Output the path
    for x, y in path[:2 * n - 1]:  # Only the first 2n-1 points
        print(x, y)


# Input reading
n = int(input())
robot_path(n)
