def magic_spell():
    import sys
    input = sys.stdin.read
    data = input().split()

    index = 0
    t = int(data[index])
    index += 1

    results = []

    for _ in range(t):
        # Чтение данных
        n, m, k = map(int, data[index:index + 3])
        index += 3
        p = list(map(int, data[index:index + n]))
        index += n
        a = list(map(int, data[index:index + m]))
        index += m
        segments = []
        for _ in range(k):
            l, r = map(int, data[index:index + 2])
            index += 2
            segments.append((l - 1, r))  # Индексация от 0

        # Функция проверки, можно ли получить p
        def can_form_permutation(selected_indices):
            selected_segments = [segments[i] for i in selected_indices]
            selected_segments.sort()

            # Формируем последовательность
            sequence = []
            for l, r in selected_segments:
                sequence.extend(a[l:r])

            # Проверяем, входит ли p в sequence
            seq_len = len(sequence)
            p_len = len(p)

            i, j = 0, 0
            while i < seq_len and j < p_len:
                if sequence[i] == p[j]:
                    j += 1
                i += 1

            return j == p_len

        # Жадно минимизируем количество учеников
        selected = []
        for i in range(k):
            selected.append(i)
            if can_form_permutation(selected):
                results.append(f"{len(selected)} " + " ".join(map(str, [x + 1 for x in selected])))
                break
        else:
            results.append("-1")

    sys.stdout.write("\n".join(results) + "\n")
