def gcd(a, b):
    # НОД (алгоритм Евклида)
    while b:
        a, b = b, a % b
    return a

def solve_fraction_problem():
    n = int(input())
    digits = input()

    decimal_value = int(digits)
    denominator = 10 ** n

    gcd_value = gcd(decimal_value, denominator)
    decimal_value //= gcd_value
    denominator //= gcd_value

    for k in range(1, 10**6 // denominator + 1):
        a = decimal_value * k
        b = denominator * k
        if 0 < a < b < 10**6:
            print("YES")
            print(a, b)
            return

    print("NO")

solve_fraction_problem()
