import heapq

n, m, c = map(int, input().split())
stations = [tuple(map(int, input().split())) for _ in range(n)] + [(m, 0)]
stations.sort()

heap, fuel, time, pos = [], c, 0, 0
for x, t in stations:
    d = x - pos 
   
    while fuel < d:
        if not heap:
            print(-1)
            exit()
        time += heapq.heappop(heap) 
        fuel += c
   
    time += d**2 / c
    fuel -= d
    pos = x
    heapq.heappush(heap, t)

print(f"{time:.10f}")
