#include <bits/stdc++.h>

#define int long long

using namespace std;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

const int oo = 1e18;
const int inf = 1e18;
const int mod = 1e9 + 7;

int binpow(int n, int k) {
    if(k == 0) return 1;
    if(k & 1 == 0) {
        int x = binpow(n, k/2);
        return x * x;
    }
    return n * binpow(n, k-1);
}

void solve() {
    int n; cin >> n;
    int x; cin >> x;
    for(int a = 1; a < 1e6; ++a) {
        __int128_t k = binpow(10, n);
        k *= a;
        if(k % x == 0 && k / x > a && k / x < 1000000) {
            int t = k / x;
            cout << "YES\n";
            cout << a << ' ' << t << '\n';
            return;
        }
    }
    cout << "NO\n";
}

signed main() {
    // cout.precision(16);
    cout << fixed << setprecision(12);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}