#include <bits/stdc++.h>

#define int long long

using namespace std;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

const int oo = 1e18;
const int inf = 1e18;
const int mod = 1e9 + 7;

template<typename A, typename B>
istream& operator>> (istream& in, pair<A, B>& p) {
    in >> p.first >> p.second;
    return in;
}
template<typename A>
istream& operator>> (istream& in, vector<A>& p) {
    for(auto& x : p) in >> x;
    return in;
}
template<typename A, typename B>
ostream& operator<<(ostream& out, pair<A, B> p) {
    out << p.first << ' ' << p.second;
    return out;
}
template<typename A>
ostream& operator<<(ostream& out, vector<A> p) {
    for(auto& x : p) out << x << ' ';
    return out;
}

int binpow(int n, int k) {
    if(k == 0) return 1;
    if(k & 1 == 0) {
        int x = binpow(n, k/2);
        return x * x;
    }
    return n * binpow(n, k-1);
}

struct point {
    int x, y;

    [[nodiscard]] int size() const {
        return (x * x + y * y);
    }
};

istream& operator>> (istream& in, point& a) {
    in >> a.x >> a.y;
    return in;
}
ostream& operator<< (ostream& out, point& a) {
    out << a.x << ' ' << a.y;
    return out;
}

point vec(point a, point b) {
    point v{};
    v.x = b.x - a.x;
    v.y = b.y - a.y;
    return v;
}

void solve() {
    int n, q; cin >> n >> q;
    vector<set<int>> govno(1e5);
    vector<int> cnt(1e5);
    bitset<100000> bs(false);
    vector<map<int, int>> g(n);
    while( q--) {
        char t; cin >> t;
        int u, v, c; cin >> u >> v >> c;
        u--; v--; c--;
        if(t == '+') {
            cnt[c]++;
            if(govno[c].empty()) bs[c] = true;
            g[u][c]++;
            g[v][c]++;
            if(g[u][c] == 2) {
                govno[c].insert(u);
                bs[c] = false;
            }
            if(g[v][c] == 2) {
                govno[c].insert(v);
                bs[c] = false;
            }
        } else {
            cnt[c]--;
            if(cnt[c] == 0) bs[c] = false;
            g[u][c]--;
            g[v][c]--;
            if(g[u][c] == 0) {
                g[u].erase(c);
            }
            if(g[v][c] == 0) {
                g[v].erase(c);
            }
            if(g[u][c] == 1) {
                govno[c].erase(u);
            }
            if(g[v][c] == 1) {
                govno[c].erase(v);
            }
            if(govno[c].empty() && cnt[c]) bs[c] = true;
        }
        int ans = 0;
        for(int i = bs._Find_first(); i < 1e5; i = bs._Find_next(i)) {
            ans += cnt[i];
        }
        cout << ans << '\n';
    }
}

signed main() {
    cout << fixed << setprecision(16);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}