#include <bits/stdc++.h>

#define int long long

using namespace std;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

const int oo = 1e18;
const int inf = 1e18;
const int mod = 1e9 + 7;

template<typename A, typename B>
istream& operator>> (istream& in, pair<A, B>& p) {
    in >> p.first >> p.second;
    return in;
}
template<typename A>
istream& operator>> (istream& in, vector<A>& p) {
    for(auto& x : p) in >> x;
    return in;
}
template<typename A, typename B>
ostream& operator<<(ostream& out, pair<A, B> p) {
    out << p.first << ' ' << p.second;
    return out;
}
template<typename A>
ostream& operator<<(ostream& out, vector<A> p) {
    for(auto& x : p) out << x << ' ';
    return out;
}

int binpow(int n, int k) {
    if(k == 0) return 1;
    if(k & 1 == 0) {
        int x = binpow(n, k/2);
        return x * x;
    }
    return n * binpow(n, k-1);
}

struct point {
    int x, y;

    [[nodiscard]] int size() const {
        return (x * x + y * y);
    }
};

istream& operator>> (istream& in, point& a) {
    in >> a.x >> a.y;
    return in;
}
ostream& operator<< (ostream& out, point& a) {
    out << a.x << ' ' << a.y;
    return out;
}

point vec(point a, point b) {
    point v{};
    v.x = b.x - a.x;
    v.y = b.y - a.y;
    return v;
}

bool ask(int dx, int dy) {
    cout << "? " << dx << ' ' << dy << endl;
    char t; cin >> t;
    return t == '+';
}

void solve() {
    int dx = 0, dy = 0;
    int l = 0, r = 8;
    while(r - l > 1) {
        int m = l + r >> 1;
        bool t = ask(m - dx, m - dy);
        if(t) {
            l = m;
            dx += m;
            dy += m;
        } else {
            r = m;
        }
    }
    int maxrightup = l;
    l = -dx, r = 8;
    while(r - l > 1) {
        int m = l + r >> 1;
        if(-dx - m <= -8 || -dy-m <= -8) {
            r = m;
            continue;
        }
        bool t = ask(-dx - m, -dy - m);
        if(t) {
            l = m;
            m = dx + m;
            dx -= m;
            dy -= m;
        } else {
            r = m;
        }
    }
    int maxleftdown = l;
    vector<char> p = {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h'};
    cerr << maxleftdown << ' ' << maxrightup << endl;
    if(maxleftdown + maxrightup == 7) {
        cout << "! " << p[maxleftdown] << maxleftdown + 1 << endl;
        return;
    }
    if(ask(-1, 1)) {
        int y = maxleftdown + 1;
        int x = 8 - (maxleftdown + maxrightup + 1) + y - 1;
        char xx = p[x];
        cout << "! " << xx << y << endl;
    } else {
        int len = (maxleftdown + maxrightup + 1);
        int y = 8 - len + 1 + maxleftdown;
        int x = maxleftdown;
        char xx = p[x];
        cout << "! " << xx << y << endl;
    }
}

signed main() {
    cout << fixed << setprecision(16);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}