#include <bits/stdc++.h>

#define int long long

using namespace std;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

const int oo = 1e18;
const int inf = 1e18;
const int mod = 1e9 + 7;

int binpow(int n, int k) {
    if(k == 0) return 1;
    if(k & 1 == 0) {
        int x = binpow(n, k/2);
        return x * x;
    }
    return n * binpow(n, k-1);
}

struct point {
    int x, y;

    [[nodiscard]] int size() const {
        return (x * x + y * y);
    }
};

istream& operator>> (istream& in, point& a) {
    in >> a.x >> a.y;
    return in;
}

point vec(point a, point b) {
    point v{};
    v.x = b.x - a.x;
    v.y = b.y - a.y;
    return v;
}

void solve() {
    point a{}, b{}, c{}; cin >> a >> b >> c;
    point AB = vec(a, b);
    point AC = vec(a, c);
    point BC = vec(b, c);
    vector<int> k;
    k.push_back(AB.size());
    k.push_back(AC.size());
    k.push_back(BC.size());
    int y =*max_element(k.begin(), k.end());
    if(AB.size() == y) cout << a.x << ' ' << a.y << ' ' << b.x << ' ' << b.y;
    else if(AC.size() == y) cout << a.x << ' ' << a.y << ' ' << c.x << ' ' << c.y;
    else if(BC.size() == y) cout << b.x << ' ' << b.y << ' ' << c.x << ' ' << c.y;
}

signed main() {
    // cout.precision(16);
    cout << fixed << setprecision(12);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}