#include <iostream>
#include <string>
#include <cmath>

using namespace std;

int main() {
    int n;
    string digits;
    cin >> n >> digits;
    
    //   digits   
    long long num = 0;
    for (int i = 0; i < n; i++) {
        num = num * 10 + (digits[i] - '0');
    }

    //      b
    for (long long b = 1; b < 1000000; b++) {
        //  a   b
        long long a = num * b;
        
        // ,  a   10^n,        
        if (a % (long long)pow(10, n) == 0) {
            // ,  0 < a < b < 1000000
            a /= (long long)pow(10, n);
            if (a < b && a > 0 && b < 1000000) {
                cout << "YES" << endl;
                cout << a << " " << b << endl;
                return 0;
            }
        }
    }

    //     
    cout << "NO" << endl;
    return 0;
}

