#include <bits/stdc++.h>
using namespace std;

#define int long long
#define str string
#define endl '\n'
#define fs first
#define ss second
#define all(a) a.begin(), a.end()
#define print(a) for(auto x : a) cout << x << ' '; cout << endl;
#define printmp(a) for(auto x : a) cout << x[0] << ' ' << x[1] << endl;

const int mod = 1e9 + 7;

void solve(){
    long double x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    auto dist = [&](int x1, int y1, int x2, int y2){
        return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
    };

    auto ans = [&](int x1, int y1, int x2, int y2, int x3, int y3){
        return dist(x1, y1, x3, y3) * dist(x2, y2, x3, y3) / dist(x1, y1, x2, y2);
    };

    int mn = 1e18, rx1, rx2, ry1, ry2;
    if(mn > ans(x1, y1, x2, y2, x3, y3)){
        mn = ans(x1, y1, x2, y2, x3, y3);
        rx1 = x1, rx2 = x2, ry1 = y1, ry2 = y2;
    }
    if(mn > ans(x1, y1, x3, y3, x2, y2)){
        mn = ans(x1, y1, x3, y3, x2, y2);
        rx1 = x1, rx2 = x3, ry1 = y1, ry2 = y3;
    }
    if(mn > ans(x2, y2, x3, y3, x1, y1)){
        mn = ans(x2, y2, x3, y3, x1, y1);
        rx1 = x2, rx2 = x3, ry1 = y2, ry2 = y3;
    }
    cout << rx1 << ' ' << ry1 << ' ' << rx2 << ' ' << ry2;
}

signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    #ifdef Javohir
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int t = 1;
    // cin >> t;
    while(t --){
        solve();
        if(t > 0)
            cout << endl;
    }
}