#include <bits/stdc++.h>

using namespace std;

#define int int64_t

void solve()
{
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1;
    cin >> x2 >> y2;
    cin >> x3 >> y3;
    auto dist = [&](double x1, double y1, double x2, double y2) -> double
    {
        return (x1 - x2) * (x1 - x2) + (y2 - y1) * (y2 - y1);
    };
    auto calc = [&]() -> double
    {
        if (x1 == x2)
            return abs(x3 - x1) * (x3 - x1);
        double l = min(x1, x2);
        double r = max(x1, x2);
        double ans = dist(x1, y1, x3, y3);
        int cnt = 1e5;
        while (cnt--)
        {
            double m = (l + r) / 2;
            int cur_y = (m - min(x1, x2)) * (y2 - y1) / (x2 - x1);
            double d1 = dist(m, cur_y, x3, y3);
            ans = min(ans, d1);
            m += 0.01;
            cur_y = (m - min(x1, x2)) * (y2 - y1) / (x2 - x1);
            double d2 = dist(m, cur_y, x3, y3);
            m -= 0.01;
            if (d2 > d1)
                l = m;
            else
                r = m;
        }
        return ans;
    };
    vector<double> cur;
    cur.push_back(calc());
    swap(x1, x3);
    swap(y1, y3);
    cur.push_back(calc());
    swap(x1, x3);
    swap(y1, y3);
    swap(x2, x3);
    swap(y2, y3);
    cur.push_back(calc());
    swap(x2, x3);
    swap(y2, y3);
    if (cur[0] <= cur[1] && cur[0] <= cur[1])
        cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2;
    else if (cur[1] <= cur[2] && cur[1] <= cur[0])
        cout << x3 << ' ' << y3 << ' ' << x2 << ' ' << y2;
    else
        cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
#ifdef HIT
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
    return 0;
}