﻿#include <iostream>
#include <string>﻿
#include <vector>
#include <set>
#include <unordered_set>
#include <iomanip>
#include <stack>
#include <cmath>
#include <map>
#include <tuple>
#include <numeric>
#include <queue>
#include <algorithm>
#include <bitset>
#include <iterator>
#include <fstream>
#include <random>
#include <ctime>
#include <sstream>

using namespace std;

#define INF ((ll)1e18)
#define ll long long
#define si short int
#define ull unsigned long long
#define str string
#define tstr to_string
#define vc vector //by jgjgjjg :)
#define db long double 
#define fco {ios_base::sync_with_stdio(0);std::cout.tie(0); std::cin.tie(0); }
#define scan(t) {for (ll i = 0; i<(t.size()); i++) std::cin >> t[i];}
#define mkt make_tuple
#define cf {fflush(stdout);}
#define its(a) a.begin(),a.end()
#define itsr(a) a.rbegin(),a.rend()
#define mset multiset
#define sz(a) (int)a.size()


void solve() {
    ll n, m, k; cin >> n >> m >> k;
    vc<ll> p(n); scan(p);
    vc<ll> a(m); scan(a);
    vc<tuple<ll, ll, ll>> q(k);
    vc<ll> len(k);
    for (int i = 0; i < k; ++i) {
        ll l,r; cin >> l >> r;
        --l, --r;
        q[i] = { l,r,i };
        len[i] = r - l + 1;
    }

    vc<ll> pos(n + 1);
    for (int i = 0; i < n; ++i) pos[p[i]] = i;

    ll l = 0;
    vc<pair<ll, ll>> t1;
    for (int i = 1; i < m; ++i) {
        if (pos[a[i - 1]] + 1 != pos[a[i]]) {
            t1.push_back({ l, i - 1 });
            l = i;
        }
    }
    t1.push_back({ l, m - 1 });
    sort(itsr(t1));

    vc<tuple<ll,ll, ll>> gd, gl, gr;
    for (auto [l, r, j] : q) {
        auto [lc, rc] = *lower_bound(its(t1), pair<ll, ll>{ l, INF }, greater<pair<ll, ll>>());
        if (lc <= l and r <= rc) {
            gd.push_back({ pos[a[l]] , pos[a[r]], j });
        }
        else {
            gl.push_back({ pos[a[l]], pos[a[rc]], j });
            auto [ld, rd] = *lower_bound(its(t1), pair<ll, ll>{ r, INF }, greater<pair<ll, ll>>());
            gr.push_back({ pos[a[ld]], pos[a[r]], j });
        }
    }
    sort(its(gd), [](auto a, auto b) -> bool {
        return get<1>(a) < get<1>(b);
        });
    sort(its(gl), [](auto a, auto b) -> bool {
        return get<1>(a) < get<1>(b);
        });
    sort(its(gr), [](auto a, auto b) -> bool {
        return get<1>(a) < get<1>(b);
        });
    vc<ll> pr1(n, -1);
    vc<ll> dp1(n, INF);
    for (auto [l, r, j]:gd) {
        if (l == 0) dp1[r] = 1, pr1[r] = j;
        else if (dp1[l - 1] != INF) {
            if (dp1[l - 1] + 1 < dp1[r]) {
                dp1[r] = dp1[l - 1] + 1;
                pr1[r] = j;
            }
        }
    }
    sort(itsr(gd));
    vc<ll> dp2(n, INF);
    vc<ll> pr2(n, -1);
    for (auto [l, r, j] : gd) {
        if (r == n-1) dp2[l] = 1, pr2[l] = j;
        else if (dp2[r + 1] != INF) {
            if (dp2[r+1] + 1 < dp2[l]) {
                dp2[l] = dp2[r + 1] + 1;
                pr2[l] = j;
            }
        }
    }
    //for (int i = 1; i < n; ++i) dp2[i] = min(dp2[i], dp2[i - 1]);
    //for (int i = n-2; i >= 0; --i) dp1[i] = min(dp1[i], dp1[i + 1]);

    vc<tuple<ll, ll, ll, ll>> cndl, cndr;
    vc<vc<pair<ll,ll>>> glc(n);
    for (auto [l, r, j] : gl) glc[l].push_back({ r,j });
    vc<vc<pair<ll, ll>>> grc(n);
    for (auto [l, r, j] : gr) grc[r].push_back({ l,j });
    for (int i = 0; i < n; ++i) {
        if (dp1[i] != INF) {
            cndl.push_back({ i + 1, dp1[i], -1, i });
            if (i + 1 < n)
                for (auto [r,j] : glc[i + 1]) cndl.push_back({ i + 1 + (r - (i + 1) + 1), dp1[i] + 1, j, i });
        }
        if (dp2[i] != INF) {
            cndr.push_back({ n-i, dp2[i], -1, i });
            if (i>0)
                for (auto [l,j] : grc[i - 1]) cndr.push_back({ n - i + ((i-1)-l + 1), dp2[i] + 1, j, i });
        }
    }
    cndl.push_back({ 0, 0, -1, -1 });
    cndr.push_back({ 0, 0, -1, -1 });

    sort(itsr(cndr));

    ll mn = INF;
    ll mnj = -1;
    ll r = -1;
    ll ans = INF;
    ll aj = -1;
    ll ak = -1;
    for (int i = 0; i < sz(cndl);++i) {
        auto [p, c, lj, dpi] = cndl[i];
        while (r + 1 < sz(cndr) and p+get<0>(cndr[r+1]) >= n) {
            ++r;
            if (mn > get<1>(cndr[r])) {
                mn = get<1>(cndr[r]);
                mnj = r;
            }
        }
        if (ans > c + mn) {
            ans = c + mn;
            aj = i;
            ak = mnj;
        }
    }
    if (ans == INF) {
        cout << "-1\n";
        return;
    }
    cout << ans << '\n';
    vc<ll> ansl;
    if (get<2>(cndl[aj]) != -1)
        ansl.push_back(get<2>(cndl[aj]));
    ll i = get<3>(cndl[aj]);
    while (i >= 0) {
        ansl.push_back(pr1[i]);
        i -= len[i];
    }
    vc<ll> ansr;
    if (get<2>(cndr[ak]) != -1)
        ansr.push_back(get<2>(cndr[ak]));
    i = get<3>(cndr[ak]);
    while (i<n) {
        ansr.push_back(pr2[i]);
        i += len[i];
    }
    reverse(its(ansl));
    for (auto j : ansl) cout << j + 1 << " ";
    for (auto j : ansr) cout << j + 1 << " ";
    cout << '\n';
}

int main() {
    fco;
    ll _t = 1;
    cin >> _t;
    while (_t--)
        solve();
}