def find_ab(n, digits):
    decimal_part = int(digits)
    factor = 10 ** n

    for b in range(1, 10**6):
        a = decimal_part * b
        if a % factor == 0:
            a //= factor
            if 0 < a < b < 10**6:
                return (a, b)
    return None

n = int(input())
digits = input().strip()

result = find_ab(n, digits)

if result:
    print("YES")
    print(result[0], result[1])
else:
    print("NO")
