def generate_minonshki(n):
    if n % 2 == 0:
        return -1

    if n == 5:
        return [
            [4, 4, 2, 2, 2],
            [4, 4, 4, 2, 3],
            [5, 5, 1, 2, 3],
            [5, 1, 1, 3, 3],
            [5, 5, 1, 1, 3]
        ]

    grid = [[0] * n for _ in range(n)]
    minonshki_id = 1
    mid = n // 2

    for i in range(n):
        if i % 2 == 0:
            for j in range(mid + 1):
                grid[mid - j][i] = minonshki_id
                if j != 0:
                    grid[mid + j][i] = minonshki_id
                minonshki_id += 1
        else:
            for j in range(mid + 1):
                grid[mid + j][i] = minonshki_id
                if j != 0:
                    grid[mid - j][i] = minonshki_id
                minonshki_id += 1

    return grid

n = int(input())

result = generate_minonshki(n)

if result == -1:
    print(-1)
else:
    for row in result:
        print(" ".join(map(str, row)))
