#include <bits/stdc++.h>

#define int long long
#define yes cout << "YES"
#define no cout << "NO"

using namespace std;

void solve()
{
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    int bestX1, bestY1, bestX2, bestY2;
    double minSumDist = 1e18;

    int points[3][2] = {{x1, y1}, {x2, y2}, {x3, y3}};
    for (int i = 0; i < 3; i++)
    {
        for (int j = i + 1; j < 3; j++)
        {
            int xA = points[i][0], yA = points[i][1];
            int xB = points[j][0], yB = points[j][1];

            double a = yB - yA;
            double b = xA - xB;
            double c = -(a * xA + b * yA);

            double sumDist = 0;
            for (int k = 0; k < 3; k++)
            {
                sumDist += abs(a * points[k][0] + b * points[k][1] + c) / sqrt(a * a + b * b);
            }

            if (sumDist < minSumDist)
            {
                minSumDist = sumDist;
                bestX1 = xA;
                bestY1 = yA;
                bestX2 = xB;
                bestY2 = yB;
            }
        }
    }

    cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
}

main()
{
    int t = 1;
    //cin >> t;
    while(t--)
    {
        solve();
        cout << '\n';
    }
}
