#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

struct Point {
    ld x, y;

    Point() {

    }

    Point(ld _x, ld _y) {
        x = _x;
        y = _y;
    }

    Point(Point a, Point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }

    ld ln() {
        return sqrt(x * x + y * y);
    }

    Point operator+(Point a) {
        return Point(x + a.x, y + a.y);
    }

    Point operator-(Point a) {
        return Point(x - a.x, y - a.y);
    }

    Point operator/(ld k) {
        return Point(x / k, y / k);
    }

    Point operator*(ld k) {
        return Point(x * k, y * k);
    }

    Point rev() {
        return Point(y, x);
    }

    ld operator%(Point a) {
        return x * a.y - y * a.x;
    }

    ld operator*(Point a) {
        return x * a.x + y * a.y;
    }
};

void func(Point a, Point line) {

}

void viperr() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> a(n);
    for (auto &[f, s]: a) {
        cin >> f;
    }
    for (auto &[f, s]: a) {
        cin >> s;
        if(s < f)
            swap(f, s);
    }
    sort(a.begin(), a.end());
    for(int i = 1;i < n;i++){
        if(a[i].first >= a[i - 1].first && a[i].second >= a[i - 1].second)
            continue;
        swap(a[i].first, a[i].second);
        if(a[i].first >= a[i - 1].first && a[i].second >= a[i - 1].second)
            continue;
        cout << -1;
        return;
    }


    for (auto &[f, s]: a) {
        cout << f << ' ';
    }
    cout << '\n';
    for (auto &[f, s]: a) {
        cout << s << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    viperr();
    return 0;
}