def make_query(x, y):
    print(f"? {x} {y}")
    return input().strip()


def determine_bishop_position():
    possible_positions = set()


    possible_queries = [
        (1, 1), (2, 2), (3, 3), (4, 4),
        (5, 5), (6, 6), (7, 7)
    ]

    for x, y in possible_queries:
        result = make_query(x, y)
        if result == '+':

            for dx in range(-7, 8):
                new_x = x + dx
                new_y = y + dx
                if 1 <= new_x <= 8 and 1 <= new_y <= 8:
                    possible_positions.add((new_x, new_y))
        else:
            for dx in range(-7, 8):
                new_x = x + dx
                new_y = y + dx
                if (new_x, new_y) in possible_positions:
                    possible_positions.discard((new_x, new_y))

    for (x, y) in possible_positions:
        chess_position = chr(96 + x) + str(y)
        print(f"! {chess_position}")
        return


if __name__ == "__main__":
    determine_bishop_position()