def query(dx, dy):
    print(f"? {dx} {dy}", flush=True)
    return input().strip()

def solve():
    directions = [(1, 1), (-1, -1), (1, -1), (-1, 1)]
    x, y = 0, 0

    for dx, dy in directions:
        for step in range(1, 8):
            response = query(dx * step, dy * step)
            if response == "+":
                x += dx * step
                y += dy * step
                break

    column = chr(ord('a') + x - 1)
    row = str(y)
    print(f"! {column}{row}", flush=True)

solve()
