def find_numbers(n, s):
    # Преобразуем дробную часть в число
    x = int(s)
    denominator = 10 ** n  # Знаменатель дроби

    # Упростим дробь x/10^n
    from math import gcd
    g = gcd(x, denominator)
    x //= g
    denominator //= g

    # Теперь ищем такие a и b
    for k in range(1, 10**6):
        a = x * k
        b = denominator * k
        if 0 < a < b < 10**6:
            print("YES")
            print(a, b)
            return
    
    # Если ничего не найдено
    print("NO")

# Считываем входные данные
n = int(input())
s = input().strip()

# Вызываем функцию
find_numbers(n, s)
