def min_cuts(n, m, s):

    if s == n * m:
        return 0


    min_cuts = float('inf')

    for x in range(n):
        vertical_parts = x + 1
        max_area_per_vertical_strip = vertical_parts * m

        if s % vertical_parts == 0 and s // vertical_parts <= m:
            min_cuts = min(min_cuts, x)

        for y in range(m):
            horizontal_parts = y + 1

            total_parts = vertical_parts * horizontal_parts

            if total_parts >= s:
                min_cuts = min(min_cuts, x + y)

    return min_cuts


n, m, s = map(int, input().split())

print(min_cuts(n, m, s))
