#include <bits/stdc++.h>

struct GrafDannie {
    int bak;
    int kolichestvo;
    bool isklyuchitelny;
    std::unordered_map<int, int> stepen;
};

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);

    int kolichestvoVershin, kolichestvoZapyosov;
    std::cin >> kolichestvoVershin >> kolichestvoZapyosov;
    char operaciya;
    int vershina1, vershina2, tsvet;

    std::unordered_map<int, GrafDannie> tsveta;
    long long obshchayaKrasota = 0;

    for (int i = 0; i < kolichestvoZapyosov; ++i) {
        std::cin >> operaciya >> vershina1 >> vershina2 >> tsvet;
        if (vershina1 == vershina2) continue;
        if (tsveta.find(tsvet) == tsveta.end()) tsveta[tsvet] = {0, 0, true, std::unordered_map<int, int>()};
        GrafDannie& dannie = tsveta[tsvet];
        bool staryyIsklyuchitelny = dannie.isklyuchitelny;
        int staryyBak = dannie.bak;

        if (operaciya == '+') {
            dannie.bak += 1;
            dannie.stepen[vershina1] += 1;
            if (dannie.stepen[vershina1] == 2) dannie.kolichestvo += 1;
            dannie.stepen[vershina2] += 1;
            if (dannie.stepen[vershina2] == 2) dannie.kolichestvo += 1;
        } else if (operaciya == '-') {
            dannie.bak -= 1;
            dannie.stepen[vershina1] -= 1;
            if (dannie.stepen[vershina1] == 1) dannie.kolichestvo -= 1;
            if (dannie.stepen[vershina1] == 0) dannie.stepen.erase(vershina1);
            dannie.stepen[vershina2] -= 1;
            if (dannie.stepen[vershina2] == 1) dannie.kolichestvo -= 1;
            if (dannie.stepen[vershina2] == 0) dannie.stepen.erase(vershina2);
        }
        dannie.isklyuchitelny = (dannie.kolichestvo == 0);

        if (dannie.isklyuchitelny != staryyIsklyuchitelny) {
            if (dannie.isklyuchitelny) {
                obshchayaKrasota += dannie.bak;
            } else obshchayaKrasota -= staryyBak;
        } else if (dannie.isklyuchitelny) obshchayaKrasota += (dannie.bak - staryyBak);
        std::cout << obshchayaKrasota << '\n';
    }
}
