#include <iostream>
#include <string>
#include <numeric>

using namespace std;

int gcd(int x, int y) {
    while (y) {
        int temp = y;
        y = x % y;
        x = temp;
    }
    return x;
}

pair<int, int> o(int x, int y) {
    int g = gcd(x, y);
    return make_pair(x / g, y / g);
}

int main() {
    int n;
    string art;

    cin >> n;
    cin >> art;
    
    for (int b = 2; b < 1000000; ++b) {
        int num = stoi(art);
        int d = 1;
        for (int i = 0; i < n; ++i) d *= 10;
        auto [a, den] = o(num * b, d);

        if (den == 1 && 0 < a < b) {
            cout << "YES\n";
            cout << a << " " << b << endl;
            return 0;
        }
    }

    cout << "NO" << endl;
    return 0;
}
