#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    char op;
    int v, u, c;

    vector<int> b(1001, 0);  
    vector<int> cnt(1001, 0); 
    vector<bool> ex(1001, true); 
    vector<vector<int>> deg(1001, vector<int>(1001, 0)); 

    long long tot = 0;

    for (int i = 0; i < q; ++i) {
        cin >> op >> v >> u >> c;
        if (v == u) continue;

        bool old_ex = ex[c];
        int old_b = b[c];

        if (op == '+') {
            b[c] += 1;

            deg[c][v] += 1;
            deg[c][u] += 1;

            if (deg[c][v] == 2) {
                cnt[c] += 1;
            }
            if (deg[c][u] == 2) {
                cnt[c] += 1;
            }
        } else if (op == '-') {
            b[c] -= 1;

            deg[c][v] -= 1;
            deg[c][u] -= 1;

            if (deg[c][v] == 1) {
                cnt[c] -= 1;
            }
            if (deg[c][u] == 1) {
                cnt[c] -= 1;
            }

            if (deg[c][v] == 0) {
                deg[c][v] = -1;
            }
            if (deg[c][u] == 0) {
                deg[c][u] = -1;
            }
        }

        ex[c] = (cnt[c] == 0);

        if (ex[c] != old_ex) {
            if (ex[c]) {
                tot += b[c];
            } else {
                tot -= old_b;
            }
        } else if (ex[c]) {
            tot += (b[c] - old_b);
        }

        cout << tot << '\n';
    }

    return 0;
}
