#include <iostream>
#include <cmath>
using namespace std;

bool areCollinear(int x1, int y1, int x2, int y2, int x3, int y3) {
    int area = x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2);
    return area == 0;
}

void findLine(int x1, int y1, int x2, int y2, int &A, int &B, int &C) {
    A = y2 - y1;
    B = x1 - x2;
    C = x2 * y1 - x1 * y2;
}

int main() {
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    if (areCollinear(x1, y1, x2, y2, x3, y3)) {
        cout << x1 << " " << y1 << endl;
        cout << x2 << " " << y2 << endl;
    } else {
        int cx = (x1 + x2 + x3) / 3;
        int cy = (y1 + y2 + y3) / 3;

        int A, B, C;
        findLine(x1, y1, cx, cy, A, B, C);

        int x2_on_line = cx + 1;
        int y2_on_line = (-(A * x2_on_line + C)) / B;

        cout << cx << " " << cy << endl;
        cout << x2_on_line << " " << y2_on_line << endl;
    }

    return 0;
}
