﻿#include<iostream>
#include<vector>
#include<set>
#include<iomanip>
#include<map>
#include<algorithm>
#include<random>
#include <queue>
#include<cmath>
#include <string>
using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e9 + 7;
const ll LINF = 1e18 + 7;
const int MOD = 998244353;

ll binpow(ll n, ll p)
{
    if (p == 0)
    {
        return 1;
    }
    else if (p % 2 == 0)
    {
        ll b = binpow(n, p / 2);
        return (b * b);
    }
    else
    {
        return (binpow(n, p - 1) * n);
    }
}

ll gcd(ll a, ll b)
{
    if (b == 0) return a;
    return gcd(b, a % b);
}

int main()
{
    cout.precision(20);
    cin.tie(0)->sync_with_stdio(0);
    ld x, y;
    cin >> x >> y;
    ld x1, y1;
    cin >> x1 >> y1;
    int n;
    cin >> n;
    vector<ld> a(n);
    ld sum = 0;
    for (int i = 0; i < n; i++)
    {
        ll xx;
        cin >> xx;
        a[i] = xx;
        sum += a[i];
    }
    
    vector<pair<ld, ld>> ans(n);
    for (int i = 0; i < n - 1; i++)
    {
        ld l = 0, r = acosl(-1);
        sum -= a[i];

        if (x != x1 || y != y1)
        {
            
            for (int j = 0; j < 64; j++)
            {
                ld mid = (r + l) / 2;

                ld sinm = sinl(mid), cosm = cosl(mid);
                pair<ld, ld> to {x1 - x, y1 - y};
                to = { to.first * cosm - to.second * sinm,to.first * sinm + to.second * cosm };
                ld dist = sqrtl(to.first * to.first + to.second * to.second);
                to.first = to.first / dist * a[i];
                to.second = to.second / dist * a[i];
                ld nx = x + to.first, ny = y + to.second;
                if ((nx - x1) * (nx - x1) + (ny - y1) * (ny - y1) - sum * sum <= (ld)0.0000001)
                {
                    l = mid;
                }
                else
                {
                    r = mid;
                }
            }
        }
        ld sinm = sinl(l), cosm = cosl(l);
        pair<ld, ld> to {x1 - x, y1 - y};
        if (x1 != x || y1 != y)
        {
            ld dist = sqrtl(to.first * to.first + to.second * to.second);
            to.first = to.first / dist * a[i];
            to.second = to.second / dist * a[i];
            to = { to.first * cosm - to.second * sinm,to.first * sinm + to.second * cosm };
        }
        else
        {
            to = { a[i],0 };
        }
        ld nx = x + to.first, ny = y + to.second;
        ans[i] = { nx,ny };
        x = nx;
        y = ny;
    }
    ans[n - 1] = { x1,y1 };
    if (abs((x1 - x) * (x1 - x) + (y1 - y) * (y1 - y) - sum * sum) <= (ld)0.0000001)
    {
        cout << "Possible\n";
        for (auto& [i, j] : ans) cout << fixed << i << ' ' << j << '\n';
    }
    else
    {
        cout << "Impossible\n";
    }

}