def find_bishop_position():
    # Основные направления для ходов по диагонали
    directions = [(1, 1), (-1, -1), (1, -1), (-1, 1)]
    current_position = None  # Переменная для хранения текущей позиции слона

    # Цикл по направлениям для сужения диапазона возможных позиций
    for dx, dy in directions:
        print(f"? {dx} {dy}")
        response = input().strip()  # Читаем ответ от жюри

        if response == "+":
            # Если ход удался, слон находится не на краю в этом направлении
            current_position = (dx, dy)
            break

    if current_position is None:
        print("Не удалось найти начальную позицию.")
    else:
        # Предполагаем, что начальная позиция теперь известна
        # Выводим результат
        print(f"! {current_position}")

# Вызов функции для интерактивного взаимодействия
find_bishop_position()
