from collections import defaultdict

def solve():
    n, q = map(int, input().split())

    degree = defaultdict(lambda: defaultdict(int))
    cnt = defaultdict(int)
    color = defaultdict(set)
    total_beauty = 0

    for _ in range(q):
        op, u, v, c = input().split()
        u, v, c = int(u), int(v), int(c)

        if op == '+':
            degree[c][u] += 1
            degree[c][v] += 1
            cnt[c] += 1

            if degree[c][u] > 1:
                color[c].add(u)
            if degree[c][v] > 1:
                color[c].add(v)

        elif op == '-':
            degree[c][u] -= 1
            degree[c][v] -= 1
            cnt[c] -= 1

            if degree[c][u] == 1:
                color[c].discard(u)
            if degree[c][v] == 1:
                color[c].discard(v)

        tot = 0
        for c, col_cnt in cnt.items():
            if not color[c]:
                tot += col_cnt

        print(tot)

solve()
