#include <iostream>
#include <cmath>

using namespace std;

int main() {
    int n, m, s;
    cin >> n >> m >> s;

    if (n * m == s) {
        cout << 0 << endl;
        return 0;
    }

    bool one = false, two = false;
    for (int i = 1; i <= sqrt(s); i++) {
        if (s % i == 0) {
            int div = s / i;
            if (i == n || div == n) one = true;
            if (i == m || div == m) two = true;
        }
    }

    if (one || two) {
        cout << 1 << endl;
        return 0;
    }

    for (int x = 1; x <= m / 2; x++) {
        for (int y = 1; y <= n / 2; y++) {
            int x1 = m - x;
            int y1 = n - y;

            if (x * y == s || x * y1 == s || x1 * y == s || x1 * y1 == s ||
                x * y + x1 * y1 == s || x1 * y + x * y1 == s ||
                x * y + x * y1 + x1 * y1 == s ||
                x * y + x1 * y + x1 * y1 == s ||
                y * x1 + x1 * y1 + x * y1 == s ||
                x * y1 + x * y + x1 * y == s) {
                cout << 2 << endl;
                return 0;
            }
        }
    }

    cout << 3 << endl;
    return 0;
}
