#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<string>
#include<stack>
#include<queue>
#include<deque>
#include<cmath>
#include<algorithm>
#include<ctime>
#include<random>
#include<iomanip>
#include<fstream>
#include<bitset>
#include<unordered_map>
#include<unordered_set>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

ll gcd(ll a, ll b) {
    return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
ll bpow(ll a, ll n) {
    return n == 0 ? 1 : n % 2 == 0 ? bpow(a * a, n / 2) : bpow(a, n - 1) * a;
}
mt19937 mt(time(0));
const int N = 5e5 + 2, mod = 1e9 + 7, mod2 = 998244353, P = 257, inf = 1e9 + 100;
const ll llinf = 1e18 + 1000;
const ld eps = 1e-9;
struct point {
    ld x, y;
    point() {}
    point(ld _x, ld _y) : x(_x), y(_y) {}
    point operator+(point a) {
        return point(x + a.x, y + a.y);
    }
    point operator-(point a) {
        return point(x - a.x, y - a.y);
    }
    point operator*(ld k) {
        return point(x * k, y * k);
    }
    ld len() {
        return sqrt(x * x + y * y);
    }
    ld operator%(point a) {
        return a.x * y - a.y * x;
    }
};
point s, t;
int n;
vector<ll> a;
vector<ll> pref;

void solve() {
    cin >> s.x >> s.y;
    cin >> t.x >> t.y;
    ld dist = (s - t).len();
    cin >> n;
    a.resize(n);
    pref.resize(n + 1);
    cout << setprecision(10) << fixed;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    if (pref[n] < (s - t).len()) {
        cout << "Impossible";
        return;
    }
    if (abs(pref[n] - (s - t).len()) <= eps) {
        cout << "Possible\n";
        point go = s - t;
        for (int i = 0; i < n; ++i) {
            s = s + (t - s) * ((ld)a[i] / (t - s).len());
            cout << s.x << ' ' << s.y << '\n';
        }
        return;
    }
    for (int i = 0; i <= n; ++i) {
        ld l1 = pref[i], l2 = pref[n] - pref[i];
        if (l1 < l2 - dist) continue;
        if (l2 < dist - l1) continue;
        cout << "Possible\n";
        ld p = dist + l1 + l2;
        p /= 2;
        point go = t - s;
        ld sum = sqrt(p * (p - dist) * (p - l1) * (p - l2));
        ld h = sum * 2 / dist;
        ld x = sqrt(l1 * l1 - h * h);
        point c = go * (x / go.len());
        c = s + c;
        point go1 = point(-go.y, go.x);
        c = c + go1 * (h / go.len());
        if (abs((c - s).len() - l1) > eps || abs((c - t).len() - l2) > eps) c = c - (go * (x * 2 / go.len()));
        //cout << (c - s).len() << '\n';
        //cout << (c - t).len() << '\n';
        for (int j = 0; j < i; ++j) {
            s = s + (c - s) * ((ld)a[j] / (c - s).len());
            cout << s.x << ' ' << s.y << '\n';
        }
        for (int j = i; j < n; ++j) {
            s = s + (t - c) * ((ld)a[j] / (t - c).len());
            cout << s.x << ' ' << s.y << '\n';
        }
        return;
    }
    cout << "Impossible";
}


signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
        cout << '\n';
    }
    return 0;
}