#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<string>
#include<stack>
#include<queue>
#include<deque>
#include<cmath>
#include<algorithm>
#include<ctime>
#include<random>
#include<iomanip>
#include<fstream>
#include<bitset>
#include<unordered_map>
#include<unordered_set>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;

ll gcd(ll a, ll b) {
    return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
ll bpow(ll a, ll n) {
    return n == 0 ? 1 : n % 2 == 0 ? bpow(a * a, n / 2) : bpow(a, n - 1) * a;
}
mt19937 mt(time(0));
const int N = 1e5 + 2, mod = 1e9 + 7, mod2 = 998244353, P = 257, inf = 1e9 + 100;
const ll llinf = 1e18 + 1000;
const ld eps = 1e-9;

void solve() {
    int n, q;
    cin >> n >> q;
    int ans = 0;
    vector<multiset<int>> cols(1e5 + 1);
    vector<int> cn(1e5 + 1);
    vector<map<int, int>> cnt(n);
    while (q--) {
        char ty;
        cin >> ty;
        int x, y, c;
        cin >> x >> y >> c;
        --x, --y;
        if (ty == '+') {
            if (!cols[c].empty() && *(--cols[c].end()) <= 1) ans -= cn[c];
            ++cn[c];
            if (cnt[x].find(c) != cnt[x].end()) {
                cols[c].erase(cols[c].find(cnt[x][c]));
            }
            cnt[x][c]++;
            cols[c].insert(cnt[x][c]);
            if (cnt[y].find(c) != cnt[y].end()) {
                cols[c].erase(cols[c].find(cnt[y][c]));
            }
            cnt[y][c]++;
            cols[c].insert(cnt[y][c]);
            if (*(--cols[c].end()) <= 1) ans += cn[c];
        }
        else {
            if (!cols[c].empty() && *(--cols[c].end()) <= 1) ans -= cn[c];
            --cn[c];
            cols[c].erase(cols[c].find(cnt[x][c]));
            --cnt[x][c];
            cols[c].insert(cnt[x][c]);
            cols[c].erase(cols[c].find(cnt[y][c]));
            --cnt[y][c];
            cols[c].insert(cnt[y][c]);
            if (*(--cols[c].end()) <= 1) ans += cn[c];
        }
        cout << ans << '\n';
    }
}


signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
        cout << '\n';
    }
    return 0;
}