#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    vector <map <int, int>> gr(n);
    vector <set <int>> color(1e5);
    vector <int> perfect(1e5, 1);
    vector <int> color_cnt(1e5);

    ll ans = 0;
    while (q--){
        char com;
        cin >> com;
        int v, u, c;
        cin >> v >> u >> c;
        --v; --u; --c;

        if (com == '+'){
            ++gr[v][c];
            ++gr[u][c];
            if (gr[v][c] > 1) color[c].insert(v);
            if (gr[u][c] > 1) color[c].insert(u);
            if (color[c].size() && perfect[c]){
                ans -= color_cnt[c];
                perfect[c] = 0;
            } else if (perfect[c]) ++ans;
            ++color_cnt[c];
        } else {
            --gr[v][c];
            --gr[u][c];
            if (gr[v][c] < 2) color[c].erase(v);
            if (gr[u][c] < 2) color[c].erase(u);
            --color_cnt[c];
            if (!color[c].size() && !perfect[c]){
                ans += color_cnt[c];
                perfect[c] = 1;
            } else if (perfect[c]) --ans;
        }
        cout << ans << '\n';
    }
}
