n, q = map(int, input().split())
degree = {}
edge_count = {}
excellent_color_count = 0
answers = []

def is_excellent(color):
    for vertex in range(n):
        if degree.get(color, {}).get(vertex, 0) > 1:
            return False
    return True

for _ in range(q):
    operation, a, b, c = input().split()
    a, b, c = int(a) - 1, int(b) - 1, int(c)
    
    if c not in degree:
        degree[c] = {}
        edge_count[c] = 0

    if operation == '+':
        degree[c][a] = degree[c].get(a, 0) + 1
        degree[c][b] = degree[c].get(b, 0) + 1
        edge_count[c] += 1
    elif operation == '-':
        degree[c][a] -= 1
        degree[c][b] -= 1
        edge_count[c] -= 1
    
    excellent_color_count = 0
    for color, count in edge_count.items():
        if is_excellent(color):
            excellent_color_count += count
    
    answers.append(excellent_color_count)

print('\n'.join(map(str, answers)))