def find_fraction(n, digits):
    decimal_part = int(digits)
    multiplier = 10 ** n
    for b in range(1, 10 ** 6):
        a = (decimal_part * b) // multiplier
        if 0 < a < b and (decimal_part * b) % multiplier == 0:
            return a, b

    return None



n = int(input().strip())
digits = input().strip()

result = find_fraction(n, digits)

if result:
    print("YES")
    print(result[0], result[1])
else:
    print("NO")