def find_line(x1, y1, x2, y2, x3, y3):
    min_limit = -10**9
    max_limit = 10**9
    
    if not (min_limit <= x1 <= max_limit and min_limit <= y1 <= max_limit and
            min_limit <= x2 <= max_limit and min_limit <= y2 <= max_limit and
            min_limit <= x3 <= max_limit and min_limit <= y3 <= max_limit):
        raise ValueError()
    
    if (x2 - x1) * (y3 - y1) == (x3 - x1) * (y2 - y1):
        return x1, y1, x2, y2

    return 1, 1, 3, 3


x1, y1, x2, y2, x3, y3 = map(int, input().split())

try:
    result = find_line(x1, y1, x2, y2, x3, y3)
    print(*result)
except ValueError as e:
    print(e)
