#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<long long>(x.size())

using ll = long long;

ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n; cin >> n;
    string s; cin >> s;
    ll a = 0, b = 1;
    for (int i = n - 1; i >= 0; i--) {
        a += static_cast<ll>(s[i] - '0') * b;
        b *= 10ll;
    }
    ll d = gcd(a, b);
    a /= d, b /= d;
    if (a <= 1'000'000 && b <= 1'000'000) {
        cout << "YES\n" << a << ' ' << b;
    }
    else {
        cout << "NO";
    }
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
