#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
#include <cmath>
#include <unordered_map>
#include <set>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<long long>(x.size())

using ll = long long;
unordered_map<int, unordered_map<int, int>> matrix;
unordered_map<int, int> cnt;
bool is_ok(int c) {
    return matrix[c].size() / 2 == cnt[c];
}
void solve() {
    int n, q;
    cin >> n >> q;
    int ans = 0;
    for (int i = 0; i < q; i++) {
        char s;
        int v, u, c;
        cin >> s >> v >> u >> c;
        if (s == '+') {
            bool flag = is_ok(c);
            matrix[c][v]++;
            matrix[c][u]++;
            cnt[c]++;
            if (!is_ok(c) && flag) {
                ans -= (cnt[c] - 1);
            }
            if (is_ok(c)) {
                ans++;
            }
        }
        else {
            matrix[c][v]--;
            matrix[c][u]--;
            bool flag = is_ok(c);
            if (matrix[c][v] == 0) matrix[c].erase(v);
            if (matrix[c][u] == 0) matrix[c].erase(u);
            cnt[c] -= 1;
            if (is_ok(c) != flag) ans += cnt[c];
            if (is_ok(c) == flag && flag == 1) ans--;
        }
        cout << ans << '\n';
    }

}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}