#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <string>
using namespace std;

#define all(x) x.begin(), x.end()
#define sz(x) static_cast<long long>(x.size())

using ll = long long;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].second;
    }

    for (int i = 0; i < n; ++i) {
        if (arr[i].first > arr[i].second) {
            swap(arr[i].first, arr[i].second);
        }
    }
    sort(all(arr));
    
    bool flag = true;
    for (int i = 1; i < n; ++i) {
        if (arr[i].second < arr[i - 1].second) {
            flag = false;
        }
    }
    if (flag) {
        for (int i = 0; i < n; ++i) {
            cout << arr[i].first << ' ';
        }
        cout << '\n';
        for (int i = 0; i < n; ++i) {
            cout << arr[i].second << ' ';
        }
        cout << '\n';
    }
    else {
        cout << -1;
    }
}

int main() {
    //cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
