from math import gcd

def solve_fraction(n, d):
    denominator = 10**n
    numerator = int(d)
    g = gcd(numerator, denominator)
    numerator //= g
    denominator //= g
    
    for k in range(1, 10**6 // denominator + 1):
        b = k * denominator
        a = (b * numerator) // denominator
        if 0 < a < b < 10**6:
            return f"YES\n{a} {b}"
    return "NO"

n = int(input().strip())
d = input().strip()
print(solve_fraction(n, d))
