def triangle_area(c, h):
    # Проверяем базовые условия
    if h > c or h <= 0:
        return -1

    # Вычисляем дискриминант
    discriminant = c**2 - 4 * h**2

    # Если дискриминант отрицательный, треугольник невозможен
    if discriminant < 0:
        return -1

    # Вычисляем отрезки p и q
    sqrt_discriminant = discriminant**0.5
    p = (c + sqrt_discriminant) / 2
    q = (c - sqrt_discriminant) / 2

    # Проверяем, что оба отрезка положительные
    if p <= 0 or q <= 0:
        return -1

    # Вычисляем площадь
    area = 0.5 * c * h
    return area


# Тесты
c = int(input())
a = int(input())
print(triangle_area(c,a))
