#include <iostream>
#include <string>

using namespace std;

int main() {
    int n;
    string digits;
    cin >> n >> digits;

    long long decimal_part = 0;
    for (char c : digits) {
        decimal_part = decimal_part * 10 + (c - '0');
    }

    long long power_of_ten = 1;
    for (int i = 0; i < n; i++) {
        power_of_ten *= 10;
    }

    for (long long b = 1; b <= 1000000; b++) {
        if ((decimal_part * b) % power_of_ten == 0) {
            long long a = (decimal_part * b) / power_of_ten;
            if (0 < a && a < b) {
                cout << "YES" << endl;
                cout << a << " " << b << endl;
                return 0;
            }
        }
    }

    cout << "NO" << endl;
    return 0;
}