def solve():
    import sys
    input = sys.stdin.read
    x1, y1, x2, y2, x3, y3 = map(int, input().split())
    
    def on_line(x1, y1, x2, y2, x, y):
        return (x - x1) * (y2 - y1) == (y - y1) * (x2 - x1)

    if not on_line(x1, y1, x2, y2, x3, y3):
        dx, dy = x2 - x1, y2 - y1
    else:
        dx, dy = x3 - x1, y3 - y1

    from math import gcd
    g = gcd(dx, dy)
    dx //= g
    dy //= g

    p1x, p1y = x1 - dx * 109, y1 - dy * 109
    p2x, p2y = x1 + dx * 109, y1 + dy * 109

    print(p1x, p1y, p2x, p2y)