#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<iomanip>
#include<cmath>
#include <stdexcept>
#include <string>
#include <set>
#include<cstring>
#include <utility>

using namespace std;
#define int long long 
#define ld long double
#define ll long long
#define ull unsigned long long

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
}


ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}



void solve_h() {
	int n, q;
	cin >> n >> q;

	int N = 1e5 + 1;
	vector<multiset<int>> colors_edge(N);
	vector<int> cnt_edge(N);

	int beauty = 0;

	while (q--) {
		char t;
		int v, u, c;
		cin >> t >> v >> u >> c;

		if (t == '+') {
			if (!cnt_edge[c] && !colors_edge[c].count(v) && !colors_edge[c].count(u)) {
				beauty++;
			}

			if (!cnt_edge[c] && colors_edge[c].count(v)) {
				beauty = max(0ll, beauty - 1);
				cnt_edge[c]++;
			}
			else if (colors_edge[c].count(v)) {
				cnt_edge[c]++;
			}

			if (!cnt_edge[c] && colors_edge[c].count(u)) {
				beauty = max(0ll, beauty - 1);
				cnt_edge[c]++;
			}
			else if (colors_edge[c].count(u)) {
				cnt_edge[c]++;
			}


			colors_edge[c].insert(v), colors_edge[c].insert(u);


			cout << beauty << '\n';
		}
		else {
			if (colors_edge[c].count(v) == 2) {
				cnt_edge[c]--;
			}
			if (colors_edge[c].count(u) == 2) {
				cnt_edge[c]--;
			}

			colors_edge[c].erase(colors_edge[c].lower_bound(v));
			colors_edge[c].erase(colors_edge[c].lower_bound(u));

			if (!cnt_edge[c] && !colors_edge[c].count(v) && !colors_edge[c].count(u)) {
				beauty++;
			}

			cout << beauty << '\n';
		}
	}
}

void solve_a() {
	int n;
	cin >> n;
	string x;
	cin >> x;
	string a;
	bool f = 0;
	for (auto el : x) {
		if (el == '0' && f == 0)
			continue;
		else {
			a += el;
			f = 1;
		}
	}

	string b = "1";
	for (int i = 0; i < n; i++) {
		b += '0';
	}

	int y = n;

	while (y > 5 && a.size() + 2 < b.size()) {
		a += '0';
		if (!b.empty()) {
			b.pop_back();
		}
		else {
			cout << "NO";
			return;
		}
		y--;
	}
	ll an = stoll(a);
	ll bn = stoll(b);
	ll nod = gcd(an, bn);
	an = an / nod;
	bn = bn / nod;
	a = to_string(an);
	b = to_string(bn);
	if (a.size() >= 7 || b.size() >= 7) {
		cout << "NO";
	}
	else {
		cout << "YES" << endl;
		cout << an << ' ' << bn;
	}
}

signed main() {
	fast();
	solve_a();

	return 0;
}