#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<iomanip>
#include<cmath>
#include <stdexcept>
#include <string>
#include <set>
#include<cstring>
#include <utility>

using namespace std;
#define int long long 
#define ld long double
#define ll long long
#define ull unsigned long long

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
}


void solve_h() {
	int n, q;
	cin >> n >> q;

	int N = 1e5 + 1;
	vector<multiset<int>> colors_edge(N);
	vector<int> cnt_edge(N);

	int beauty = 0;

	while (q--) {
		char t;
		int v, u, c;
		cin >> t >> v >> u >> c;

		if (t == '+') {
			if (!cnt_edge[c] && !colors_edge[c].count(v) && !colors_edge[c].count(u)) {
				beauty++;
			}

			if (!cnt_edge[c] && colors_edge[c].count(v)) {
				beauty = max(0ll, beauty - 1);
				cnt_edge[c]++;
			}
			else if (colors_edge[c].count(v)) {
				cnt_edge[c]++;
			}

			if (!cnt_edge[c] && colors_edge[c].count(u)) {
				beauty = max(0ll, beauty - 1);
				cnt_edge[c]++;
			}
			else if (colors_edge[c].count(u)) {
				cnt_edge[c]++;
			}


			colors_edge[c].insert(v), colors_edge[c].insert(u);


			cout << beauty << '\n';
		}
		else {
			if (colors_edge[c].count(v) == 2) {
				cnt_edge[c]--;
			}
			if (colors_edge[c].count(u) == 2) {
				cnt_edge[c]--;
			}

			colors_edge[c].erase(colors_edge[c].lower_bound(v));
			colors_edge[c].erase(colors_edge[c].lower_bound(u));

			if (!cnt_edge[c] && !colors_edge[c].count(v) && !colors_edge[c].count(u)) {
				beauty++;
			}

			cout << beauty << '\n';
		}
	}
}


int d(int a, int b, int s) {
	bool f = 0;

	for (int i = 1; i <= s; i++) {
		if (s % i == 0 && i <= a && (s / i) <= b) {
			f = 1;
		}
	}
		
	if (!f) {
		return 3;
	}
	else {
		int ans = 2;
		if (s % a == 0) {
			if ((s / a) < b) {
				ans = 1;
			}
		}

		if (s % b == 0) {
			if ((s / b) < a)
				ans = 1;
		}

		if (s == a * b)
			ans = 0;

		return ans;
	}
}

void solve_d() {
	int a, b, s;
	cin >> a >> b >> s;
	cout << min(d(a, b, s), d(a, b, a * b - s));
}

void solve_b() {
	long double c, h;
	cin >> c >> h;
	if (c * c - 4 * h * h < 0) {
		cout << -1;
	}
	else {
		ld D = (ld)(c * c - 4.0 * h * h);
		ld q = (ld)sqrt(D);
		ld x1 = (ld)(c + q) / 2.0;
		ld x2 = (ld)(c - q) / 2.0;	
		ld a1 = sqrt(h * h + x1 * x1);
		ld b1 = sqrt(h * h + c * c - 2 * c * x1 + x1 * x1);
		ld a2 = sqrt(h * h + x2 * x2);
		ld b2 = sqrt(h * h + c * c - 2 * c * x2 + x2 * x2);
		if ((x1 > 0 && x1 < c && c < a1 + b1 && a1 < b1 + c && b1 < a1 + c) || (x2 > 0 && x2 < c && c < a2 + b2 && a2 < c + b2 && b2 < a2 + c)) {
			cout << (long double)(c * h / 2.0);
		}
		else {
			cout << -1;
		}
	}
}

signed main() {
	fast();
	solve_d();

	return 0;
}