#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <cmath>
#include <stdexcept>
#include <string>
#include <set>
#include <cstring>
#include <utility>

using namespace std;

//#define int long long 
#define ld long double
#define ll long long
#define ull unsigned long long

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
}

void solve_h() {
	int n, q;
	cin >> n >> q;

	int N = 1e5 + 1;
	vector<multiset<int>> colors(N);
	vector<int> cnt(N);

	int beauty = 0;

	while (q--) {
		char t;
		int v, u, c;
		cin >> t >> v >> u >> c;

		if (t == '+') {
			if (!cnt[c] && colors[c].count(v)) {
				beauty = max(0, beauty - 1);
				cnt[c]++;
			}
			else if (colors[c].count(v)) {
				cnt[c]++;
			}
			if (!cnt[c] && colors[c].count(u)){
				beauty = max(0, beauty - 1);
				cnt[c]++;
			}
			else if (colors[c].count(u)) {
				cnt[c]++;
			}
			
			colors[c].insert(v), colors[c].insert(u);

			if (!cnt[c]) {
				beauty++;
			}

			cout << beauty << '\n';
		}
		else {
			if (cnt[c]) {
				if (colors[c].count(v) > 1) {
					cnt[c]--;
				}
				if (colors[c].count(u) > 1) {
					cnt[c]--;
				}
				if (!cnt[c]) beauty++;
			}
			
			colors[c].erase(colors[c].lower_bound(v));
			colors[c].erase(colors[c].lower_bound(u));

			cout << beauty << '\n';
		}
	}
}

signed main() {
	fast();
	solve_h();

	return 0;
}