import queue

n, m, c = map(int, input().split())
x = [0] * (n + 2)
t = [0] * (n + 2)

for i in range(1, n + 1):
    x[i], t[i] = map(int, input().split())
x[n + 1] = m

graph = [dict() for i in range(n + 2)]
for i in range(n + 2):
    for j in range(i + 1, n + 2):
        graph[i][j] = (x[j] - x[i]) ** 2 / c + t[j]

answer = [0] * (n + 2)
q = queue.Queue()
q.put(0)
while not q.empty():
    i = q.get()
    for j, distance in graph[i].items():
        if answer[j] > answer[i] + distance or answer[j] == 0:
            answer[j] = answer[i] + distance
            q.put(j)

print(answer[n + 1])
