n = int(input())
front_values = list(map(int, input().split()))
back_values = list(map(int, input().split()))

orientations = []
for i in range(n):
    orientations.append((front_values[i], back_values[i], i))
    orientations.append((back_values[i], front_values[i], i))

orientations.sort()

selected_cards = set()
selected_orientations = []
last_back = -float('inf')

for front, back, idx in orientations:
    if idx not in selected_cards and back >= last_back:
        selected_cards.add(idx)
        selected_orientations.append((front, back))
        last_back = back
        if len(selected_cards) == n:
            break

if len(selected_cards) == n:
    front_result = [str(front) for front, back in selected_orientations]
    back_result = [str(back) for front, back in selected_orientations]
    print(' '.join(front_result))
    print(' '.join(back_result))
else:
    print(-1)
