def solve_magic_spell_problem():
    t = int(input())
    results = []

    for _ in range(t):
        n, m, k = map(int, input().split())
        p = list(map(int, input().split()))
        a = list(map(int, input().split()))
        students = [tuple(map(int, input().split())) for __ in range(k)]

        scroll_runes = []
        student_order = []

        for i, (l, r) in enumerate(students):
            segment = a[l - 1:r]
            scroll_runes.extend(segment)
            student_order.append(i + 1)
            if all(x in scroll_runes for x in p):
                break
        else:
            results.append("-1")
            continue

        found = False
        for i in range(len(scroll_runes) - n + 1):
            if scroll_runes[i:i + n] == p:
                found = True
                break

        if found:
            results.append(f"{len(student_order)}")
            results.append(" ".join(map(str, student_order)))
        else:
            results.append("-1")

    print("\n".join(results))


if __name__ == "__main__":
    solve_magic_spell_problem()
