#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp> 
#include <ext/pb_ds/tree_policy.hpp> 
 
using namespace std;
using namespace __gnu_pbds; 
 
#define int long long
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ff first
#define ss second
#define pb push_back
#define ordered_set tree<int, null_type,less<int>, rb_tree_tag,tree_order_statistics_node_update> 
#define ordered_multiset tree<int, null_type,less_equal<int>, rb_tree_tag,tree_order_statistics_node_update>
 
template<class T, class U> inline bool chmin(T& a, const U& b) { if (a > b) { a = b; return true; } return false; }
template<class T, class U> inline bool chmax(T& a, const U& b) { if (a < b) { a = b; return true; } return false; }
 
int N = 1e5 + 5;
const int INF = 1e18;
const int mod = 1e9 + 7;
const double pi = acos(-1);

void add(int &a, int b) {
    if (a + b >= mod) a = (a + b) - mod;
    else a += b;
}
 
void sub(int &a, int b) {
    if (a - b < 0) a = (a - b) + mod;
    else a -= b;;
}

double dis(int x1, int y1, int x2, int y2){
	return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

void solve(){
	int a[3][2];
	for(int i = 0; i < 3; i++){
		for(int j = 0; j < 2; j++) cin >> a[i][j];
	}
	double res = INF;
	int f = 0, s = 0;
	for(int i = 0; i < 3; i++){
		for(int j = i + 1; j < 3; j++){
			int k = (j + 1) % 3;
			if(k == i) k++;
			int vx1 = a[j][0] - a[i][0];
			int vy1 = a[j][1] - a[i][1];
			int vx2 = a[k][0] - a[i][0];
			int vy2 = a[k][1] - a[i][1];
			double deg = abs(atan2(vy1, vx1) - atan2(vy2, vx2));
			if(deg > pi / 2) deg = 2 * pi - deg;
			double ans = INF;
			if(deg <= pi / 2){
				ans = sin(deg) * dis(0, 0, vx2, vy2);
			}
			ans = min({ans, dis(0, 0, vx2, vy2), dis(vx1, vy1, vx2, vy2)});
			if(chmin(res, ans)){
				f = i;
				s = j;
			}
		}
	}
	cout << a[f][0] << ' ' << a[f][1] << ' ' << a[s][0] << ' ' << a[s][1];
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);cout.tie(nullptr);
	
	int t = 1;
	//cin >> t;
	while(t--){
		solve();
	}
}

