#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()
#define int double
#define ar array
const int inf = 1e18, N = 1e5 + 5, pi = acos(-1);
int crosspr(int x1, int y1, int x2, int y2) {
	return abs(x1 * y2) - abs(x2 * y1);
}

int dotpr(int x1, int y1, int x2, int y2) {
	return abs(x1 * x2) + abs(y1 * y2);
}

int angle(int x1, int y1, int x2, int y2) {
	return atan2(crosspr(x1, y1, x2, y2), dotpr(x1, y1, x2, y2));
}
int indeg(int x) {
	return (x / pi) * 180;
}
int dist (int x1 , int y1 , int x2 , int y2){
	return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}
int eps = DBL_EPSILON;
int area(int x1 , int y1 , int x2 , int y2 , int x3 , int y3){
	int d1 = dist(x1 , y1 , x2 , y2);
	int d2 = dist(x2 , y2 , x3 , y3);
	int d3 = dist(x1 , y1 , x3 , y3);
	int u = (d1 + d2 + d3) / 2;
	int ans = sqrt(u * (u - d1) * (u - d2) * (u - d3));
	cerr << d1 << " " << d2 << " " << d3 << "\n";
	if (d1 + d2 < d3 || d1 + d3 < d2 || d2 + d3 < d1)
		ans = -1;
	return ans;
}
int32_t main() {
	int c;
	cin >> c;
	int h;
	cin >> h;
	if (h >= c || h * h > c * c / 4){
		cout << -1;
		return 0;
	}
	cout << area(0 , 0 , c , 0 , c / 2 , h);
	return 0;
}
