/*
 *    author: a.k
 *    created: idk
*/
#include <bits/stdc++.h> 
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define pb emplace_back
#define nl "\n"

using dbl = double;
struct Vector {
	dbl x, y;
	Vector(dbl _x, dbl _y) : x(_x), y(_y) {}
	dbl len() {
		return sqrt(x * x + y * y);
	}
	tuple<int, int, int> Line(const Vector &b) {
		int A = y - b.y;
		int B = b.x - x;
		int C = -(A * x + B * y);
		return {A, B, C};
	}
};
dbl dist_to_ln(Vector p, Vector a, Vector b) {
	auto [A, B, C] = a.Line(b);
	return abs(A * p.x + B * p.y + C) / Vector(A, B).len();
}
void solve() {
	vector<dbl> x(3), y(3);
	for(int i = 0; i < 3; i++) {
		cin >> x[i] >> y[i];
	}
	dbl res = 1e18, f1 = -1, f2 = -1;
	for(int i = 0; i < 3; i++) {
		for(int j = 0; j < 3; j++) {
			if(i == j) continue;
			for(int k = 0; k < 3; k++) {
				if(i == k || j == k) continue;
				Vector p(x[k], y[k]), a(x[i], y[i]), b(x[j], y[j]);
				dbl dis = dist_to_ln(p, a, b);
				if(res > dis || f1 == -1) {
					res = dis;
					f1 = i, f2 = j;
				}
			}
		}
	}
	cout << x[f1] << ' ' << y[f1] << ' ' << x[f2] << ' ' << y[f2] << nl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int tt = 1; 
	// cin >> tt;
	while(tt--) solve();
}
