#include <bits/stdc++.h>
using namespace std;

#define MAX_COLOR 100000

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    unordered_map<int, tuple<unordered_map<int, int>, int, unordered_set<int>, int>> color_data;

    int tb = 0;

    for (int i = 0; i < q; ++i) {
        char t;
        int v, u, c;
        cin >> t >> v >> u >> c;

        int edge = min(v, u) * MAX_COLOR + max(v, u);

        unordered_map<int, int>& ce = get<0>(color_data[c]);
        int& cb = get<1>(color_data[c]);
        unordered_set<int>& cg = get<2>(color_data[c]);
        int& bad_nodes = get<3>(color_data[c]);

        if (t == '+') {
            cg.insert(edge);
            ce[v]++;
            ce[u]++;
            cb++;

            if (ce[v] == 2) bad_nodes++;
            if (ce[u] == 2) bad_nodes++;
        } 
        else {
            cg.erase(edge);
            ce[v]--;
            ce[u]--;
            cb--;

            if (ce[v] == 1) bad_nodes--;
            if (ce[u] == 1) bad_nodes--;
        }

        tb = 0;
        for (unordered_map<int, tuple<unordered_map<int, int>, int, unordered_set<int>, int>>::iterator it = color_data.begin(); it != color_data.end(); ++it) {
            unordered_map<int, int>& ce = get<0>(it->second);
            int& cb = get<1>(it->second);
            unordered_set<int>& cg = get<2>(it->second);
            int& bad_nodes = get<3>(it->second);
            if (bad_nodes == 0) {
                tb += cb;
            }
        }

        cout << tb << '\n';
    }

    return 0;
}
