#include <bits/stdc++.h>
using namespace std;

const int MAX_C = 1e5 + 7;

struct custom_hash {
    template <class T>
    size_t operator ()(const T& key) const {
        return hash<T>()(key);
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
  
    int n, q;
    cin >> n >> q;
  
    unordered_map<int, unordered_map<int, int>, custom_hash> ce;
    unordered_map<int, int, custom_hash> cb;
    unordered_map<int, unordered_set<int>, custom_hash> cg;
    int tb = 0;
  
    for (int i = 0; i < q; ++i) {
        char t;
        int v, u, c;
        cin >> t >> v >> u >> c;
    
        if (t == '+') {
            cg[c].insert(min(v, u) * MAX_C + max(v, u));
            ce[c][v]++;
            ce[c][u]++;
            cb[c]++;
        } else {
            cg[c].erase(min(v, u) * MAX_C + max(v, u));
            ce[c][v]--;
            ce[c][u]--;
            cb[c]--;
        }

        tb = 0;
        for (auto& [c, e] : cg) {
            bool ex = true;
            for (auto& [v, cnt] : ce[c]) {
                if (cnt > 1) {
                    ex = false;
                    break;
                }
            }
            if (ex) {
                tb += cb[c];
            }
        }

        cout << tb << '\n';
    }

    return 0;
}
