def solve():
    x1, y1, x2, y2, x3, y3 = map(int, input().split())


    def point_to_line_distance(x, y, A, B, C):
        return abs(A * x + B * y + C) / (A ** 2 + B ** 2) ** 0.5


    points = [(x1, y1), (x2, y2), (x3, y3)]
    best_distance = float('inf')
    best_points = None

    for i in range(3):
        for j in range(i + 1, 3):

            x1, y1 = points[i]
            x2, y2 = points[j]


            A = y2 - y1
            B = x1 - x2
            C = x2 * y1 - x1 * y2


            total_distance = 0
            for k in range(3):
                x, y = points[k]
                total_distance += point_to_line_distance(x, y, A, B, C)


            if total_distance < best_distance:
                best_distance = total_distance
                best_points = (x1, y1, x2, y2)


    print(best_points[0], best_points[1], best_points[2], best_points[3])
solve()