#include <iostream>
#include <string>

using namespace std;

int main() {
    int n;
    string fractionalPart;
    cin >> n >> fractionalPart;

    long long numerator = 0;
    long long denominator = 1;

    for (int i = 0; i < n; ++i) {
        numerator = numerator * 10 + (fractionalPart[i] - '0');
        denominator *= 10;
    }

    long long commonDivisor = [](long long a, long long b) {
        while (b) {
            a %= b;
            swap(a, b);
        }
        return a;
    }(numerator, denominator);

    numerator /= commonDivisor;
    denominator /= commonDivisor;


    for (long long b = 1; b <= 1000000; ++b) {
        long long temp = b;
        bool only2and5 = true;
        while (temp % 2 == 0) temp /= 2;
        while (temp % 5 == 0) temp /= 5;
        if (temp != 1) only2and5 = false;

        if (only2and5 && b % denominator == 0) {
            long long a = (b / denominator) * numerator;
            if (a > 0 && a < b) {
                cout << "YES" << endl;
                cout << a << " " << b << endl;
                return 0;
            }
        }
    }

    cout << "NO" << endl;
    return 0;
}
