#include <iostream>
#include <algorithm>
using namespace std;

int cuts(long long n, long long m, long long s) {
    if (s == n * m) {
        return 0;
    }

    if ((s % n == 0 && s/n <= m) || (s % m == 0 && s/m <= n)) {
        return 1;
    }

    if (s < n || s < m) {
        return 2;
    }

    if (n == 2 && m == 2 && s == 3) {
        return 2;
    }

    for (long long i = 1; i <= m; i++) {
        if (i * n >= s && (i * n - s < n)) {
            return 2;
        }
    }
    for (long long i = 1; i <= n; i++) {
        if (i * m >= s && (i * m - s < m)) {
            return 2;
        }
    }

    return 3;
}

int main() {
    long long n, m, s;
    cin >> n >> m >> s;

    cout << cuts(n, m, s) << endl;

    return 0;
}