#include <cmath>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

#define ll long long
#define vi vector<int>
#define vll vector<long long>
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define rep(i, n) for (int i = 0; i < n; ++i)
#define repr(i, n) for (int i = n - 1; i >= 0; --i)
#define fastio ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);


#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

bool cmp(pair<int, int> x, pair<int, int> y)
{
    if (x.first != y.first)
        return x.first < y.first;
    else
        return x.second < y.second;
}

int main() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    vector<pair<int, int>> cards(n);
    for (int i = 0; i < n; ++i) {
        if(a[i]>b[i]){
            cards[i] = {b[i],a[i]};
        }else{
            cards[i] = {a[i],b[i]};
        }
    }

    sort(cards.begin(), cards.end());

    vector<long long> result_top, result_bottom;
    
    for(auto i : cards){
        result_top.push_back(i.first);
        result_bottom.push_back(i.second);
    }
    if(is_sorted(result_top.begin(),result_top.end()) && is_sorted(result_bottom.begin(),result_bottom.end())){
        for (int i = 0; i < n; ++i) {
            cout << result_top[i] << " ";
        }
        cout<<endl;

        for (int i = 0; i < n; ++i) {
            cout << result_bottom[i] << " ";
        }
    }else{
        cout<<-1;
    }
        

    

    return 0;
}
