def find_cheburashki_number(k):
    # Функция для нахождения числа Чебурашки с номером k
    
    # Бинарный поиск по числу n
    left, right = 1, 10**9  # Ограничиваем поиск по n, так как n может быть до 10^9
    
    while left < right:
        mid = (left + right) // 2
        # Сумма апельсинов, забранных за n шагов
        total_apples = mid * (mid + 3) // 2
        if total_apples >= k:
            right = mid
        else:
            left = mid + 1
    
    return left

# Чтение входных данных
k = int(input())

# Вывод ответа
print(find_cheburashki_number(k))
