#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &	u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

const int inf = 3e18;

struct Line{
	int m, c;
	
	Line(int m = 0, int c = inf) : m(m), c(c) {}
	
	int operator ()(int x){ return m * x + c; }
	
	bool isOpt(Line ff, Line ss){ // ff > ss
		__int128 x = c - ff.c, y = c - ss.c;
		x *= (ss.m - m), y *= (ff.m - m);
		
		return x <= y;
	}
};

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

	int n, m, C; cin >> n >> m >> C;
	
	vector <int> x(n + 2), t(n + 2);
	
	for ( int i = 1; i <= n; i++ ){
		cin >> x[i] >> t[i];
		
		t[i] *= C;
	} n += 1;
	
	x[n] = m;
	
	vector <int> dp(n + 1, inf);
	
	deque <Line> dq;
	
	auto ins = [&](int j){
		Line cur = {-x[j], dp[j] + t[j] + x[j] * x[j]};
		
		while ( (int)dq.size() > 1 && dq[(int)dq.size() - 2].isOpt(cur, dq.back()) ) dq.pop_back();
		
		dq.pb(cur);
	};
	
	dp[0] = 0; ins(0);
	
	for ( int i = 1; i <= n; i++ ){
		int X = 2 * x[i];
		
		while ( (int)dq.size() > 1 && dq[0](X) >= dq[1](X) ) dq.pop_front();
		
		dp[i] = dq[0](X) + x[i] * x[i]; ins(i);
	}
	
	cout << fixed << setprecision(10) << (dp.back() + .0) / C;

    cout << '\n';
}
