#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &	u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

	int n, q; cin >> n >> q;
	
	vector <map<int,int>> adj(n + 1);
	map <int,int> badV, cnt;
	
	int cnt_bad = 0;
	
	auto er = [&](int u, int c){
		if ( adj[u][c] > 1 ) badV[c] -= 1;
	};
	
	auto ins = [&](int u, int c){
		if ( adj[u][c] > 1 ) badV[c] += 1;
	};
	
	int tot = 0;
	
	while ( q-- ){
		char x_; cin >> x_;
		int t = (x_ == '-' ? -1 : 1);
		
		int u, v, c; cin >> u >> v >> c;
		
		if ( badV[c] > 0 ) cnt_bad -= cnt[c];
		
		er(u, c), er(v, c);
		
		tot += t, cnt[c] += t;
		adj[u][c] += t, adj[v][c] += t;
		
		ins(u, c), ins(v, c);
		
		if ( badV[c] > 0 ) cnt_bad += cnt[c];
		
		cout << tot - cnt_bad << ln;
	}

    cout << '\n';
}
