#include <iostream>
#include <cmath>

using namespace std;

// Функция для нахождения уравнения прямой через две точки
void find_line(int x1, int y1, int x2, int y2) {
    // Вычисление коэффициентов уравнения прямой: Ax + By + C = 0
    int A = y2 - y1;  // Разность по y
    int B = x1 - x2;  // Разность по x
    int C = x2 * y1 - x1 * y2;  // Свободный член

    // Выводим две точки, через которые проходит эта прямая
    // Выбираем, например, первую и вторую точку, через которые эта прямая проходит
    cout << x1 << " " << y1 << " ";
    cout << x2 << " " << y2 << endl;
}

int main() {
    // Чтение координат трёх точек
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    // Нам нужно просто выбрать две точки для вычисления прямой
    // Возьмём, например, (x1, y1) и (x2, y2)
    find_line(x1, y1, x2, y2);

    return 0;
}
