import math

def dist(x0, y0, x1, y1, x2, y2):
    a = y2 - y1
    b = -(x2 - x1)
    c = x2 * y1 - x1 * y2
    d = abs(a * x0 + b * y0 + c) / math.sqrt(a * a + b * b)
    return d

x1, y1, x2, y2, x3, y3 = map(int, input().split())

d1 = dist(x1, y1, x2, y2, x3, y3)
d2 = dist(x2, y2, x1, y1, x3, y3)
d3 = dist(x3, y3, x1, y1, x2, y2)

if d1 < d2 and d1 < d3:
    print(x2, y2, x3, y3)
elif d2 < d3 and d2 < d1:
    print(x1, y1, x3, y3)
else:
    print(x1, y1, x2, y2)