#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define F first
#define S second
#define pb push_back
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define Fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

const int N = 2e5 + 7;
const int R = 1e9 + 10;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const int B = 320;

double dist(double x0, double y0, double x1, double y1, double x2, double y2) {
    double A = y2 - y1;
    double B = x1 - x2;
    double C = -(A * x1 + B * y1);
    double d = abs(A * x0 + B * y0 + C) / sqrt(A * A + B * B);
    return d;
}

int main() {
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    double d1 = dist(x1 * 1.0, y1 * 1.0, x2 * 1.0, y2 * 1.0, x3 * 1.0, y3 * 1.0);
    double d2 = dist(x2 * 1.0, y2 * 1.0, x1 * 1.0, y1 * 1.0, x3 * 1.0, y3 * 1.0);
    double d3 = dist(x3 * 1.0, y3 * 1.0, x1 * 1.0, y1 * 1.0, x2 * 1.0, y2 * 1.0);

    if (d1 < d2 && d1 < d3) {
        cout << x2 << ' ' << y2 << ' ' << x3 << ' ' << y3 << '\n';
    } else if (d2 < d3 && d2 < d1) {
        cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3 << '\n';
    } else {
        cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << '\n';
    }
}