from fractions import Fraction

def solve(n, digits):
    # Строим строку из цифр после запятой
    decimal_string = digits
    
    # Преобразуем эту строку в дробь
    fractional_part = int(decimal_string)
    denominator = 10 ** n
    
    # Пытаемся найти пару a и b
    for b in range(denominator, 10**6):
        a = fractional_part * (b // denominator)
        if a < b:
            if a * denominator == fractional_part * b:
                # Нашли пару a и b
                return f"YES\n{a} {b}"
    
    return "NO"

# Ввод
n = int(input())
digits = input().strip()

# Решение
print(solve(n, digits))
