#include <iostream>
#include <string>
#include <cmath>
#include <numeric>

using namespace std;

int main() {
    int n;
    cin >> n;
    
    string digits;
    cin >> digits;
    
    // Преобразуем строку цифр в число
    int numerator = stoi(digits);
    int denominator = pow(10, n);
    
    // Находим НОД числителя и знаменателя
    int gcd_value = gcd(numerator, denominator);
    
    // Упрощаем дробь
    numerator /= gcd_value;
    denominator /= gcd_value;
    
    // Проверяем, что числитель и знаменатель лежат в допустимых пределах
    if (numerator < denominator && denominator < 1000000) {
        cout << "YES\n" << numerator << " " << denominator << endl;
    } else {
        cout << "NO\n";
    }
    
    return 0;
}
