#include <iostream>
#include <string>
#include <cmath>
#include <numeric>

using namespace std;

int main() {
    int n;
    cin >> n;
    
    string digits;
    cin >> digits;
    
    // Если строка digits представляет число с ведущими нулями, просто преобразуем в целое число
    int numerator = stoi(digits);  // числитель
    int denominator = pow(10, n);  // знаменатель: 10^n
    
    // Находим НОД числителя и знаменателя
    int gcd_value = gcd(numerator, denominator);
    
    // Упрощаем дробь
    numerator /= gcd_value;
    denominator /= gcd_value;
    
    // Проверка, что числитель и знаменатель подходят
    if (numerator < denominator && denominator < 1000000) {
        cout << "YES\n" << numerator << " " << denominator << endl;
    } else {
        cout << "NO\n";
    }
    
    return 0;
}
