def check_decimal(a, b, n, digits):
    # Получаем n знаков после запятой для деления a / b
    result = []
    remainder = a % b
    for _ in range(n):
        remainder *= 10
        result.append(remainder // b)
        remainder = remainder % b
    
    # Сравниваем полученные знаки с заданными
    return ''.join(map(str, result)) == digits

def solve():
    n = int(input())  # Читаем количество знаков после запятой
    digits = input().strip()  # Читаем сами знаки после запятой

    # Перебираем возможные значения b от 2 до 10^6
    for b in range(2, 1000000):
        for a in range(1, b):
            if check_decimal(a, b, n, digits):
                print(f"YES\n{a} {b}")
                return
    
    print("NO")
