import math

c = int(input())
h = int(input())

def find_catheti(c, h):

    if c <= h:
        return 0,0

    discriminant = c**4 - 4 * c**2 * h**2
    
    if discriminant < 0:
        return 0,0
    

    a_squared_1 = (c**2 + math.sqrt(discriminant)) / 2
    a_squared_2 = (c**2 - math.sqrt(discriminant)) / 2
    

    a_squared = max(a_squared_1, a_squared_2)


    a = math.sqrt(a_squared)
    b = (c * h) / a
    
    return a,b


def check_triangle_existence(a, b, c, h):
    # Убедимся, что гипотенуза больше высоты
    if c <= h:
        return False
    
    # Вычисляем площадь через гипотенузу и высоту
    area_by_height = 0.5 * c * h
    
    # Вычисляем произведение катетов
    area_by_sides = a * b / 2
    
    # Если площади совпадают, то треугольник существует
    if math.isclose(area_by_height, area_by_sides):
        return True
    return False

a,b = find_catheti(c,h)

area = (c*h)/2

if not check_triangle_existence(a,b,c,h):
    area = -1
print(area)