#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;

template<class T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& e : a)
        in >> e;
    return in;
}

template<class T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& e : a)
        out << e << ' ';
    out << '\n';
    return out;
}

ll func(ll n, ll m, ll s) {
    if (s == n * m) {
        return 0;
    }
    if (s % n == 0 || s % m == 0) {
        return 1;
    }
    if (m - s / n == s % n) {
        if (s < n) {
            return 1;
        }
        return 2;
    }
    if (n - s / m == s % m) {
        if (s < m) {
            return 1;
        }
        return 2;
    }
    if (s < n || s < m) {
        return 2;
    }
    return 3;
}

void solve() {
    ll n, m, s;
    cin >> n >> m >> s;
    cout << func(n, m, s);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}