#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;

template<class T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& e : a)
        in >> e;
    return in;
}

template<class T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& e : a)
        out << e << ' ';
    out << '\n';
    return out;
}

ll func(ll n, ll m, ll s) {
    if (s == n * m) {
        return 0;
    }
    if (s % n == 0 || s % m == 0) {
        return 1;
    }
    ll ans = 3;
    if ((m - s / n == s % n) || (n - s / m == s % m) || s < n || s < m) {
        ans = min(ans, 2ll);
    }
    return ans;
}

int sgn(ll a) {
    if (a < 0) {
        return -1;
    }
    if (a > 0) {
        return 1;
    }
    return 0;
}

void solve() {
    ll n, m, s;
    cin >> n >> m >> s;
    if (s == n * m / 2 && ((n * m) % 2) == 1) {
        cout << 2;
        return;
    }
    ll ans = func(n, m, s);
    if (ans == 3) {
        for (ll b = 1; b < n; b++) {
            ll x = n * b + s - m * n;
            ll y = 2 * b - m;
            if (sgn(y) * sgn(x) < 0) {
                continue;
            }
            if (abs(x) % abs(y) == 0) {
                if (abs(x) / abs(y) < m) {
                    ans = 2;
                    break;
                }
            }
        }
    }
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}