#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

template<class T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& e : a)
        in >> e;
    return in;
}

template<class T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (T& e : a)
        out << e << ' ';
    out << '\n';
    return out;
}


void solve() {
    ll n;
    cin >> n;
    if (n < 5) {
        if (n == 1) {
            cout << 1;
            return;
        }
        cout << -1;
        return;
    }
    vector<vector<ll>> matr(n, vector<ll>(n, 0));
    for (ll i = 0; i < n; i++) {
        matr[0][i] = 1;
    }
    ll x = 2;
    for (ll j = 0; j < n / 2; j++) {
        for (ll i = j + 1; i < n; i++) {
            matr[i][j] = x;
        }
        for (ll i = 1; i <= j + 1; i++) {
            matr[i][j + 1] = x;
        }
        x++;
    }
    ll l = n / 2 + 1;
    for (ll k = l; k < n; k++) {
        matr[1][k] = x;
    }
    for (ll i = 1; i < 1 + n / 2; i++) {
        matr[i][l] = x;
    }
    for (ll k = n / 2; k <= l; k++) {
        matr[1 + n / 2][k] = x;
    }
    x++;


    ll p = n / 2;
    for (ll j = n / 2 + 2; j < n; j++) {
        for (ll i = 2; i <= 2 + p; i++) {
            matr[i][j] = x;
        }
        matr[2 + p][j - 2] = x;
        matr[2 + p][j - 1] = x;
        matr[2 + p][j] = x;

        for (ll i = 3 + p; i < n; i++) {
            matr[i][j - 2] = x;
        }


//        for (ll i = 0; i < n; i++) {
//            for (ll j = 0; j < n; j++) {
//                cout << matr[i][j] << " ";
//            }
//            cout << '\n';
//        }
//        cout << '\n';

        p++;
        x++;
    }

    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            cout << matr[i][j] << " ";
        }
        cout << '\n';
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}