#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector<pair<int, int>> cards(n);
    for (int i = 0; i < n; ++i) {
        cards[i] = {min(a[i], b[i]), max(a[i], b[i])};
    }

    sort(cards.begin(), cards.end());

    vector<int> top, bottom;
    int last_top = -1, last_bottom = -1;
    for (int i = 0; i < n; ++i) {
        if (cards[i].first >= last_top) {
            top.push_back(cards[i].first);
            last_top = cards[i].first;
        } else if (cards[i].second >= last_bottom) {
            bottom.push_back(cards[i].second);
            last_bottom = cards[i].second;
        } else {
            cout << -1 << endl;
            return 0;
        }
    }

    for (int x : top) cout << x << " ";
    cout << endl;
    for (int x : bottom) cout << x << " ";
    cout << endl;

    return 0;
}