/* ------------------------------> TEMPLATE <------------------------------ */

#include <bits/stdc++.h>
using namespace std;

#define ld long double
#define ll long long
#define vt vector
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define vsevyho signed main
#define CBO ios_base::sync_with_stdio(false); cin.tie(NULL); ll T = 1

const ll N = 1e5 + 7;
const ll MOD = 1e9 + 7;
const ll INF = 1e18 + 1488;

/* ------------------------------> FUNCTIONS, ARRAYS, ETC. <------------------------------ */



/* ------------------------------> MAIN SOLVE <------------------------------ */

void solve( /* ---> vsevyhodite <--- */ ) {
    ll n, m, s;
    cin >> n >> m >> s;

    if (n * m == s) {
        cout << 0;
        return;
    } 

    if (s % n == 0 || s % m == 0) {
        cout << 1;
        return;
    }


    ll a, b, c, d;
    /*
    
    */

    for (ll i = 0; i < n; i++) {
        ll l = 0, r = m - 1, j, sum;

        // test1

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = a + b + c;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test2

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = a + b + d;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test3

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = a + c + d;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test4

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = b + c + d;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test5

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = a + b;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test6

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = a + c;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test7

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = a + d;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test8

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = b + c;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test9

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = b + d;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test10

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = c + d;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test11

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = a;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test12

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = b;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test13

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = c;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }

        // test14

        l = 0, r = m - 1;
        while (l <= r) {
            j = (l + r) / 2;

            a = i * j;
            b = i * (m - j);
            c = (n - i) * j;
            d = (n - i) * (m - j);

            sum = d;

            if (a + b + c == s || a + b + d == s || a + c + d == s || b + c + d == s || a + b == s || a + c == s || a + d == s || b + c == s || b + d == s || c + d == s || a == s || b == s || c == s || d == s) {
                cout << 2;
                return;
            } 

            if (sum > s) r = j - 1;
            else l = j + 1;
        }
    }

    cout << 3;
} 

/* ------------------------------> cin >> T <------------------------------ */

vsevyho() {
    CBO;
    //cin >> T;
    
	while (T--) solve();
}