#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4,popcnt,abm,mmx,avx,avx2")
#pragma GCC optimize("unroll-loops")
using namespace std;
long double x0, y0, x1, y1;
long double dist(long double x, long double y, long double a, long double b) {
    return sqrtl((a - x) * (a - x) + (b - y) * (b - y));
}
long double kol(long double x) {
    return max(-x, x);
}
long double f(long double a, long double b, long double x, long double y) {
    return kol(dist(x0, y0, x, y) - a) + kol(dist(x1, y1, x, y) - b);
}
bool ch(long double a, long double b, long double &ansx, long double &ansy) {
    long double xl = -2000, xr = 2000;
    int cnt1 = 0;
    while (cnt1 < 200) {
        long double xmid = (xl + xr) / 2.0;
        int cnt2 = 0;
        long double yl = -2000, yr = 2000;
        while (cnt2 < 200) {
            long double ymid = (yl + yr) / 2.0;
            if (f(a, b, xmid, ymid) > f(a, b, xmid, ymid + 0.00000000001)) {
                yl = ymid;
            } else {
                yr = ymid;
            }
            cnt2++;
        }
        if (f(a, b, xmid, yl) > f(a, b, xmid + 0.00000000001, yl)) {
            xl = xmid;
        } else {
            xr = xmid;
        }
        cnt1++;
    }
    int cnt2 = 0;
    long double yl = -2000, yr = 2000;
    while (cnt2 < 200) {
        long double ymid = (yl + yr) / 2.0;
        if (f(a, b, xl, ymid) > f(a, b, xl, ymid + 0.00000000001)) {
            yl = ymid;
        } else {
            yr = ymid;
        }
        cnt2++;
    }
    ansx = xl;
    ansy = yl;
    // cout << fixed << setprecision(10) << f(a, b, xl, yl) << endl;
    if (kol(f(a, b, xl, yl)) <= 0.00001) {
        return 1;
    } else {
        return 0;
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> x0 >> y0 >> x1 >> y1;
    int n;
    cin >> n;
    long double l[n + 1];
    int pref[n + 1] = {};
    for (int i = 1; i <= n; i++) {
        cin >> l[i];
    }
    vector <pair <int,int> > v;
    for(int i = 1;i <= n;i++) {
        v.push_back({l[i],i});
    }
    sort(v.begin(),v.end());
    reverse(v.begin(),v.end());
    bool verh[n + 1] = {};
    long double cnt1 = 0,cnt2 = 0;
    for(auto x:v) {
        if(cnt1 > cnt2) {
            cnt2+=x.first;
            verh[x.second] = false;
        }
        else {
            cnt1+=x.first;
            verh[x.second] = true;
        }
    }
    //cnt1,cnt2,dist(x0,y0,x1,y1);
    long double q = cnt1,w = cnt2,e = dist(x0,y0,x1,y1);
    
    if(q + w <= e || q + e <= w || e + w <= q) {
        cout << "Impossible" << endl;
    }
    else {
        long double x,y;
        ch(cnt1,cnt2,x,y);
        cout << "Possible" << endl;
        long double deltax1 = x - x0;
        long double deltay1 = y - y0;
        
        long double deltax2 = x1 - x;
        long double deltay2 = y1 - y;
        long double curx = x0,cury = y0;
        for(int i = 1;i <= n;i++) {
            if(verh[i]) {
                curx+=l[i]*(deltax1)/cnt1;
                cury+=l[i]*(deltay1)/cnt1;
            }
            else {
                curx+=l[i]*(deltax2)/cnt2;
                cury+=l[i]*(deltay2)/cnt2;
            }
            cout << fixed << setprecision(10) << curx << " " << cury << endl;
        }
        
    }
}