def solve(n, decimal_part):
    # Строим числовое значение дроби на основе введенной строки
    number = int(decimal_part)  # это число, представляющее десятичную часть
    denominator = 10 ** n       # это соответствующий знаменатель (10^n)
    
    # Ищем такие a и b, что a/b дает точно эти n знаков после запятой
    a = number
    b = denominator
    
    # Нормализуем дробь, чтобы она была в наименьшей форме
    import math
    gcd_ab = math.gcd(a, b)
    a //= gcd_ab
    b //= gcd_ab
    
    # Проверяем, что a < b и b меньше 10^6
    if a < b and b < 10**6:
        print(f"YES\n{a} {b}")
    else:
        print("NO")

# Чтение данных
n = int(input())
decimal_part = input().strip()

# Вызываем функцию решения
solve(n, decimal_part)
