#include <bits/stdc++.h>

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define nl '\n'
#define lb lower_bound
#define ub upper_bound
#define stop exit(0);
#define all(x) x.begin(), x.end()
#define str string

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const int INFI = 1e9, N = 1;
const ld PI = acos(-1.0), EPS = 1e-9;

using namespace std;

struct Line {
    ld a, b, c;

    bool is_in_line(ld x, ld y) {
        return (a * x + b * y + c == 0);
    }
};

struct Point {
    ld x, y;

    ld distance(Point a) {
        return (sqrt((a.x - x) * (a.x - x) + (a.y - y) * (a.y - y)));
    }

    Line create_line(Point b) {
        Line line;
        line.a = y - b.y;
        line.b = b.x - x;
        line.c = x * b.y - b.x * y;
        return line;
    }

    long double point_to_line_dist(Line a) {
        long double del = sqrt(a.a * a.a + a.b * a.b);
        return abs(a.a * x + a.b * y + a.c) / del;
    }
};

void solve() {
    Point a, b, c;
    Line lab, lac, lbc;
    cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y;
    lab = a.create_line(b);
    lac = a.create_line(c);
    lbc = b.create_line(c);
    ld mindist = c.point_to_line_dist(lab);
    int f = 1, k = 0, x1 = 1, x2 = -1;
    if(b.point_to_line_dist(lac) < mindist) {
        mindist = b.point_to_line_dist(lac);
        f = 2;
    }
    if(a.point_to_line_dist(lbc) < mindist) {
        mindist = a.point_to_line_dist(lbc);
        f = 3;
    }
    if(f == 1) cout << a.x << ' ' << a.y << ' ' << b.x << ' ' << b.y << '\n';
    if(f == 2) cout << a.x << ' ' << a.y << ' ' << c.x << ' ' << c.y << '\n';
    if(f == 3) cout << b.x << ' ' << b.y << ' ' << c.x << ' ' << c.y << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed;
    cout << setprecision(0);
    ll t = 1;
    //cin >> t;
    while(t--) solve();
    return 0;
}
