#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long double

int dist (int x1, int y1, int x2, int y2)
{
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

void solve()
{
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    int a = dist(x1, y1, x2, y2), b = dist(x1, y1, x3, y3), c = dist(x2, y2, x3, y3);
    if (max({a, b, c}) == a) {
        cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << '\n';
    } else if (max({a, b, c}) == b) {
        cout << x1 << ' ' << y1 << ' ' << x3 << ' ' << y3 << '\n';
    } else {
        cout << x2 << ' ' << y2 << ' ' << x3 << ' ' << y3 << '\n';
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
