import math

def solve():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    x0, y0 = map(int, data[0:2])
    x1, y1 = map(int, data[2:4])
    n = int(data[4])
    a = list(map(int, data[5:5 + n]))
    
    
    total_distance = sum(a)
    direct_distance = math.sqrt((x1 - x0)**2 + (y1 - y0)**2)
    
    if total_distance < direct_distance or (total_distance - direct_distance) % 2 != 0:
        print("Impossible")
        return
    
    
    x, y = x0, y0
    result = []
    
    for step in a:
       
        if x1 == x and y1 == y:
            dx, dy = step, 0  
        else:
            remaining_distance = math.sqrt((x1 - x)**2 + (y1 - y)**2)
            if remaining_distance == 0:
                dx, dy = step, 0
            else:
                dx = step * (x1 - x) / remaining_distance
                dy = step * (y1 - y) / remaining_distance
        
       
        x += dx
        y += dy
        result.append((x, y))
    
    print("Possible")
    for px, py in result:
        print(f"{px:.6f} {py:.6f}")
