#include <bits/stdc++.h>
using namespace std;

struct ColorInfo {
    vector<int> vertices;
    vector<int> degrees;
};

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    int n, q;
    cin >> n >> q;
    
    const int MAX_C = 100005;
    vector<ColorInfo> color_info(MAX_C);
    vector<int> m_c(MAX_C, 0);
    vector<int> bad_c(MAX_C, 0);
    
    long long sum_beauty = 0;
    
    while(q--){
        char op;
        int v, u, c;
        cin >> op >> v >> u >> c;
        
        bool was_superior = (bad_c[c] == 0);
        int prior_m_c = m_c[c];
        
        if(op == '+'){
            m_c[c] +=1;
            ColorInfo &ci = color_info[c];
            int idx = -1;
            for(int i=0; i < ci.vertices.size(); ++i){
                if(ci.vertices[i] == v){
                    idx = i;
                    break;
                }
            }
            if(idx == -1){
                ci.vertices.push_back(v);
                ci.degrees.push_back(1);
            }
            else{
                ci.degrees[idx] +=1;
                if(ci.degrees[idx] ==2){
                    bad_c[c] +=1;
                }
            }
            idx = -1;
            for(int i=0; i < ci.vertices.size(); ++i){
                if(ci.vertices[i] == u){
                    idx = i;
                    break;
                }
            }
            if(idx == -1){
                ci.vertices.push_back(u);
                ci.degrees.push_back(1);
            }
            else{
                ci.degrees[idx] +=1;
                if(ci.degrees[idx] ==2){
                    bad_c[c] +=1;
                }
            }
        }
        else if(op == '-'){
            m_c[c] -=1;
            ColorInfo &ci = color_info[c];
            int idx = -1;
            for(int i=0; i < ci.vertices.size(); ++i){
                if(ci.vertices[i] == v){
                    idx = i;
                    break;
                }
            }
            if(idx != -1){
                ci.degrees[idx] -=1;
                if(ci.degrees[idx] ==1){
                    bad_c[c] -=1;
                }
                if(ci.degrees[idx] ==0){
                    ci.vertices[idx] = ci.vertices.back();
                    ci.degrees[idx] = ci.degrees.back();
                    ci.vertices.pop_back();
                    ci.degrees.pop_back();
                }
            }
            idx = -1;
            for(int i=0; i < ci.vertices.size(); ++i){
                if(ci.vertices[i] == u){
                    idx = i;
                    break;
                }
            }
            if(idx != -1){
                ci.degrees[idx] -=1;
                if(ci.degrees[idx] ==1){
                    bad_c[c] -=1;
                }
                if(ci.degrees[idx] ==0){
                    ci.vertices[idx] = ci.vertices.back();
                    ci.degrees[idx] = ci.degrees.back();
                    ci.vertices.pop_back();
                    ci.degrees.pop_back();
                }
            }
        }
        
        bool is_superior_now = (bad_c[c] == 0);
        int new_m_c = m_c[c];
        
        if(was_superior){
            if(is_superior_now){
                if(op == '+'){
                    sum_beauty +=1;
                }
                else {
                    sum_beauty -=1;
                }
            }
            else{
                sum_beauty -= prior_m_c;
            }
        }
        else{
            if(is_superior_now){
                sum_beauty += new_m_c;
            }
        }
        
        cout << sum_beauty << "\n";
    }
}
