class ColorfulGraph:
    def _init_(self, n):
        self.edges = {}  # Хранение рёбер по цветам
        self.beauty = 0  # Текущая суммарная красота графа

    def add_edge(self, u, v, c):
        if c not in self.edges:
            self.edges[c] = set()
        self.edges[c].add((u, v))

    def remove_edge(self, u, v, c):
        if c in self.edges and (u, v) in self.edges[c]:
            self.edges[c].remove((u, v))
            if not self.edges[c]:
                del self.edges[c]

    def calculate_beauty(self):
        return len(self.edges)

if _name_ == "_main_":
    import sys
    input = sys.stdin.read

    data = input().splitlines()
    n, q = map(int, data[0].split())
    graph = ColorfulGraph(n)

    results = []
    for i in range(1, q + 1):
        query = data[i].split()
        if query[0] == "+":
            _, u, v, c = query
            u, v, c = int(u), int(v), int(c)
            graph.add_edge(u, v, c)
        elif query[0] == "-":
            _, u, v, c = query
            u, v, c = int(u), int(v), int(c)
            graph.remove_edge(u, v, c)

        # Вычисляем текущую красоту графа
        results.append(graph.calculate_beauty())

    # Вывод результатов
    print("\n".join(map(str, results)))
