def find_fraction(n, digits):
    from decimal import Decimal, getcontext

    getcontext().prec = n + 10  # Устанавливаем точность до n+10 знаков после запятой
    digits = digits.strip()  # Убираем лишние пробелы

    for b in range(1, 10**6):
        for a in range(1, b):
            result = str(Decimal(a) / Decimal(b))[2:n+2]  # Извлекаем дробную часть результата
            if result == digits:
                return f"YES\n{a} {b}"
    
    return "NO"

# Пример использования:
n = int(input("Введите количество знаков после запятой: "))
digits = input("Введите цифры после запятой: ")

print(find_fraction(n, digits))

