def is_in_bounds(x, y):
    return -10**9 <= x <= 10**9 and -10**9 <= y <= 10**9

def triangle_area(x1, y1, x2, y2, x3, y3):
    return abs((x1 * (y2 - y3) + x2 * (y3 - y1) + x3 * (y1 - y2)) / 2)

x1, y1 = map(int, input("Введите координаты точки 1 (x1 y1): ").split())
x2, y2 = map(int, input("Введите координаты точки 2 (x2 y2): ").split())
x3, y3 = map(int, input("Введите координаты точки 3 (x3 y3): ").split())

if not (is_in_bounds(x1, y1) and is_in_bounds(x2, y2) and is_in_bounds(x3, y3)):
    print("Ошибка: координаты точек выходят за пределы [-10^9, 10^9].")
else:
    area = triangle_area(x1, y1, x2, y2, x3, y3)
    print("Площадь треугольника:", area)
