#include <bits\stdc++.h>

using namespace std;

using ll = long long;

const int N = 1e6;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<set<pair<int, int>>> g(n);
    vector<int> cnt(N), bad(N);
    ll ans = 0;
    while (q--) {
        char op;
        int v, u, c;
        cin >> op >> v >> u >> c;
        --u;
        --v;
        if (op == '+') {
            auto it = g[v].lower_bound({c, -1});
            if (bad[c] == 0) ans -= cnt[c];
            if (it != g[v].end() && it->first == c) {
                bad[c]++;
            }
            it = g[u].lower_bound({c, -1});
            if (it != g[u].end() && it->first == c) {
                bad[c]++;
            }
            cnt[c]++;
            if (bad[c] == 0) ans += cnt[c];
            g[v].emplace(c, u);
            g[u].emplace(c, v);
        } else {
            g[v].erase({c, u});
            g[u].erase({c, v});
            cnt[c]--;
            if (bad[c] == 0) {
                ans--;
            } else {
                auto it = g[v].upper_bound({c, -1});
                if (it != g[v].end() && it->first == c) {
                    it = g[v].upper_bound(*it);
                    if (it == g[v].end() || it->first != c) {
                        bad[c]--;
                    }
                }
                it = g[u].upper_bound({c, -1});
                if (it != g[u].end() && it->first == c) {
                    it = g[u].upper_bound(*it);
                    if (it == g[u].end() || it->first != c) {
                        bad[c]--;
                    }
                }
                if (bad[c] < 0) throw 1;
                if (bad[c] == 0) ans += cnt[c];
            }
        }
        cout << ans << '\n';
    }

}

signed main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}
