import sys


x0, y0 = map(int, input().split())
x1, y1 = map(int, input().split())
n = int(input())
a = list(map(int, input().split()))
def can_reach(x0, y0, x1, y1, a):
    n = len(a)
    delta_x = x1 - x0
    delta_y = y1 - y0

    # Initialize a set to store reachable points and their paths
    reachable = {(0, 0): [(x0, y0)]}

    for i in range(n):
        jump = a[i]
        new_reachable = {}

        for (dx, dy), path in reachable.items():
            for (nx, ny) in [(dx + jump, dy), (dx - jump, dy), (dx, dy + jump), (dx, dy - jump)]:
                new_path = path + [(x0 + nx, y0 + ny)]
                if (nx, ny) not in new_reachable or len(new_reachable[(nx, ny)]) > len(new_path):
                    new_reachable[(nx, ny)] = new_path

        reachable = new_reachable

    if (delta_x, delta_y) in reachable:
        return True, reachable[(delta_x, delta_y)]
    else:
        return False, []


possible, path = can_reach(x0, y0, x1, y1, a)

if possible:
    print("Possible")
    for point in path[1:]:  # Пропускаем начальную точку, так как она уже дана
        print(f"{point[0]:.4f} {point[1]:.4f}")
else:
    print("Impossible")
