#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>
#include <map>
typedef long double ld;
typedef long long ll;
#define ff first
#define ss second
using namespace std;
const int N = 25e4 + 10;
const int M = 1e7 + 10;
struct Line {
	ld k;
	ld b;
};
Line tree[M];
int l[M], r[M];
ld get_val(Line a, ld x) {
	return a.k * x + a.b;
}
ld dp[N];
ll x[N], t[N];
int sz = 1;
void add(int v, int tl, int tr, Line x) {
	int tm = (tl + tr) / 2;
	if (get_val(tree[v], (ld)tm) >= get_val(x, (ld)tm)) {
		swap(tree[v], x);
	}
	if (get_val(tree[v], (ld)tl) <= get_val(x, (ld)tl) &&
		get_val(tree[v], (ld)tr) <= get_val(x, (ld)tr)) {
		return;
	}
	if (tl != tr) {
		if (get_val(x, (ld)tl) < get_val(tree[v], (ld)tl)) {
			if (!l[v]) {
				l[v] = ++sz;
				tree[sz] = x;
				return;
			}
			add(l[v], tl, tm, x);
		}
		else if (get_val(x, (ld)tr) < get_val(tree[v], (ld)tr)) {
			if (!r[v]) {
				r[v] = ++sz;
				tree[sz] = x;
				return;
			}
			add(r[v], tm + 1, tr, x);
		}
	}
}
ld get_mx(int v, int tl, int tr, int pos) {
	if (tl == tr) return get_val(tree[v], pos);
	int tm = (tl + tr) / 2;
	if (pos <= tm) {
		if (!l[v]) return get_val(tree[v], pos);
		return min(get_val(tree[v], pos), get_mx(l[v], tl, tm, pos));
	}
	else {
		if (!r[v]) return get_val(tree[v], pos);
		return min(get_val(tree[v], pos), get_mx(r[v], tm + 1, tr, pos));
	}
}
int main()
{
	ll n, m, c;
	cin >> n >> m >> c;
	for (int i = 1; i <= n; i++) {
		cin >> x[i] >> t[i];
	}
	dp[1] = (((ld)x[1] * x[1]) / (ld)c + (ld)t[1]);
	tree[1] = { -2.0 * (ld)x[1] / c, dp[1] + ((ld)x[1] * x[1]) / c };
	for (int i = 2; i <= n; i++) {
		dp[i] = (((ld)x[i] * x[i]) / (ld)c + (ld)t[i]);
		dp[i] = min(dp[i], get_mx(1, 1, m, x[i]) + t[i] + ((ld)x[i] * x[i]) / c);
		add(1, 1, m, { -2.0 * (ld)x[i] / c, dp[i] + ((ld)x[i] * x[i]) / c });
	}
	ld ans = 1e18 + 10;
	for (int i = 1; i <= n; i++) {
		ans = min(ans, dp[i] + ((ld)(m - x[i]) * (m - x[i])) / c);
	}
	cout << fixed << setprecision(12) << (ld)ans << "\n";
}