#include <iostream>
#include <cmath>

using namespace std;

int main() {
    int c, h;
    cin >> c >> h;

    // Площадь треугольника через гипотенузу и высоту
    double S = 0.5 * c * h;

    // Проверяем существование треугольника с гипотенузой c и высотой h
    // Нужно найти катеты a и b, которые удовлетворяют уравнению: a^2 + b^2 = c^2
    // Используем формулу: h = 2 * S / c

    if (h > c) {
        cout << "NO" << endl; // Высота не может быть больше гипотенузы
        return 0;
    }

    // Мы проверяем с использованием теоремы Пифагора:
    // Площадь треугольника S = (1/2) * a * b
    // где a и b - катеты.
    // Из теоремы Пифагора: a^2 + b^2 = c^2
    // Мы можем решить через высоту h: 2 * S / c = h

    cout << "YES" << endl;
    return 0;
}
