#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;
    
    // Сначала определим маршрут
    vector<pair<int, int>> route;
    
    // Начало маршрута за пределами сетки, например, (n, n) для удобства.
    route.push_back({n, n});
    
    // Проходим по строкам
    for (int i = 0; i < n; i++) {
        if (i % 2 == 0) { 
            for (int j = 0; j < n; j++) {
                route.push_back({i, j});
            }
        } else { 
            for (int j = n - 1; j >= 0; j--) {
                route.push_back({i, j});
            }
        }
    }
    
    
    for (const auto& p : route) {
        cout << p.first << " " << p.second << endl;
    }

    return 0;
}
