def process_queries(n, q, queries):
    MAX_COLOR = 100000
    color_edges_count = [0] * (MAX_COLOR + 1)
    vertex_color_degree = [[0] * (MAX_COLOR + 1) for _ in range(n + 1)]
    color_non_excellent_count = [0] * (MAX_COLOR + 1)
    total_beauty = 0
    for query in queries:
        type_of_query, v, u, c = query
        v, u, c = int(v), int(u), int(c)
        if type_of_query == '+':
            color_edges_count[c] += 1
            vertex_color_degree[v][c] += 1
            vertex_color_degree[u][c] += 1
            if vertex_color_degree[v][c] == 2:
                color_non_excellent_count[c] += 1
            if vertex_color_degree[u][c] == 2:
                color_non_excellent_count[c] += 1
        elif type_of_query == '-':
            color_edges_count[c] -= 1
            vertex_color_degree[v][c] -= 1
            vertex_color_degree[u][c] -= 1
            if vertex_color_degree[v][c] == 1:
                color_non_excellent_count[c] -= 1
            if vertex_color_degree[u][c] == 1:
                color_non_excellent_count[c] -= 1
        total_beauty = 0
        for color in range(1, MAX_COLOR + 1):
            if color_non_excellent_count[color] == 0:
                total_beauty += color_edges_count[color]
        print(total_beauty)
n, q = map(int, input().split())
queries = [input().split() for _ in range(q)]
process_queries(n, q, queries)