﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <set>
#include <cmath>
#include <unordered_map>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define print(a) for (auto i : a) {cout << i << " ";} cout << "\n";
#define scan(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define its(a) a.begin(), a.end()
//ll gcd(ll a, ll b) {
//    if (b == 0) return a;
//    return gcd(b, a % b);
//}

void solve() {
    int n; cin >> n;
    vector <pair <int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
    }
    for (int i = 0; i < n; ++i) {
        if (a[i].first > a[i].second) {
            swap(a[i].first, a[i].second);
        }
    }
    sort(its(a));
    vector <pair <int, int>> ans = { a[0] };
    for (int i = 1; i < n; ++i) {
        if (ans.back().first <= a[i].first && ans.back().second <= a[i].second) {
            ans.push_back(a[i]);
        }
        else {
            cout << -1;
            return;
        }
    }
    for (int i = 0; i < n; ++i) cout << ans[i].first << " ";
    cout << "\n";
    for (int i = 0; i < n; ++i) cout << ans[i].second << " ";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    //freopen("network.in", "r", stdin);
    //freopen("network.out", "w", stdout);
    solve();
}