def find_numbers(n, sequence):
    # Convert the sequence string to an integer
    seq_int = int(sequence)
    multiplier = 10**n

    for b in range(1, 10**6):
        a = seq_int * b
        if a % multiplier == 0:
            a //= multiplier
            if 0 < a < b < 10**6:
                return "YES", a, b
    return "NO",

# Input
n = int(input())  # Length of the sequence
sequence = input().strip()  # Sequence of digits after the decimal point

# Solve and output
result = find_numbers(n, sequence)
if result[0] == "YES":
    print(result[0])
    print(result[1], result[2])
else:
    print(result[0])
