import math

def calculate_triangle_area(c, h):
    # Проверяем, возможен ли такой треугольник
    if h > c or h <= 0 or c <= 0:
        return -1

    # Проверяем, можно ли построить прямоугольный треугольник
    # h² + (c/2)² должно быть равно (c/2)² + другой половине гипотенузы
    if 4 * h**2 > c**2:
        return -1

    # Если проверки пройдены, вычисляем площадь
    area = (c * h) / 2
    return area

# Ввод данных: длина гипотенузы (c) и высота (h)
c = int(input())
h = int(input())

# Вычисление результата и вывод
result = calculate_triangle_area(c, h)
if result == -1:
    print(-1)
else:
    print(f"{result:.1f}")  # Выводим результат с точностью до 1 десятичного знака
