#include <bits/stdc++.h>
#define fr first
#define sc second
#define ll long long
#define pb push_back
#define no cout << "NO" << endl
#define yes cout << "YES" << endl
#define IShowSpeed ios_base::sync_with_stdio(0); cin.tie(0);
using namespace std;

double distanceToLine(double A, double B, double C, int x, int y) {
    return fabs(A * x + B * y + C) / sqrt(A * A + B * B);
}

bool areCollinear(int x1, int y1, int x2, int y2, int x3, int y3) {
    
    return (x2 - x1) * (y3 - y1) == (y2 - y1) * (x3 - x1);
}

void mercurii() {
    int x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    
    if (areCollinear(x1, y1, x2, y2, x3, y3)) {
        cout << x1 << " " << y1 << endl;
        cout << x2 << " " << y2 << endl;
        return;
    }

    double minDistance = 1e9;
    int bestX1 = x1, bestY1 = y1, bestX2 = x2, bestY2 = y2;

    
    {
        double A = y2 - y1;
        double B = x1 - x2;
        double C = x2 * y1 - x1 * y2;
        double distance = distanceToLine(A, B, C, x3, y3);
        if (distance < minDistance) {
            minDistance = distance;
            bestX1 = x1;
            bestY1 = y1;
            bestX2 = x2;
            bestY2 = y2;
        }
    }

    
    {
        double A = y3 - y1;
        double B = x1 - x3;
        double C = x3 * y1 - x1 * y3;
        double distance = distanceToLine(A, B, C, x2, y2);
        if (distance < minDistance) {
            minDistance = distance;
            bestX1 = x1;
            bestY1 = y1;
            bestX2 = x3;
            bestY2 = y3;
        }
    }

    
    {
        double A = y3 - y2;
        double B = x2 - x3;
        double C = x3 * y2 - x2 * y3;
        double distance = distanceToLine(A, B, C, x1, y1);
        if (distance < minDistance) {
            minDistance = distance;
            bestX1 = x2;
            bestY1 = y2;
            bestX2 = x3;
            bestY2 = y3;
        }
    }

    
    cout << bestX1 << " " << bestY1 << endl;
    cout << bestX2 << " " << bestY2 << endl;
}
/*
 4 5 8 10 9 100

 9 100
 4 5
 ================
 1 3 4 6 9 14

 9 14
 1 3
 ================
 13 88 104 200 888 12


 888 12
 13 88
 */
int main() {
    IShowSpeed
    ll t = 1;
    // cin >> t;
    while (t--) {
        mercurii();
    }
}
