def find_path(grid, x, y, path=[]):
    n = len(grid)
    grid[x][y] = 0
    path.append((x, y))
    if all(row.count(1) == 0 for row in grid):
        return path
    for dx, dy in [(0, 1), (0, -1), (1, 0), (-1, 0)]:
        nx, ny = x + dx, y + dy
        if 0 <= nx < n and 0 <= ny < n and grid[nx][ny]:
            if find_path(grid, nx, ny, path):
                return path
    path.pop()
    grid[x][y] = 1
    return None

grid = [[1, 0, 1],
        [1, 1, 0],
        [0, 1, 1]]
start = (0, 0) 
path = find_path(grid, start[0], start[1], [])
if path:
    print(path)
else:
  #  print("Путь не найден")