n, q = map(int, input().split())

graph = {}
degree = {} 


def is_excellent(color):
    if color not in degree:
        return True
    for count in degree[color].values():
        if count > 1:
            return False
    return True


def calculate_total_beauty():
    total_beauty = 0
    for color in graph:
        if is_excellent(color):
            total_beauty += len(graph[color])
    return total_beauty


for _ in range(q):
    query = input().split()
    op = query[0]
    u, v, c = int(query[1]), int(query[2]), int(query[3])
    u, v = min(u, v), max(u, v) 

    if op == '+':
        if c not in graph:
            graph[c] = {}
            degree[c] = {}
        graph[c][(u, v)] = True
        if u not in degree[c]:
            degree[c][u] = 0
        if v not in degree[c]:
            degree[c][v] = 0
        degree[c][u] += 1
        degree[c][v] += 1

    else:
        del graph[c][(u, v)]
        degree[c][u] -= 1
        degree[c][v] -= 1
        if degree[c][u] == 0:
          del degree[c][u]
        if degree[c][v] == 0:
          del degree[c][v]
        if not graph[c]:
          del graph[c]
          del degree[c]


    print(calculate_total_beauty())


