#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
using ull = unsigned long long;
using ll = long long;
using str = string;
void print() {cout << "\n";}
template <typename T>
void print(const T& arg) {
    cout << arg << " ";
}
template <typename T, typename... Args>
void print(const T& arg, const Args&... args) {
    cout << arg << " ";
    print(args...);
}
inline void debugMode() {
    #ifndef ONLINE_JUDGE
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #endif // ONLINE_JUDGE
}
const int N = 250000 + 10, eps = 1e-6;
int dp[N], x[N], t[N];
int n, m, c;
struct Line {
    mutable ll k, m, p;
    bool operator<(const Line& o) const { return k < o.k; }
    bool operator<(ll x) const { return p < x; }
};

struct LineContainer : multiset<Line, less<>> {
    // (for doubles, use inf = 1/.0, div(a,b) = a/b)
    static const ll inf = LLONG_MAX;
    ll div(ll a, ll b) { // floored division
        return a / b - ((a ^ b) < 0 && a % b); }
    bool isect(iterator x, iterator y) {
        if (y == end()) return x->p = inf, 0;
        if (x->k == y->k) x->p = x->m > y->m ? inf : -inf;
        else x->p = div(y->m - x->m, x->k - y->k);
        return x->p >= y->p;
    }
    void add(ll k, ll m) {
        auto z = insert({k, m, 0}), y = z++, x = y;
        while (isect(y, z)) z = erase(z);
        if (x != begin() && isect(--x, y)) isect(x, y = erase(y));
        while ((y = x) != begin() && (--x)->p >= y->p)
            isect(x, erase(y));
    }
    ll query(ll x) {
        assert(!empty());
        auto l = *lower_bound(x);
        return l.k * x + l.m;
    }
};
int f(int x, int y) {
    int S = ::x[y] - ::x[x];
    int T = S;
    return T;
}
void solve() {
    cin >> n >> m >> c;
    x[0] = 0;
    t[0] = 0;
    x[n] = m;
    t[n] = 0; 
    for (int i = 1; i <= n; i++) {
        cin >> x[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> t[i];
    }
    LineContainer T;
    T.add(0, 0);
    dp[0] = 0;
    for (int i = 1; i <= n + 1; i++) {
        int dp[i] = T.query()
    }
    for (int i = 0; i <= n; i++) {
        cout << fixed << setprecision(6) << dp[i] << " ";
    }
    // cout << fixed << setprecision(10) << dp[n];
}
signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    debugMode();
    int $ = 1;
    // cin >> $;
    while ($--) {
        solve();
    }
}
