#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
using ull = unsigned long long;
using ll = long long;
using str = string;
void print() {cout << "\n";}
template <typename T>
void print(const T& arg) {
    cout << arg << " ";
}
template <typename T, typename... Args>
void print(const T& arg, const Args&... args) {
    cout << arg << " ";
    print(args...);
}
inline void debugMode() {
    #ifndef ONLINE_JUDGE
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #endif // ONLINE_JUDGE
}
void solve() {
    int n;
    cin >> n;
    int a[n], b[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        if (a[i] > b[i])
            swap(a[i], b[i]);
    }
    vector<pair<int, int>> v;
    for (int i = 0; i < n; i++) {
        v.push_back({a[i], b[i]});
    }
    sort(v.begin(), v.end());
    bool flag = 1;
    for (int i = 1; i < n; i++) {
        if (v[i].first >= v[i - 1].first && v[i].second >= v[i - 1].second)
            continue;
        flag = 0;
    }
    if (!flag) {
        cout << -1;
        return;
    }
    for (int i = 0; i < n; i++) {
        cout << v[i].first << " ";
    }
    cout << "\n";
    for (int i = 0; i < n; i++) {
        cout << v[i].second << " ";
    }
    cout << "\n";
}
signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    // debugMode();
    int $ = 1;
    // cin >> $;
    while ($--) {
        solve();
    }
}
