#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
#define int long long
//@formatter:on
//region queue

struct node {
      int opt, l, r;
};

//endregion
signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(0);
#endif
      int n, m;
      double c;
      cin >> n >> m >> c;
      vector<int> x(n + 1), t(n + 1);
      for (int i = 0; i < n; ++i) cin >> x[i + 1] >> t[i + 1];
      n+=2;
      x.push_back(m), t.push_back(0);
      vector<double> dp(n, 1e18);
      dp[0] = 0;
      deque<node> dq = {{0, 1, n}};
      auto f = [&](int j, int i) {
            return dp[j] + (x[i] - x[j]) * (x[i] - x[j]) / c + t[i];
      };

      for (int i = 1; i < n; ++i) {
            dp[i] = f(dq.front().opt, i);

            dq.front().l++;
            if (dq.front().l == dq.front().r) dq.pop_front();

            while (!dq.empty() and f(i, dq.back().l) < f(dq.back().opt, dq.back().l)) dq.pop_back();

            if (dq.empty()) dq.push_back({i, i + 1, n});
            else {
                  int l = dq.back().l, r = dq.back().r;
                  while (r - l > 1) {
                        int mid = (l + r) >> 1;

                        if (f(i, mid) < f(dq.back().opt, mid)) r = mid;
                        else l = mid;
                  }

                  dq.back().r = r;
                  if (r != n) dq.push_back({i, r, n});
            }
      }
      cout << fixed << setprecision(10);
      cout << dp.back();
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " \n"[i == a.size() - 1];
    return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a)
        is >> i;
    return is;
}
// endregion