#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(0);
#endif

      int n, q;
      cin >> n >> q;

      vector<int> cnt(1e5 + 50);
      vector<map<int, int>> used(1e5 + 50);
      vector<set<int>> bad(1e5 + 50);
      int good = 0;

      for (int i = 0; i < q; ++i) {
            char t;
            int u, v, c;
            cin >> t >> u >> v >> c;

            u--, v--;

            if (t == '+') {
                  good -= (bad[c].size() == 0) * (cnt[c]);
                  if (used[c][u]) {
                        bad[c].insert(u);
                  }
                  if (used[c][v]) {
                        bad[c].insert(v);
                  }
                  used[c][u]++;
                  used[c][v]++;
                  cnt[c]++;
                  good += (bad[c].size() == 0) * (cnt[c]);
            } else {
                  good -= (bad[c].size() == 0) * (cnt[c]);
                  if (used[c][u] == 2) {
                        bad[c].erase(u);
                  }
                  if (used[c][v] == 2) {
                        bad[c].erase(v);
                  }
                  used[c][u]--;
                  used[c][v]--;
                  cnt[c]--;
                  good += (bad[c].size() == 0) * cnt[c];
            }

            cout << good << "\n";
      }
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
      for (int i = 0; i < a.size(); i++)
            os << a[i] << " \n"[i == a.size() - 1];
      return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
      for (auto &i: a)
            is >> i;
      return is;
}
// endregion