def solve():
    t = int(input()) 
    for _ in range(t):
        n, m, k = map(int, input().split())  
        p = list(map(int, input().split()))  
        a = list(map(int, input().split()))  
        segments = []
        
        for i in range(k):
            l, r = map(int, input().split())
            segments.append((l - 1, r - 1, i + 1))  
        position_in_a = {value: idx for idx, value in enumerate(a)}
        
        positions = [position_in_a[x] for x in p]

        segments.sort(key=lambda x: x[1])

        current_position = -1 
        selected_segments = []

        for start, end, idx in segments:
            if start > current_position:
                current_position = end
                selected_segments.append(idx)
            

            if current_position >= positions[-1]:
                break
        
        if current_position >= positions[-1]:

            print(len(selected_segments))
            print(' '.join(map(str, selected_segments)))
        else:

            print(-1)

solve()
