#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

using namespace std;

bool is_sorted(vector<int>& a) {
    for (size_t i = 0; i < a.size() - 1; ++i) {
        if (a[i] > a[i + 1]) return false;
    }
    return true;
}

int main() {
    ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
    int n;
    cin >> n;
    vector<int> f(n), b(n);
    for (int& x : f) cin >> x;
    for (int& x : b) cin >> x;

    vector<pair<int, int>> c;
    for (int i = 0; i < n; ++i) {
        c.emplace_back(min(f[i], b[i]), max(f[i], b[i]));
    }
    sort(c.begin(), c.end());

    vector<int> u;
    for (auto& p : c) u.push_back(p.second);

    if (is_sorted(u)) {
        for (auto& p : c) cout << p.first << " ";
        cout << endl;
        for (auto& p : c) cout << p.second << " ";
        cout << endl;
    } else {
        cout << -1 << endl;
    }

    return 0;
}
