#include <bits/stdc++.h>
using namespace std;
#define ll long long
double pointToLineDistance(ll x1, ll y1, ll x2, ll y2, ll px, ll py) {
    if (x1 == x2 && y1 == y2) {
        return sqrt((px - x1) * (px - x1) + (py - y1) * (py - y1));
    }
    ll A = y2 - y1;
    ll B = x1 - x2;
    ll C = x2 * y1 - x1 * y2;
    return abs(A * px + B * py + C) / sqrt(A * A + B * B);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll x1, x2, x3, y1, y2, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
    double dist1 = pointToLineDistance(x1, y1, x2, y2, x3, y3);
    double dist2 = pointToLineDistance(x1, y1, x3, y3, x2, y2);
    double dist3 = pointToLineDistance(x2, y2, x3, y3, x1, y1);
    double x = min({dist1, dist2, dist3});
    if(x == dist1) {
        cout << x1 << " " << y1 << " " << x2 << " " << y2;
    } else if(x == dist2) {
        cout << x1 << " " << y1 << " " << x3 << " " << y3;
    } else {
        cout << x2 << " " << y2 << " " << x3 << " " << y3;
    }
    return 0;
}
