def main():
    n, q = map(int, input().split())
    fggf = {}
    vr = [{} for _ in range(n+1)]
    pc = set()

    def klychkov(v, u, c):
        if c not in fggf:
            fggf[c] = set()
        fggf[c].add((min(v, u), max(v, u)))
        if c not in vr[v]:
            vr[v][c] = 0
        if c not in vr[u]:
            vr[u][c] = 0
        vr[v][c] += 1
        vr[u][c] += 1

        pf = True
        for x in range(1, n+1):
            if vr[x].get(c, 0) > 1:
                pf = False
                break

        if pf:
            pc.add(c)
        else:
            pc.discard(c)

    def puck(v, u, c):
        e = (min(v, u), max(v, u))
        if c in fggf:
            fggf[c].remove(e)
            if not fggf[c]:
                del fggf[c]

        if c in vr[v]:
            vr[v][c] -= 1
            if vr[v][c] == 0:
                del vr[v][c]

        if c in vr[u]:
            vr[u][c] -= 1
            if vr[u][c] == 0:
                del vr[u][c]

        pr = True
        for x in range(1, n+1):
            if vr[x].get(c, 0) > 1:
                pr = False
                break

        if pr and c in fggf:
            pc.add(c)
        else:
            pc.discard(c)

    for _ in range(q):
        op, v, u, c = input().split()
        v, u, c = int(v), int(u), int(c)

        if op == '+':
            klychkov(v, u, c)
        else:  # op == '-'
            puck(v, u, c)

        res = sum(len(fggf[c]) for c in pc)
        print(res)

main()
