from collections import defaultdict
n, q = map(int, input().split())
f = defaultdict(set)
def add_edge(color, u, v):
    edge = (min(u, v), max(u, v))
    f[color].add(edge)
def remove_edge(color, u, v):
    edge = (min(u, v), max(u, v))
    f[color].discard(edge)
def is_excellent(color):
    if color not in f:
        return 0
    seen = set()
    count = 0
    for (u, v) in f[color]:
        if u in seen or v in seen:
            return 0
        seen.add(u)
        seen.add(v)
        count += 1
    return count
for _ in range(q):
    operation = input().split()
    op = operation[0]
    u, v, c = int(operation[1]), int(operation[2]), int(operation[3])
    if op == '+':
        add_edge(c, u, v)
    else:
        remove_edge(c, u, v)
    ans = sum(is_excellent(color) for color in f)
    print(ans)