from collections import defaultdict

n, q = map(int, input().split())

g = []
rg = defaultdict(lambda: defaultdict(int))

def klychkov(puck):
    count1 = sum(1 for u, v, c in g if c == puck)
    return count1

for _ in range(q):
    q1 = input().split()
    op, u, v, c = q1[0], int(q1[1]), int(q1[2]), int(q1[3])
    k2 = (min(u, v), max(u, v), c)

    if op == '+':
        g.append(k2)
        rg[u][c] += 1
        rg[v][c] += 1
    else:
        g.remove(k2)
        rg[u][c] -= 1
        rg[v][c] -= 1

    res = 0
    for i in {c for u, v, c in g}:
        k3 = False
        for counts in rg.values():
            if i in counts and counts[i] > 1:
                k3 = True
                break
        if not k3:
            res += klychkov(i)

    print(res)
