#include<bits/stdc++.h>
using namespace std;

int main() {
    long long n, m, s;
    cin >> n >> m >> s;

    if (s == n * m) {
        cout << 0 << endl;
        return 0;
    }
    int min_cuts = -1;
    for (int total_cuts = 0; total_cuts <= n + m - 2; ++total_cuts) {
        for (int x = 0; x <= total_cuts; ++x) {
            int y = total_cuts - x;
            if (x >= n  y >= m) continue;

            vector<long long> piece_sizes;
            long long piece_width = m / (y + 1);
            long long rem_width = m % (y + 1);
            long long piece_height = n / (x + 1);
            long long rem_height = n % (x + 1);
            for (int i = 0; i <= x; ++i) {
                for (int j = 0; j <= y; ++j) {
                    piece_sizes.push_back((piece_height + (i < rem_height)) * (piece_width + (j < rem_width)));
                }
            }

            long long max_sum = 0;
            for (long long size : piece_sizes) max_sum += size;

            if (s > max_sum) continue;
            vector<bool> dp(s + 1, false);
            dp[0] = true;

            for (long long size : piece_sizes) {
                for (long long i = s; i >= size; --i) {
                    dp[i] = dp[i]  dp[i - size];
                }
            }

            if (dp[s]) {
                min_cuts = total_cuts;
                break;
            }
        }
        if (min_cuts != -1) break;
    }

    cout << min_cuts << endl;
    return 0;
}
