#include <bits/stdc++.h>
using namespace std;

int main() {
    long long n, q;
    cin >> n >> q;

    unordered_map<long long, long long> total_count;           //    
    vector<unordered_map<long long, long long>> node_color_count(n + 1);  //     
    unordered_map<long long, long long> invalid_count;          //    (      )

    long long valid_sum = 0;  //   

    while (q--) {
        char op;
        long long v, u, c;
        cin >> op >> v >> u >> c;

        //   "+",   c
        if (op == '+') {
            //         v  u
            if (node_color_count[v][c] == 0) {
                total_count[c]++;
            }
            if (node_color_count[u][c] == 0) {
                total_count[c]++;
            }

            //    c   v  u
            node_color_count[v][c]++;
            node_color_count[u][c]++;

            // ,   c   2    ,   
            if (node_color_count[v][c] == 2) {
                invalid_count[c]++;
            }
            if (node_color_count[u][c] == 2) {
                invalid_count[c]++;
            }
        }
        //   "-",   c
        else if (op == '-') {
            //    c   v  u
            if (node_color_count[v][c] == 1) {
                total_count[c]--;
            }
            if (node_color_count[u][c] == 1) {
                total_count[c]--;
            }

            node_color_count[v][c]--;
            node_color_count[u][c]--;

            // ,    c      1,    
            if (node_color_count[v][c] == 1) {
                invalid_count[c]--;
            }
            if (node_color_count[u][c] == 1) {
                invalid_count[c]--;
            }
        }

        //    
        valid_sum = 0;
        for (const auto& [color, count] : total_count) {
            if (count > 0 && invalid_count[color] == 0) {
                valid_sum += count;
            }
        }

        cout << valid_sum << endl;
    }

    return 0;
}
