#include <bits/stdc++.h>
using namespace std;

int main() {
    long long n, q;
    cin >> n >> q;

    unordered_map<long long, long long> total_count;
    vector<unordered_map<long long, long long>> vertex_count(n + 1);
    unordered_set<long long> valid_colors;
    while (q--) {
        char m;
        long long v, u, c;
        cin >> m >> v >> u >> c;

        if (m == '+') {
            total_count[c]++;
            vertex_count[v][c]++;
            vertex_count[u][c]++;
            if (vertex_count[v][c] <= 1 && vertex_count[u][c] <= 1) {
                valid_colors.insert(c);
            } else {
                valid_colors.erase(c);
            }
        }
        else if (m == '-') {
            total_count[c]--;
            vertex_count[v][c]--;
            vertex_count[u][c]--;
            if (vertex_count[v][c] <= 1 && vertex_count[u][c] <= 1) {
                valid_colors.insert(c);
            } else {
                valid_colors.erase(c);
            }
        }

        long long s = 0;
        for (long long color : valid_colors) {
            s += total_count[color];
        }
        cout << s << endl;
    }

    return 0;
}
