#include <bits/stdc++.h>
using namespace std;

int main() {
    long long n, q;
    cin >> n >> q;

    unordered_map<long long, long long> total_count;
    vector<unordered_map<long long, long long>> node_color_count(n + 1);
    unordered_map<long long, long long> invalid_count;
    while (q--) {
        char op;
        long long v, u, c;
        cin >> op >> v >> u >> c;

        if (op == '+') {
            total_count[c]++;
            if (++node_color_count[v][c] == 2) invalid_count[c]++;
            if (++node_color_count[u][c] == 2) invalid_count[c]++;
        } else if (op == '-') {
            if (--node_color_count[v][c] == 1) invalid_count[c]--;
            if (--node_color_count[u][c] == 1) invalid_count[c]--;
            total_count[c]--;
        }

        long long valid_sum = 0;
        for (const auto& [color, count] : total_count) {
            if (count > 0 && invalid_count[color] == 0) {
                valid_sum += count;
            }
        }
        cout << valid_sum << endl;
    }
}
