use std::cmp::{max, min};
use std::io::{self, BufRead};
struct C {
    i: usize,
    x: i64,
    y: i64,
    a: i64,
    b: i64,
    f: bool,
}

fn main() {
    let stdin = io::stdin();
    let mut lines = stdin.lock().lines();
    
    let n: usize = lines.next().unwrap().unwrap().trim().parse().unwrap();
    let mut c: Vec<C> = Vec::with_capacity(n);
    
    for j in 0..n {
        let a: i64 = lines.next().unwrap().unwrap().trim().parse().unwrap();
        c.push(C { i: j, x: 0, y: 0, a, b: 0, f: false });
    }
    
    for j in 0..n {
        let b: i64 = lines.next().unwrap().unwrap().trim().parse().unwrap();
        c[j].b = b;
        c[j].x = min(c[j].a, c[j].b);
        c[j].y = max(c[j].a, c[j].b);
    }
    
    c.sort_by(|p, q| p.x.cmp(&q.x));
    
    let mut pf = c[0].x;
    let mut pb = c[0].y;
    
    for j in 0..n {
        if c[j].x >= pf && c[j].y >= pb {
            pf = c[j].x;
            pb = c[j].y;
            if c[j].a != c[j].x {
                c[j].f = true;
            }
        } else if c[j].y >= pf && c[j].x >= pb {
            pf = c[j].y;
            pb = c[j].x;
            if c[j].a != c[j].y {
                c[j].f = true;
            }
        } else {
            println!("-1");
            return;
        }
    }
    
    let mut fr: Vec<i64> = vec![0; n];
    let mut bk: Vec<i64> = vec![0; n];
    
    for j in 0..n {
        let idx = c[j].i;
        if !c[j].f {
            fr[idx] = c[j].a;
            bk[idx] = c[j].b;
        } else {
            fr[idx] = c[j].b;
            bk[idx] = c[j].a;
        }
    }
    
    for j in 0..n {
        print!("{}{}", fr[j], if j == n - 1 { '\n' } else { ' ' });
    }
    for j in 0..n {
        print!("{}{}", bk[j], if j == n - 1 { '\n' } else { ' ' });
    }
}