#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
bool issorted(const vector<int>& array) {
    for (size_t i = 0; i < array.size() - 1; ++i) {
        if (array[i] > array[i + 1]) {
            return false;
        }
    }
    return true;
}


int main() {
    int n;
    cin >> n;
    
    vector<int> x1(n);
    vector<int> x2(n);
    
    for (int i = 0; i < n; ++i) {
        cin >> x1[i];
    }
    
    for (int i = 0; i < n; ++i) {
        cin >> x2[i];
    }
    
    for (int i = 0; i < n; ++i) {
        if (x2[i] < x1[i]) {
            swap(x1[i], x2[i]);
        }
    }
    
    vector<pair<int, int>> xs(n);
    for (int i = 0; i < n; ++i) {
        xs[i] = make_pair(x1[i], x2[i]);
    }

    sort(xs.begin(), xs.end());

    vector<int> a1(n), b1(n);
    for (int i = 0; i < n; ++i) {
        a1[i] = xs[i].first;
        b1[i] = xs[i].second;
    }

    if (issorted(a1) && issorted(b1)) {
        for (int num : a1) {
            cout << num << " ";
        }
        cout << endl;
        
        for (int num : b1) {
            cout << num << " ";
        }
        cout << endl;
    } else {
        cout << -1 << endl;
    }
    return 0;
}