def find_numbers(n, digits):
    num = int(''.join(map(str, digits)))
    max_denom = 10**6
    max_power = int(log10(max_denom))

    for i in range(max_power + 1):
        for j in range(max_power + 1):
            denom = 2**i * 5**j
            if denom > max_denom:
                break
            a = num * denom
            if a < max_denom:
                return "YES", a, denom

    return "NO"

# Ввод данных
n = int(input())
digits = list(map(int, input()))

# Поиск ответа
result = find_numbers(n, digits)
print(*result)
