def find_optimal_points(x1, y1, x2, y2, x3, y3):
    min_distance = float('inf')
    optimal_points = None
    for x in range(min(x1, x2, x3), max(x1, x2, x3) + 1):
        for y in range(min(y1, y2, y3), max(y1, y2, y3) + 1):
            distance = abs(x1 - x) + abs(y1 - y)
            distance += abs(x2 - x) + abs(y2 - y)
            distance += abs(x3 - x) + abs(y3 - y)
            if distance < min_distance:
                min_distance = distance
                optimal_points = (x, y)
    return optimal_points
x1, y1 = 0, 0
x2, y2 = 10, 10
x3, y3 = 5, 6
optimal_points = find_optimal_points(x1, y1, x2, y2, x3, y3)
print(x1, y1, x2, y2, x3, y3)
