#include <iostream>
#include <cmath>
#include <string>

using namespace std;

bool func(int b) {
    
    while (b % 2 == 0) b /= 2;
    while (b % 5 == 0) b /= 5;
    return b > 1;
}

int main() {
    int n;
    string ss;
    
    cin >> n;
    cin >> ss;

    
    double decimalPart = stod("0." + ss);
    
    for (int b = 2; b < 1000000; ++b) {
        if (func(b)) {
            int a = static_cast<int>(decimalPart * b);

            if (0 < a && a < b && fabs(static_cast<double>(a) / b - decimalPart) < 1e-17) {
                cout << "YES" << endl;
                cout << a << " " << b << endl;
                return 0;
            }
        }
    }
    
    cout << "NO" << endl;
    return 0;
}
