def generate_n_minos(n):
    # Проверка невозможных случаев
    if n == 1:
        return [[1]]
    if n > 1 and n % 2 == 0:
        return -1  # Для простоты, тут указано, что решение невозможно (это уточняется)

    # Матрица для хранения разбиения
    grid = [[0] * n for _ in range(n)]
    current_id = 1

    # Генерация простого разбиения (например, змейкой)
    for i in range(n):
        for j in range(n):
            grid[i][j] = current_id
            if (j + 1) % n == 0:  # Переход к следующей фигуре
                current_id += 1

    # Условие: каждый блок уникален
    return grid


# Ввод
n = int(input())

# Генерация разбиения
result = generate_n_minos(n)

# Вывод
if result == -1:
    print(-1)
else:
    for row in result:
        print(" ".join(map(str, row)))
