import math

def solve(x0, y0, x1, y1, n, a):
    # Проверяем, возможно ли это движение вообще
    total_distance = math.sqrt((x1 - x0) * 2 + (y1 - y0) * 2)
    total_jump_distance = sum(a)
    
    if abs(total_distance - total_jump_distance) > 1e-6:
        print("Impossible")
        return
    
    # Инициализация начальной точки
    x, y = x0, y0
    positions = [(x, y)]
    
    # Используем простое решение: равномерное распределение углов
    # Рассчитываем общую угол, по которому будут двигаться все прыжки
    angle = math.atan2(y1 - y0, x1 - x0)
    
    # Преобразуем длину прыжков в (dx, dy) используя углы
    for i in range(n):
        # Для каждого прыжка вычисляем его вклад в координаты
        # Прямолинейное движение по направлению (angle)
        dx = a[i] * math.cos(angle)
        dy = a[i] * math.sin(angle)
