#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector<int> front(n), back(n);
    vector<pair<int, int>> cards(n);
    for (int i = 0; i < n; ++i) {
        cards[i] = {a[i], b[i]};
    }
    sort(cards.begin(), cards.end());
    int prev_front = -1, prev_back = -1;

    // Проходим по карточкам
    for (int i = 0; i < n; ++i) {
        int f = cards[i].first;
        int b = cards[i].second;
        if (f >= prev_front && b >= prev_back) {
            if (f <= b) {
                front[i] = f;
                back[i] = b;
                prev_front = f;
                prev_back = b;
            } else {
                front[i] = b;
                back[i] = f;
                prev_front = b;
                prev_back = f;
            }
        }
        else if (f >= prev_front) {
            front[i] = f;
            back[i] = b;
            prev_front = f;
            prev_back = b;
        } else if (b >= prev_back) {
            front[i] = b;
            back[i] = f;
            prev_front = b;
            prev_back = f;
        } else {
            cout << -1 << endl;
            return 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << front[i] << " ";
    }
    cout << endl;

    for (int i = 0; i < n; ++i) {
        cout << back[i] << " ";
    }
    cout << endl;

    return 0;
}