def solve(n, m, s):
    if n * m == s:
        print(0)
        return
    min_cuts = float('inf')
    for height in range(1, int(s**0.5) + 1):
        if s % height == 0:
            width = s // height
            if height <= n and width <= m:
                cuts = (height - 1) + (width - 1)
                min_cuts = min(min_cuts, cuts)
            if width <= n and height <= m:
                cuts = (width - 1) + (height - 1)
                min_cuts = min(min_cuts, cuts)
    if min_cuts == float('inf'):
        print(-1)
    else:
        print(min_cuts)
n, m, s = map(int, input().split())

solve(n, m, s)
