n = int(input())
a = list(map(int, input().split()))
b = list(map(int, input().split()))

cards = sorted(zip(a, b), key=lambda x: (x[0], x[1]))  # Сортировка по обеим картам

top, bottom = [], []
prev_top = prev_bottom = -float('inf')

for x, y in cards:
    # Сначала пытаемся положить карту (x, y) в (top, bottom)
    if x >= prev_top and y >= prev_bottom:
        top.append(x)
        bottom.append(y)
        prev_top, prev_bottom = x, y
    # Если не получилось, пробуем положить наоборот (y, x)
    elif y >= prev_top and x >= prev_bottom:
        top.append(y)
        bottom.append(x)
        prev_top, prev_bottom = y, x
    else:
        # Если не удается положить карту, то выводим -1
        print(-1)
        break
else:
    # Если мы завершили цикл без ошибок, выводим top и bottom
    print(*top)
    print(*bottom)
