#include <bits/stdc++.h>
#define fast_io cin.tie(NULL)->sync_with_stdio(0);
#define all(x) (x).begin(), (x).end()
#define debug(x) cerr << (#x) << " " << (x) << endl
#define SZ(s) ((int)s.size())
#define pb push_back
#define ff first
#define ss second
#define int long long
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

const int MOD = 1e9 + 7;
const int N = 2e5 + 100;
const int inf = 1e18;

int binpow(int a, int b, int m) {
    a %= m;
    int res = 1;
    while (b) {
        if (b & 1)
            res = res * a % m;
        a = a * a % m;
        b >>= 1;
    }
    return res;
}

int inv(int a) {
    return a <= 1 ? a : MOD - (int) (MOD / a) * inv(MOD % a) % MOD;
}

bool check(double a, double b, double c) {
    return a + b > c && a + c > b && b + c > a;
}

void solve() {
    int c, h;
    cin >> c >> h;
    bool ok = 0;
    double m = c / 2.0;
    if(m * m - h * h < 0) ok = 0;
    double k = sqrt(m * m - h * h);
    double x = m + k;
    double y = c - x;
    // cout << x << ' ' << y << '\n';
    double d1 = sqrt(x * x + h * h);
    double d2 = sqrt(y * y + h * h);
    if(check(d1, x, double(h)) && check(d2, y, double(h)) && check(double(c), d1, d2)) ok = 1;
    if(h > c / 2.0) {   
        cout << -1;
    } else {
        cout << c * h / 2.0;
    }
}

signed main() {
    fast_io;
    int t = 1;
    // cin >> t;
    for (int i = 1; i <= t; i++) {
        solve();
        cout << "\n";
    }
    return 0;
}
