#include <bits/stdc++.h>
#define fast_io cin.tie(NULL)->sync_with_stdio(0);
#define all(x) (x).begin(), (x).end()
#define debug(x) cerr << (#x) << " " << (x) << endl
#define SZ(s) ((int)s.size())
#define pb push_back
#define ff first
#define ss second
#define int long long
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

const int MOD = 1e9 + 7;
const int N = 2e5 + 100;
const int inf = 1e18;

int binpow(int a, int b, int m) {
    a %= m;
    int res = 1;
    while (b) {
        if (b & 1)
            res = res * a % m;
        a = a * a % m;
        b >>= 1;
    }
    return res;
}

int inv(int a) {
    return a <= 1 ? a : MOD - (int) (MOD / a) * inv(MOD % a) % MOD;
}

bool check(double a, double b, double c) {
    return a + b > c && a + c > b && b + c > a;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<pii, int>> a(n * 2);
    vector <int> v(n), w(n);
    vector<bool> used(n);
    for(int i = 0; i < n; i ++) {
        cin >> a[i].ff.ff;
    }

    for(int i = 0; i < n; i ++) {
        cin >> a[i].ff.ss;
        a[i + n].ff = {a[i].ff.ss, a[i].ff.ff};
        a[i].ss = i; a[i + n].ss = i;
    }

    sort(all(a));

    bool ok = true;
    vector <pii> b(n); b[0] = a[0].ff; used[a[0].ss] = 1;
    int j = 1;
    for (int i = 1; i < 2 * n; i ++) {
        if (used[a[i].ss] == 1) continue;

        if (b[j - 1].ss > a[i].ff.ss) {
            ok = false;
            break;
        }

        b[j] = a[i].ff;
        used[a[i].ss] = 1;
        j ++;
    }

    if (!ok) {
        cout << -1;
        return;
    }

    for (int i = 0; i < n; i ++) {
        cout << b[i].ff << ' ';
    }
    cout << endl;
    for (int i = 0; i < n; i ++) {
        cout << b[i].ss << ' ';
    }
}

signed main() {
    fast_io;
    int t = 1;
    // cin >> t;
    for (int i = 1; i <= t; i++) {
        solve();
        cout << "\n";
    }
    return 0;
}
