import math

def min_cuts(l, m, n):
  if l * m == n:
    return 0
  if l == 1 or m == 1:
    return max(l, m) - 1

  best_cuts = float('inf')
  

  if l % 2 == 0:
   cuts = min_cuts(l // 2, m, n // 2) + min_cuts(l // 2, m, n - n // 2) + 1
   best_cuts = min(best_cuts, cuts)
  if m % 2 == 0:
   cuts = min_cuts(l, m // 2, n // 2) + min_cuts(l, m // 2, n - n // 2) + 1
   best_cuts = min(best_cuts, cuts)

  return best_cuts

l, m, n = map(int, input().split())
result = min_cuts(l, m, n)
print(result if result != float('inf') else -1)
