#include <bits/stdc++.h>
using namespace std;
struct Card {
    int a, b;
    int index;
};
bool solve(int n, vector<Card>& cards) {
    sort(cards.begin(), cards.end(), [](Card& x, Card& y) {
        return min(x.a, x.b) < min(y.a, y.b);
    });
    vector<int> top(n), bottom(n);
    int prevTop = 0, prevBottom = 0;
    for (int i = 0; i < n; ++i) {
        int a = cards[i].a, b = cards[i].b;
        if (a >= prevTop && b >= prevBottom) {
            top[i] = a;
            bottom[i] = b;
            prevTop = a;
            prevBottom = b;
        } else if (b >= prevTop && a >= prevBottom) {
            top[i] = b;
            bottom[i] = a;
            prevTop = b;
            prevBottom = a;
        } else {
            return false;
        }
    }
    for (int i = 0; i < n; ++i) cout << top[i] << " ";
    cout << endl;
    for (int i = 0; i < n; ++i) cout << bottom[i] << " ";
    cout << endl;
    return true;
}

int main() {
    int n;
    cin >> n;
    vector<Card> cards(n);

    for (int i = 0; i < n; ++i) cin >> cards[i].a;
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].b;
        cards[i].index = i;
    }
    if (!solve(n, cards)) {
        cout << -1 << endl;
    }

    return 0;
}
