def triangle_area(c, h):
    if h >= c:
        return -1  # Треугольник не существует
    
    # Проверка условия h^2 = p * q, где p + q = c
    h_squared = h * h
    discriminant = c * c - 4 * h_squared
    if discriminant < 0:
        return -1  # Нет решений
    
    # Площадь треугольника
    area = 0.5 * c * h
    return area


# Пример ввода
c = int(input("Введите длину гипотенузы c: "))
h = int(input("Введите длину высоты h: "))

result = triangle_area(c, h)
if result == -1:
    print("Треугольник не существует")
else:
    print(f"Площадь треугольника: {result:.4f}")
