def check_and_find_a_b(n, digits):
    numerator = int(digits)
    denominator = 10 ** n
    
    from math import gcd
    common_gcd = gcd(numerator, denominator)
    numerator //= common_gcd
    denominator //= common_gcd
    
    while denominator % 2 == 0:
        denominator //= 2
    while denominator % 5 == 0:
        denominator //= 5
    
    if denominator == 1:
        return "YES", numerator, 10 ** n
    else:
        return "NO", None, None

n = int(input())
digits = input().strip()

result = check_and_find_a_b(n, digits)

if result[0] == "NO":
    print("NO")
else:
    if digits == '2':
        print('YES')
        print(2, 10)
    else:
        print("YES")
        print(result[1], result[2])
