def min_cuts_final_strict(n, m, s):
    if s > n * m:
        return -1

    min_cuts = float('inf')

    for horizontal in range(n + 1):
        for vertical in range(m + 1):
            area1 = horizontal * m
            area2 = vertical * n
            area3 = (n - horizontal) * (m - vertical)

            if (area1 + area2 == s or area1 + area3 == s or area2 + area3 == s) and \
                    area1 <= s and area2 <= s and area3 <= s:
                min_cuts = min(min_cuts, horizontal + vertical)

    return min_cuts if min_cuts != float('inf') else -1

n, m, s = map(int, input().split())
print(min_cuts_final_strict(n, m, s))
