coords = list(map(float, input().split()))

x1, y1, x2, y2, x3, y3 = coords

points = [(x1, y1), (x2, y2), (x3, y3)]

def distance_to_line(A, B, C, x, y):
    abs_value = abs(A * x + B * y + C)
    sqrt_value = (A**2 + B**2)**0.5
    return abs_value / sqrt_value

min_distance = float('inf')
best_points = None

for i in range(3):
    for j in range(i + 1, 3):
        x1, y1 = points[i]
        x2, y2 = points[j]
        
        A = y2 - y1
        B = x1 - x2
        C = -(A * x1 + B * y1)
        
        for k in range(3):
            if k != i and k != j:
                x3, y3 = points[k]
                dist = distance_to_line(A, B, C, x3, y3)
                if dist < min_distance:
                    min_distance = dist
                    best_points = (points[i], points[j])

print(f"{int(best_points[0][0])} {int(best_points[0][1])} {int(best_points[1][0])} {int(best_points[1][1])}")
