from collections import defaultdict

def update(color, edge):
    return [i for i in color if i != edge]

def isPerfect(color):
    for i in range(len(color)):
        edge = update(color, color[i])
        if any(color[i][0] in e or color[i][1] in e for e in edge):
            return False
    return True

n, q = map(int, input().split())

Graph = defaultdict(list)
for _ in range(q):
    m, v, u, c = input().split()
    v, u, c = int(v), int(u), int(c)

    if m == '+':
        Graph[c].append(sorted([v, u]))
    elif m == '-':
        Graph[c].remove(sorted([v, u]))

    cnt = sum(1 for color in Graph.values() if isPerfect(color))

    print(cnt)
