#include <bits/stdc++.h> 
using namespace std;

typedef long long ll;
typedef long double ld;
const int inf=1e6;

#define sz(s) (int)s.size()
const int N = (int)1e6 + 12;

int n, m;
ld c;
ld x[N], t[N], dp[N];
struct line{
    ld k, b;
    ld get(ld x) {
        return k * x + b;
    }  
};
vector<line> l;
ld cross(line x, line y) {
    return (x.b - y.b) / (y.k - x.k);
}
void add(line  x) {
    while((int)l.size() >= 2 && cross(l.back(), x) <= cross(l.back(), l[(int)l.size() - 2])) {
        l.pop_back();
    }
    l.push_back(x);
}
ld get(ld x) {
    int  L = -1, R = (int)l.size() - 1;
    while(R - L > 1) {
        int mid = (L + R) >> 1;
        if(cross(l[mid], l[mid + 1]) >= x) {
            R = mid;
        } else {
            L = mid;
        }
    }
    return l[R].get(x);
    ld val = 1e18;
    for(auto i:l) {
        val = min(val, i.get(x));
    }
    return val;
}
void test() {
    cin >> n >> m >> c;
    for(int i = 1; i <= n; i++) {
        ll X, T;
        cin >> X >> T;
        x[i] = X;
        t[i] = T;
    }
    n++;
    x[n] = m;
    for(int i = 0; i <= n; i++) {
        if(!i) {
            dp[i] = 0;
        } else {
            dp[i] = get(x[i]) + x[i] * x[i] / c; 
        }
        add({-2 * x[i] / c, dp[i] + t[i] + x[i] * x[i] / c});
    }

    cout << fixed << setprecision(9) << dp[n] << '\n';
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    test();
}