#include <bits/stdc++.h> 
using namespace std;

typedef long long ll;
#define int ll
const int inf=1e6;

#define sz(s) (int)s.size()
const int N = (int)1e6 + 12, MOD = (int)1e9 + 7, MOD1 = 998244353;
const int pr = 37, pr1 = 331;

ll binpow(ll a, ll b, ll m) {
    ll ret = 1, k = a;
    while(b) {
        if(b & 1) {
            ret *= k;
            ret %= m;
        }
        k *= k;
        k %= m;
        b /= 2;
    }
    return ret;
}
int n, m, k, h[N], pos[N], p[N], a[N];
int l[N], r[N], h1[N];
vector<pair<int, int>> g[N];

struct has {
    int h[N], h1[N];
    void init(int m, int b[]) {
        h[0] = h1[0] = 0;
        for(int i = 1; i <= m; i++) {
            h[i] = (h[i - 1] + binpow(pr, i, MOD) * b[i]) % MOD;
            h1[i] = (h1[i - 1] + binpow(pr1, i, MOD1) * b[i]) % MOD1;
        }
    }
    pair<ll, ll> get(int l, int r) {
        ll x = (h[r] - h[l - 1] + MOD) % MOD, y = (h1[r] - h1[l - 1] + MOD1) % MOD1;
        x = x * binpow(binpow(pr, l - 1, MOD), MOD - 2, MOD) % MOD;
        y = y * binpow(binpow(pr1, l - 1, MOD1), MOD1 - 2, MOD1) % MOD1;
        return {x, y};
    }
}A, P;
pair<ll, ll> calc() {
    ll h = 0, h1 = 0;
    for(int i = 1; i <= n; i++) {
        h = (h + binpow(pr, i, MOD) * p[i] % MOD) % MOD;
        h1 = (h1 + binpow(pr1, i, MOD1) * p[i] % MOD1) % MOD1;
    }
    return {h, h1};
}
int e[N];
pair<int, int> dp[N][2];
pair<int, int> pp[N][2];
void test() {
    cin >> n >> m >> k;
    for(int i = 1; i <= n; i++) {
        cin >> p[i];
        pos[p[i]] = i;
        g[i].clear();
    }
    for(int i = 1; i <= m; i++) {
        cin >> a[i];
        e[i] = 0;
    }
    if(m < n) {
        cout << -1 << '\n';
        return;
    }
    vector<array<int, 3>> f;
    for(int i = 1; i <= k; i++) {
        cin >> l[i] >> r[i];
        f.push_back({l[i], r[i], i});
    }
    A.init(m, a);
    P.init(n, p);  
    pair<ll, ll> val = calc();
    vector<pair<int, int>> gd;
    for(int i = 1; i + n - 1 <= m; i++) {
        pair<ll, ll> c = A.get(i, i + n - 1);
        e[i] = e[i - 1];
        if(c == val) {
            e[i]++;
        }
    }
    for(int i = 1; i <= k; i++) {
        // j + n - 1 <= r -> j == r - n + 1
        int j = r[i] - n + 1;
        if(j >= l[i] && e[j] - e[l[i] - 1]) {
            cout << 1 << '\n' << i << '\n';
            return;
        }
    }
    auto edge = [&](int l, int r, int i) {
        int l1 = pos[a[l]], r1 = l1 + (r - l + 1) - 1;
        if(r1 <= n && P.get(l1, r1) == A.get(l, r)) {
            g[l1].emplace_back(r1, i);
        }
        {
            r1 = pos[a[r]];
            l1 =  r - r1 + 1;
            if(l1 >= 1) {
                if(A.get(l1, r) == P.get(1, r1)) {
                    g[1].emplace_back(r1, i);
                    // cout << r1 << ' ' << i << '\n';
                }
            }
        }
        {
            int val = pos[a[l]], val1 = n;
            if(P.get(val, val1) == A.get(l, l + (val1 - val))) {
                g[val].emplace_back(n, i);
            }
        }
    };
    const int inf = (int)1e9;
    for(int i = 1; i <= n; i++) {
        dp[i][0] = {inf, inf};
        dp[i][1] = {inf, inf};
        pp[i][0] = pp[i][1] = {-1, -1};
    }
    for(int i = 1; i <= k; i++) {
        edge(l[i], r[i], i);
    }

    for(int i = n; i >= 1; i--) {
        vector<array<int, 4>> vals;
        for(auto [to, id]:g[i]) {
            // cout << i << ' ' << to + 1 << '\n';
            to++;
            if(to == n + 1) {
                vals.push_back({1, id, id, to});
            } else {
                if(id != dp[to][0].second && dp[to][0].first != inf) vals.push_back({dp[to][0].first + 1, dp[to][0].second, id, to});
                if(id != dp[to][1].second && dp[to][1].first != inf) vals.push_back({dp[to][1].first + 1, dp[to][1].second, id, to});
            }
        }
        if(vals.empty()) continue;
        sort(vals.begin(), vals.end());
        dp[i][0].first = vals[0][0];
        dp[i][0].second  = vals[0][1];
        pp[i][0].first = vals[0][2];
        pp[i][0].second = vals[0][3];

        for(int j = 1; j < (int)vals.size(); j++) {
            if(vals[j][1] != vals[0][1]) {
                dp[i][1].first = vals[j][0];
                dp[i][1].second = vals[j][1];
                pp[i][1].first = vals[j][2];
                pp[i][1].second = vals[j][3];
                break;
            }
        }
    }
    if(pp[1][0].first == -1) {
        cout << -1 << '\n';
        return;
    }
    vector<int> res;
    int x = 1;
    while(x != n + 1) {
        res.push_back(pp[x][0].first);
        x = pp[x][0].second;
        // cerr << x << '\n';
    }
    cout << (int)res.size() << '\n';
    for(int i:res) {
        cout << i << ' ';
    }
    cout << '\n';
}
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    cin >> t;
    while(t--) {
        test();
    }
}