#include <bits/stdc++.h>

#define int long long

using namespace std;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

const int oo = 1e18;
const int inf = 1e18;
const int mod = 1e9 + 7;

int binpow(int n, int k) {
    if(k == 0) return 1;
    if(k & 1 == 0) {
        int x = binpow(n, k/2);
        return x * x;
    }
    return n * binpow(n, k-1);
}

void solve() {
    int n, m, s; cin >> n >> m >> s;
    if(n > m) swap(n, m);
    bool ok = false;
    for(int i = 2; i * i <= s; ++i) {
        if(s % i == 0) {
            ok = true;
            break;
        }
    }
    if(ok) {
        if(s == n * m) {
            cout << 0;
            return;
        }
        if(s % n == 0 || s % m == 0) {
            cout << 1;
            return;
        }
        for(int i = n; i >= 1; --i) {
            if(s % i == 0 && s / i <= m) {
                cout << 2;
                return;
            }
        }
        cout << 3 - (s / m == n - 1);
        return;
    }
    if(s > max(n, m)) {
        cout << 3 - (s / m == n - 1);
    }
    else cout << 1;
}

signed main() {
    // cout.precision(16);
    cout << fixed << setprecision(12);

    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}