#include <bits/stdc++.h>
using namespace std;
const int MAX_COLOR = 100005;
int main(nullptr) {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    unordered_map<int, unordered_map<int, int>> edges;
    unordered_map<int, int> color_count;
    unordered_map<int, unordered_map<int, int>> degree;
    long long total_beauty = 0;
    while (q--) {
        char type;
        int v, u, c;
        cin >> type >> v >> u >> c;
        if (type == '+') {
            degree[c][v]++;
            degree[c][u]++;
            edges[c][v]++;
            edges[c][u]++;
            color_count[c]++;
        } else if (type == '-') {
            degree[c][v]--;
            degree[c][u]--;
            edges[c][v]--;
            edges[c][u]--;
            color_count[c]--;
        }
        total_beauty = 0;
        for (auto& pair : color_count) {
            int color = pair.first;
            if (color_count[color] <= 1) {
                total_beauty += color_count[color];
            }
        }
        cout << total_beauty << '\n';
    }
    return 0;
}
