#include <bits/stdc++.h>
using namespace std;
int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    vector<pair<int, int>> cards(n);
    for (int i = 0; i < n; i++) {
        cards[i] = {a[i], b[i]};
    }
    sort(cards.begin(), cards.end(), [](const pair<int, int>& x, const pair<int, int>& y) {
        return min(x.first, x.second) < min(y.first, y.second);
    });
    vector<int> result_a(n), result_b(n);
    int last_a = -1, last_b = -1;
    for (int i = 0; i < n; i++) {
        int a_side = cards[i].first;
        int b_side = cards[i].second;
        if (a_side >= last_a && b_side >= last_b) {
            result_a[i] = a_side;
            result_b[i] = b_side;
            last_a = a_side;
            last_b = b_side;
        } else if (b_side >= last_a && a_side >= last_b) {
            result_a[i] = b_side;
            result_b[i] = a_side;
            last_a = b_side;
            last_b = a_side;
        } else {
            cout << -1 << endl;
            return 0;
        }
    }
    for (int i = 0; i < n; i++) {
        cout << result_a[i] << " ";
    }
    cout << endl;
    for (int i = 0; i < n; i++) {
        cout << result_b[i] << " ";
    }
    cout << endl;
    return 0;
}
