import sys

def min_time_to_moscow(n, m, c, stations):
    dp = [sys.maxsize] * (n + 1)
    dp[0] = 0
    fuel = c
    current_pos = 0

    for i in range(1, n + 1):
        distance = stations[i][0] - current_pos
        fuel -= distance
        for j in range(i):
            dp[i] = min(dp[i], dp[j] + stations[j][1])
        dp[i] = min(dp[i], dp[i-1] + stations[i][1])
        fuel = c

    distance = m - current_pos
    for i in range(n + 1):
        dp[n] = min(dp[n], dp[i] + distance)

    return dp[n]

# Ввод данных
n, m, c = map(int, input().split())
stations = [(0, 0)] + [tuple(map(int, input().split())) for _ in range(n)]

# Вычисление минимального времени
result = min_time_to_moscow(n, m, c, stations)

# Вывод результата
print(result)
