def check_spell(n, m, k, permutation, runes, students):
    permutation_set = set(permutation)
    runes_set = set(runes)
    
    for student_order in permutations(range(1, k + 1)):
        student_runes = set()
        for student_num in student_order:
            l, r = students[student_num - 1]
            student_runes.update(runes[l-1:r])
            if permutation_set.issubset(student_runes):
                return len(student_order), student_order
        
    return -1, []

# Ввод данных
t = int(input())
for _ in range(t):
    n, m, k = map(int, input().split())
    permutation = list(map(int, input().split()))
    runes = list(map(int, input().split()))
    students = [list(map(int, input().split())) for _ in range(k)]
    
    # Проверка заклинания
    min_students, student_order = check_spell(n, m, k, permutation, runes, students)
    
    # Вывод результата
    print(min_students)
    if min_students != -1:
        print(*student_order)

