﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

//struct DSU {
//    vector<ll> p, sz;
//    DSU() {};
//    DSU(ll n) {
//        init(n);
//    }
//
//    void init(ll n) {
//        p.resize(n);
//        iota(p.begin(), p.end(), 0ll);
//        sz.assign(n, 1);
//    }
//
//    ll leader(ll v) {
//        return (v == p[v] ? v : p[v] = leader(p[v]));
//    }
//
//    bool unite(ll a, ll b) {
//        a = leader(a);
//        b = leader(b);
//        if (a == b) return 0;
//        if (sz[a] < sz[b]) {
//            swap(a, b);
//        }
//        sz[a] += sz[b];
//        p[b] = a;
//        return 1;
//    }
//    ll size(ll n) {
//        return sz[leader(n)];
//    }
//};
//
//struct point {
//    ld x, y;
//};
//
//struct func {
//    ll k, b;
//};
//
//
//void solve() {
//    ll n, q; cin >> n >> q;
//    map<ll, map<ll, ll>> cnt; // для каждого цвета хранит его cnt по вершинам
//    map<ll, ll> wrong; // для каждого цвета хранится количество вершин с ребрами этого цвета >= 2
//    ll res = 0;
//    map<ll, ll> col;
//    while (q--) {
//        char ch; cin >> ch; ll v, u, c; cin >> v >> u >> c;
//        if (ch == '+') {
//            col[c]++;
//            ll cur = wrong[c];
//            if (cnt[c][v] == 1) wrong[c]++;
//            if (cnt[c][u] == 1) wrong[c]++;
//            cnt[c][v]++;
//            cnt[c][u]++;
//            if (col[c] == 1) {
//                ++res;
//                cout << res << '\n';
//                continue;
//            }
//            res -= (cur == 0 && wrong[c] > 0);
//            res += (cur > 0 && wrong[c] == 0);
//        }
//        if (ch == '-') {
//            col[c]--;
//            ll cur = wrong[c];
//            cnt[c][v]--;
//            cnt[c][u]--;
//            if (cnt[c][v] == 1) wrong[c]--;
//            if (cnt[c][u] == 1) wrong[c]--;
//            res -= (cur == 0 && wrong[c] > 0);
//            res += (cur > 0 && wrong[c] == 0);
//        }
//        cout << res << '\n';
//    }
//}
//
//int main() {
//    ios_base::sync_with_stdio(0); cin.tie(0);
//    ll tt = 1;
//    while (tt--) solve();
//}

void solve() {
    int cnt1 = 0, cnt2 = 0;
    for (int i = 4; i >= 1; i /= 2)
    {
        char c;
        cout << '?' << ' ' << -i << ' ' << -i << endl;
        cin >> c;
        if (c == '+') cnt1 += i;
    }
    for (int i = 4; i >= 1; i /= 2)
    {
        char c;
        cout << '?' << ' ' << i << ' ' << i << endl;
        cin >> c;
        if (c == '+') cnt2 += i;
    }
    cnt2 -= cnt1;
    cnt2 = 8 - cnt2;
    cnt1++;
    if (cnt1 == cnt2)
    {
        cout << '!' << ' ' << char(cnt1 + 'a') << cnt2 << endl;
    }
    if (cnt1 < cnt2)
    {
        char c;
        if (cnt1 + cnt2 > 9)
            cout << '?' << ' ' << 8 - cnt1 << ' ' << -(8 - cnt1) << endl;
        else cout << '?' << ' ' << cnt2 - 1 << ' ' << -(cnt2 - 1) << endl;
        cin >> c;
        if (c == '+')
        {
            cout << '!' << ' ' << char(cnt1 + 'a' - 1) << cnt2 << endl;
        }
        else
        {
            cout << '!' << ' ' << char(cnt2 + 'a' - 1) << cnt1 << endl;
        }
    }
    if (cnt1 > cnt2)
    {
        char c;
        if (cnt1 + cnt2 > 9)
            cout << '?' << ' ' << 8 - cnt2 << ' ' << -(8 - cnt2) << endl;
        else cout << '?' << ' ' << cnt1 - 1 << ' ' << -(cnt1 - 1) << endl;
        cin >> c;
        if (c == '+')
        {
            cout << '!' << ' ' << char(cnt2 + 'a' - 1) << cnt1 << endl;
        }
        else
        {
            cout << '!' << ' ' << char(cnt1 + 'a' - 1) << cnt2 << endl;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    ll tt = 1;
    while (tt--) solve();
}
