#include <bits/stdc++.h>
using namespace std;

int main() 
{
  long long n, m, s;
  cin >> n >> m >> s;

  long long min_cuts = -1;

  for(long long total_cuts = 0; total_cuts <= n + m; ++total_cuts){
    for (long long x = 0; x <= total_cuts; ++x){
      long long y = total_cuts - x;
      if (x > n || y > m) continue; 

      long long num_pieces = (x + 1) * (y + 1);
      vector<long long> piece_sizes;
      long long piece_n = n / (x + 1);
      long long piece_m = m / (y + 1);
      long long rem_n = n % (x + 1);
      long long rem_m = m % (y + 1);

      for (long long i = 0; i <= x; ++i){
        for (long long j = 0; j <= y; ++j){
          piece_sizes.push_back((piece_n + (i < rem_n)) * (piece_m + (j < rem_m)));
        }
      }

      vector<bool> dp(s + 1, false);
      dp[0] = true;
      for (long long size : piece_sizes){
        for (long long i = s; i >= size; --i){
          dp[i] = dp[i] || dp[i - size];
        }
      }

      if(dp[s]){
        min_cuts = total_cuts;
        goto found;
      }
    }
  }

found:
  cout << min_cuts << endl;
  return 0;
}
