#include <bits/stdc++.h>
using namespace std;

const int MAXN = 100005;

int n, q;
vector<pair<int, int>> graph[MAXN];
int color_count[MAXN];
int beauty[MAXN];

int main() 
{
  cin >> n >> q;

  int u, v, c;
  for (int i = 0; i < q; i++) {
    char op;
    cin >> op >> u >> v >> c;

    if(op == '+'){
      graph[u].push_back({v, c});
      graph[v].push_back({u, c});
      color_count[c]++;

      if(color_count[c] == 1){
        beauty[c]++;
      } 
	  else if(color_count[c] == 2){
        beauty[c]--;
      }
    } 
	else{
      for(int j = 0; j < graph[u].size(); j++){
        if (graph[u][j].first == v && graph[u][j].second == c){
          graph[u].erase(graph[u].begin() + j);
          break;
        }
      }
      for(int j = 0; j < graph[v].size(); j++){
        if(graph[v][j].first == u && graph[v][j].second == c){
          graph[v].erase(graph[v].begin() + j);
          break;
        }
      }
      color_count[c]--;

      if(color_count[c] == 1){
        beauty[c]++;
      } 
	  else if (color_count[c] == 0){
        beauty[c]--;
      }
    }

    int total_beauty = 0;
    for(int j = 1; j <= 100000; j++){
      total_beauty += beauty[j];
    }

    cout << total_beauty << "\n";
	
  }

  return 0;
}
