def min_cuts(n, m, s, memo={}):

    if s == n * m:
        return 0
    if (n, m, s) in memo:  
        return memo[(n, m, s)]

    min_cuts_val = float('inf')
    for i in range(1, n + 1):
        for j in range(1, m + 1):
            if i * j <= s:
                cuts = 1 + min_cuts(n - i, m, s - i * j, memo)
                min_cuts_val = min(min_cuts_val, cuts)
                cuts = 1 + min_cuts(n, m - j, s - i * j, memo)
                min_cuts_код = min(min_cuts_val, cuts)

    memo[(n, m, s)] = min_cuts_val
    return min_cuts_val

if __name__ == "__main__":

    input_str = input()
    n, m, s = map(int, input_str.split())

    result = min_cuts(n, m, s)
    print(result)
