﻿using System;
using System.Collections.Generic;

class E
{
    static void Main()
    {
        var a = Console.ReadLine().Split(' ');
        int startX = Convert.ToInt32(a[0]);
        int startY = Convert.ToInt32(a[1]);

        var b = Console.ReadLine().Split(' ');
        int endX = Convert.ToInt32(b[0]);
        int endY = Convert.ToInt32(b[1]);

        int jumpCount = Convert.ToInt32(Console.ReadLine());

        var d = Console.ReadLine().Split(' ');
        List<int> jumps = new List<int>();
        for (int i = 0; i < jumpCount; i++)
        {
            jumps.Add(Convert.ToInt32(d[i]));
        }

        int totalJump = jumps.Sum();
        double distance = Math.Sqrt(Math.Pow(endX - startX, 2) + Math.Pow(endY - startY, 2));

        if (totalJump < distance)
        {
            Console.WriteLine("Impossible");
            return;
        }
        else
        {
            Console.WriteLine("Possible");
        }

        if (totalJump == distance)
        {
            double dx = endX - startX;
            double dy = endY - startY;
            double stepSize = distance / totalJump;

            double currentX = startX;
            double currentY = startY;

            for (int i = 0; i < jumps.Count; i++)
            {
                currentX += dx * stepSize * jumps[i];
                currentY += dy * stepSize * jumps[i];
                Console.WriteLine(currentX + " " + currentY);
            }
        }
        else
        {

        }
    }
}