# Задача L. Мультимино
def solve_multimino(n):
    if n == 1:
        # n = 1 единственная клетка — это корректная миношка
        print(1)
        return
    
    if n % 2 == 1:
        grid = [[0] * n for _ in range(n)]
        current_label = 1
        x, y = 0, 0

        while current_label <= n:
            cells = []
            for _ in range(n):
                cells.append((x, y))
                grid[x][y] = current_label
                y += 1
                if y == n:
                    x += 1
                    y = 0
            current_label += 1
        
        for row in grid:
            print(" ".join(map(str, row)))
        return

    else:
        # Для четных n разбиение невозможно
        print(-1)
        
solve_multimino(4)