﻿#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <cmath>

using namespace std;

#define ll long long
#define pb push_back

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    long long n;
    cin >> n;
    vector<long long> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector<pair<long long, long long>> pairs(n);
    for (int i = 0; i < n; ++i) {
        pairs[i] = { min(a[i], b[i]), max(a[i], b[i])};
    }
    sort(pairs.begin(), pairs.end());
    for (int i = 1; i < n; ++i) {
        if ((pairs[i].first > pairs[i - 1].first) && (pairs[i].second > pairs[i - 1].second)) {
            continue;
        }
        else if ((pairs[i].first > pairs[i - 1].second) && (pairs[i].second > pairs[i - 1].first)) {
            swap(pairs[i].first, pairs[i].second);
        }
        else {
            cout << -1;
            return 0;
        }
    }
    for (auto p : pairs) {
        cout << p.first << ' ';
    }
    cout << '\n';
    for (auto p : pairs) {
        cout << p.second << ' ';
    }
}
