﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <bitset>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <deque>
#include <iterator>
#include <numeric>
#include <sstream>
#include <iomanip>
#define decimal fixed << setprecision(17)

#define int long long

#define all(x) x.begin(), x.end()
using namespace std;
using ll = long long;
using dd = long double;
ll nod(ll a, ll b) {
    return b == 0 ? a : nod(b, a % b);
}

struct Point {
    int x, y;

    Point operator-(const Point& p) const {
        return { x - p.x, y - p.y };
    }
};

int cross(Point p1, Point p2) {
    return p1.x * p2.y - p1.y * p2.x;
}

dd dist(Point p1, Point p2) {
    return sqrtl(abs(p1.x - p2.x) * abs(p1.x - p2.x) + abs(p1.y - p2.y) * abs(p1.y - p2.y));
}

void solve() {
    int x1, x2;
    cin >> x1 >> x2;
    Point A = { x1, x2 };
    cin >> x1 >> x2;
    Point B = { x1, x2 };
    cin >> x1 >> x2;
    Point C = { x1, x2 };

    Point AB = B - A;
    Point BA = A - B;
    Point CB = B - C;
    Point BC = C - B;
    Point AC = C - A;
    Point CA = A - C;

    int S2 = abs(cross(AB, AC));

    dd distAB = dist(A, B);
    dd ansAB = S2 / distAB;

    dd distAC = dist(A, C);
    dd ansAC = S2 / distAC;

    dd distCB = dist(C, B);
    dd ansCB = S2 / distCB;

    vector<dd> v = { ansAB, ansCB, ansAC };
    sort(all(v));

    if (ansAB == v[0]) {
        cout << A.x << " " << A.y << " " << B.x << " " << B.y;
    }
    else if (ansAC == v[0]) {
        cout << A.x << " " << A.y << " " << C.x << " " << C.y;
    }
    else {
        cout << C.x << " " << C.y << " " << B.x << " " << B.y;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    

    int t = 1;
    //cin >> t;

    while (t--) {
        solve();
    }

}