﻿#include <iostream>
#include <cmath>
#include <algorithm>
#define ll long long
using namespace std;

bool isp(long long a) {
    for (int i = 2; i < sqrt(a) + 1; ++i) {
        if (a % i == 0) {
            return false;
        }
    }
    return true;
}

int main()
{
    long long n, m, s;
    cin >> n >> m >> s;

    if (s == n * m) {
        cout << 0;
        return 0;
    }

    if (s % n == 0 || s % m == 0) {
        cout << 1;
        return 0;
    }

    if (n == 2 && m == 2) {
        if (s == 2) {
            cout << 1;
            return 0;
        }
        else {
            cout << 2;
            return 0;
        }
    }

    if (isp(s)) {
        if (s > max(n, m)) {
            s = n * m - s;
            if (isp(s)) {
                cout << 3;
                return 0;
            }
        }
    }

    cout << 2;
    return 0;
}
