def query(dx, dy):
    print(f"? {dx} {dy}", flush=True)
    return input().strip()

def solve():
    diagonal_moves = [(2, 2), (2, -2), (-2, 2), (-2, -2)]
    for dx, dy in diagonal_moves:
        response = query(dx, dy)
        if response == "+":
            break

    exact_moves = [(1, 1), (-1, 1), (1, -1), (-1, -1)]
    for dx, dy in exact_moves:
        for _ in range(3):
            response = query(dx, dy)
            if response == "+":
                break
            elif response == "-":
                continue

    print(f"! {input().strip()}", flush=True)

solve()
