def query(dx, dy):
    print(f"? {dx} {dy}", flush=True)
    return input().strip()

def solve():
    for step in range(1, 8):
        response = query(step, step)
        if response == "+":
            break
        elif response == "-":
            response = query(-step, -step)
            if response == "+":
                break

    for dx, dy in [(1, 1), (-1, 1), (1, -1), (-1, -1)]:
        for step in range(1, 8):
            response = query(dx * step, dy * step)
            if response == "+":
                break
            elif response == "-":
                continue

    print(f"! {input().strip()}", flush=True)

solve()
