#include <iostream>
#include <set>
#include <cmath>

using namespace std;

typedef unsigned long long ull;

int main() {
    int n;
    string s;
    cin >> n >> s;

    ull D = 0;
    for (char c : s) {
        D = D * 10 + (c - '0');
    }

    if (s.back() == '0') {
        cout << "NO" << endl;
        return 0;
    }

    set<ull> bs;
    for (int i = 0; i <= 20; ++i) {
        ull p2 = 1ULL << i;
        if (p2 >= 1e6) break;
        for (int j = 0; j <= 20; ++j) {
            ull p5 = pow(5ULL, j);
            ull b = p2 * p5;
            if (b >= 1e6) break;
            bs.insert(b);
        }
    }

    ull t = 1;
    for (int i = 0; i < n; ++i) {
        t *= 10;
        if (t >= 1e18) break;
    }

    bool found = false;
    for (ull b : bs) {
        if (b >= 1e6) continue;

        ull num;

        if (D > ULLONG_MAX / b) continue;

        num = D * b;

        if (num % t != 0) continue;

        ull a = num / t;
        if (a == 0 || a >= b || a >= 1e6) continue;

        cout << "YES" << endl;
        cout << a << " " << b << endl;
        found = true;
        break;
    }

    if (!found) {
        cout << "NO" << endl;
    }

    return 0;
}
