import math

x0, y0 = map(int, input().split()) 
x1, y1 = map(int, input().split()) 
n = int(input()) 
a = list(map(int, input().split())) 

dx = x1 - x0
dy = y1 - y0
total_distance = math.sqrt(dx**2 + dy**2)

if sum(a) < total_distance or (sum(a) - total_distance) % 2 != 0:
    print("Impossible")
else:
    print("Possible")

    direction_x = dx / total_distance
    direction_y = dy / total_distance

    current_x, current_y = x0, y0
    
    for i in range(n):
        jump = a[i]
        
        if i == n - 1:
            next_x, next_y = x1, y1
        else:
            next_x = current_x + jump * direction_x
            next_y = current_y + jump * direction_y
            
            remaining_dx = x1 - next_x
            remaining_dy = y1 - next_y
            remaining_distance = math.sqrt(remaining_dx**2 + remaining_dy**2)
            
            if remaining_distance > 0:
                direction_x = remaining_dx / remaining_distance
                direction_y = remaining_dy / remaining_distance
        
        print(f"{next_x:.6f} {next_y:.6f}")
        
        current_x, current_y = next_x, next_y
