#include<bits/stdc++.h>

int main() {
	std::cin.tie(nullptr)->sync_with_stdio(false);

	int n, m, c;
	std::cin >> n >> m >> c;
	std::vector<std::pair<int64_t, int64_t>> data(n);
	for (auto &[x, t] : data) std::cin >> x >> t, t *= c;
	auto intersect = [&](std::pair<__int128, __int128> prv, std::pair<__int128, __int128> nxt) -> __int128 {
		__int128 da = (nxt.first - prv.first);
		__int128 db = (prv.second - nxt.second);
		__int128 ret = db / da - 2;
		while (da * ret < db) ++ret;
		return ret;
	};
	std::vector<std::pair<__int128, __int128>> cht;
	std::vector<__int128> inter;
	cht.emplace_back(0, 0);
	std::vector<__int128> dp(n);
	for (int i = 0; i < n; ++i) {
		auto [x, t] = data[i];
		int j = std::upper_bound(inter.begin(), inter.end(), x) - inter.begin();
		dp[i] = cht[j].first * x + x * x + cht[j].second + t;
		std::pair<__int128, __int128> line = {-2 * x, dp[i] + x * x};
		while (inter.size() && inter.back() >= intersect(cht.back(), line)) {
			inter.pop_back();
			cht.pop_back();
		}
		inter.push_back(intersect(cht.back(), line));
		cht.push_back(line);
	}
	__int128 ans = m * m;
	for (int i = 0; i < n; ++i) {
		auto [x, t] = data[i];
		ans = std::min(ans, (m - x) * (m - x) + dp[i]);
	}
	std::cout << std::fixed << std::setprecision(20) << 1.0 * ans / c;
}