def find_a_b(n, decimal_digits):
    decimal_part = int(decimal_digits)
    denominator = 10 ** n

    for b in range(1, 10 ** 6):
        temp_b = b
        while temp_b % 2 == 0:
            temp_b //= 2
        while temp_b % 5 == 0:
            temp_b //= 5

        if temp_b != 1:  
            continue

        a = (decimal_part * b) // denominator
        if (decimal_part * b) % denominator != 0:  
            continue

        if 0 < a < b < 10 ** 6:
            return "YES\n{} {}".format(a, b)

    return "NO"


n = int(input().strip())
decimal_digits = input().strip()

result = find_a_b(n, decimal_digits)
print(result)