def generate_n_minoshki(n):
    if n == 1:
        return [[1]]
    elif n == 2:
        return [[1, 1], [2, 2]]
    elif n == 3:
        return -1
    else:
        grid = [[0] * n for _ in range(n)]
        current_minoshka = 1

        for i in range(n):
            for j in range(n):
                if (i + j) % 2 == 0:
                    grid[i][j] = current_minoshka
                    if current_minoshka < n:
                        current_minoshka += 1

        current_minoshka = 1
        for i in range(n):
            for j in range(n):
                if grid[i][j] == 0:
                    grid[i][j] = current_minoshka
                    if current_minoshka < n:
                        current_minoshka += 1

        return grid


n = int(input().strip())

result = generate_n_minoshki(n)

if result == -1:
    print(-1)
else:
    for row in result:
        print(' '.join(map(str, row)))